/*                  HamRadioAX25 F5EXO@@F6KSU.FPDL.FRA.EU                  */
/*                           mail:f5exo@free.fr                            */
/*                     Web:http://f5exo.free.fr/meteo/                     */
/*                            Erick LINE                                   */

/* Pin 11 LPT (busy) utilise en entree pour recevoir sous forme serie      */
/* Pin 2  LPT (D0) utilisee pour generee l'horloge SCLK                    */
/* Pin 3  LPT (D1) utilisee pour generee CS                                */
/* Pin 4  LPT (D2) utilisee pour envoyer les donnees vers le MAX186.       */
/*                                                                         */
/* Pin 15 LPT (/ERROR)     Bit 3   (comptage impulsions) In                */
/* Pin 13 LPT (/SELECT)    Bit 4   (comptage impulsions) In                */
/* Pin 12 LPT (/PAPER OUT) Bit 5   (comptage impulsions) In                */
/*                                                                         */
/* Pin 17 LPT (Select_IN)  Bit 3   (Alarm 2) Out                           */
/* Pin 16 LPT (INIT)       Bit 2   (Alarm 1) Out                           */
/*                                                                         */
/*                   Calcul Valeur analogique                              */
/*           Val analog = (DATA*(Uref/CAN)-Offset)/Unites                  */
/*           Ou DATA    = valeur digitale lue en sortie CAN                */
/*              Uref    = Tension de reference du CAN  4.096               */
/*              CAD     = CAN 12 bits pour MAX186                          */
/*              Offset  = valeur offset du composant capteur               */
/*              Unites  = facteur mutiplicateur du composant capteur       */

/*-------------------------------------------------------------------------*/


void
Aprs (void)
{
  int c, i;
  float z;
  char tampon[80] = { };
  char locbalise[250] = { };




/* Balise info Message */
/*
  for (i = 0; i < 2; i++)
    {
      if ((strcmp (Conf.Port[i], "none") == 0) || (strlen (Conf.Digi[i]) <= 1)
	  || (strcmp (Conf.Digi[i], "none") == 0))
	{
	  printf ("Balise Info: Port ou chemin non defini dans %s\n",
		  CONF_METEO_CONF_FILE);
	  break;
	}

      strcpy (beacon, "");
      strcat (locbalise, "balise -s");
      strcat (locbalise, Conf.SysOp);
      strcat (locbalise, "-5 -p");
      strcat (locbalise, Conf.Port[i]);
      strcat (locbalise, " -d\"APXexo v ");
      if (strcasecmp (Conf.Digi[i], "local") == 0)
	{
	  strcat (locbalise, "RELAY");
	}
      else
	{
	  strcat (locbalise, Conf.Digi[i]);
	}
      strcat (locbalise, "\" -m\"=");
      if (strlen (Conf.latitude) >= 8 && strlen (Conf.longitude) >= 8)
	{
	  strcat (locbalise, Conf.latitude);
	  strcat (locbalise, "/");
	  strcat (locbalise, Conf.longitude);
	}
      else
	{
	  sprintf (tampon, "%07.2f", aprs.location[0]);
	  strcat (locbalise, tampon);
	  strcat (locbalise, aprs.sgnla);
	  strcat (locbalise, "/");
	  strcpy (tampon, "");
	  sprintf (tampon, "%08.2f", aprs.location[1]);
	  strcat (locbalise, tampon);
	  strcat (locbalise, aprs.sgnlo);
	  strcpy (tampon, "");
	}
      strcat (locbalise, "#Home made AX25 Linux WX Station {V:");
      strcat (locbalise, METEO_VERSION);
      strcat (locbalise, "}");
      strcat (locbalise, "\"");

      cyan ();
      printf ("\n");
      printf ("[Balise Info]\n");
      resetcouleur ();
      blancvif ();
      printf (locbalise);
      printf ("\n");
      resetcouleur ();

      system (locbalise);
      strcpy (locbalise, "");
    }
*/



  /* Balise info WX */

  /* Si pas de champ digi(none) ou pas de port (none) on n'envoi pas de balise */
  for (i = 0; i < 2; i++)
    {
      if ((strcmp (Conf.Port[i], "none") == 0) || (strlen (Conf.Digi[i]) <= 1)
	  || (strcmp (Conf.Digi[i], "none") == 0))
	{
	  printf ("Balise Data: Port ou chemin non defini dans %s\n",
		  CONF_METEO_CONF_FILE);
	  break;
	}

      strcpy (beacon, "");
      strcat (beacon, "balise -s");
      strcat (beacon, Conf.SysOp);
      strcat (beacon, "-5  -p");
      strcat (beacon, Conf.Port[i]);
      strcat (beacon, " -d\"WX v ");
      if (strcasecmp (Conf.Digi[i], "local") == 0)
	{
	  strcat (beacon, "RELAY");
	}
      else
	{
	  strcat (beacon, Conf.Digi[i]);
	}
      strcat (beacon, "\" ");
      strcat (beacon, "-m\"=");
      if (strlen (Conf.latitude) >= 8 && strlen (Conf.longitude) >= 8)
	{
	  strcat (beacon, Conf.latitude);
	  strcat (beacon, "/");
	  strcat (beacon, Conf.longitude);
	}
      else
	{
	  sprintf (tampon, "%07.2f", aprs.location[0]);
	  strcat (beacon, tampon);
	  strcat (beacon, aprs.sgnla);
	  strcat (beacon, "/");
	  strcpy (tampon, "");
	  sprintf (tampon, "%08.2f", aprs.location[1]);
	  strcat (beacon, tampon);
	  strcat (beacon, aprs.sgnlo);
	  strcpy (tampon, "");
	}
      strcat (beacon, "_");
      if (Conf.C > 3)
	{
	  strcpy (tampon, ".../");
	  for (c = 0; c < Conf.C - 3; c++)
	    {
	      /* envoi postion et vitesse du vent */
	      if ((((strcasecmp (capteurs[c].Mesure, "Girouette") == 0)
		    || (strcasecmp (capteurs[c].Mesure, "Wind_dir") == 0))
		   && (capteurs[c].Unites != 0)))
		{
		  z =
		    ((tab[c][0][1][0] * CAD) -
		     capteurs[c].Offset) / capteurs[c].Unites;
		  sprintf (tampon, "%03.0f/", z);
		  break;
		}
	    }
	  strcat (beacon, tampon);
	  strcpy (tampon, "");

	  strcpy (tampon, "...g");
	  for (c = 0; c < Conf.C; c++)
	    {
	      if ((((strcasecmp (capteurs[c].Mesure, "Vent") == 0)
		    || (strcasecmp (capteurs[c].Mesure, "Wind") == 0))
		   && ((capteurs[c].Unites != 0))))
		{
/* le g est pour gust peek wind miles/Heures derniers 5mn  */
/*   strcat (beacon,"");*/
		  z =
		    ((tab[c][0][1][0] * CAD) -
		     capteurs[c].Offset) / capteurs[c].Unites;
		  sprintf (tampon, "%3.3dg", Noeud (z));	/* en Noeuds (miles) */
		  strcat (beacon, tampon);
		  strcpy (tampon, "");
		  z =
		    ((tab[c][0][0][0] * CAD) -
		     capteurs[c].Offset) / capteurs[c].Unites;
		  sprintf (tampon, "%3.3d", Noeud (z));	/* en Noeuds maxi (miles) */
		  break;
		}
	    }
	  strcat (beacon, tampon);
	  strcpy (tampon, "");

	  strcpy (tampon, "t...");
	  for (c = 0; c < Conf.C - 3; c++)
	    {
	      /* incorporation de la temperature en farenheit */
	      if ((((strcasecmp (capteurs[c].Mesure, "Temperature") == 0) ||
		    (strcasecmp (capteurs[c].Unite, "%Celsius") == 0))
		   && ((capteurs[c].Unites != 0))))
		{
		  strcat (beacon, "t");
		  z =
		    ((tab[c][0][1][0] * CAD) -
		     capteurs[c].Offset) / capteurs[c].Unites;
		  sprintf (tampon, "%3.3d", Farenheit (z));	/* en o farenheit */
		  /* sprintf(tampon,"%2.0f",z);  en oC */
		  break;
		}
	    }
	  strcat (beacon, tampon);
	  strcpy (tampon, "");
	}

      /* r rainfall P & p */
      strcpy (tampon, "r...p...P...");
      for (c = Conf.C - 3; c < Conf.C; c++)
	{
	  if ((((strcasecmp (capteurs[c].Mesure, "Pluie") == 0)
		|| (strcasecmp (capteurs[c].Mesure, "Pluviometrie") == 0)
		|| (strcasecmp (capteurs[c].Mesure, "Rain") == 0)
		|| (strcasecmp (capteurs[c].Mesure, "Regen") == 0))
	       && ((capteurs[c].Unites != 0))))
	    {
	      strcpy (tampon, "");
	      /* Last 1h */
	      strcat (beacon, "r");
	      z = ((tab[c][0][2][0] * capteurs[c].Unites));
	      sprintf (tampon, "%3.3d", Inch (z));
	      strcat (beacon, tampon);
	      strcpy (tampon, "");
	      /* Last 24h */
	      strcat (beacon, "p");
	      z = ((tab[c][0][0][0] * capteurs[c].Unites));
	      sprintf (tampon, "%3.3d", Inch (z));
	      strcat (beacon, tampon);
	      strcpy (tampon, "");
	      /* Since 0h:00 */
	      strcat (beacon, "P");
	      z = ((tab[0][2][0][c + 10] * capteurs[c].Unites));
	      sprintf (tampon, "%3.3d", Inch (z));
	      break;
	    }
	}
      strcat (beacon, tampon);
      strcpy (tampon, "");

      if (Conf.C > 3)
	{
	  strcpy (tampon, "h...");
	  for (c = 0; c < Conf.C - 3; c++)
	    {
	      /* incorporation de l'Humidite */
	      if ((((strcasecmp (capteurs[c].Mesure, "Hygrometrie") == 0) ||
		    (strcasecmp (capteurs[c].Unite, "%HR") == 0))
		   && ((capteurs[c].Unites != 0))))
		{
		  strcat (beacon, "h");
		  z =
		    ((tab[c][0][1][0] * CAD) -
		     capteurs[c].Offset) / capteurs[c].Unites;
		  sprintf (tampon, "%02.0f", z);
		  break;
		}
	    }
	  strcat (beacon, tampon);
	  strcpy (tampon, "");

	  strcpy (tampon, "b....");
	  for (c = 0; c < Conf.C - 3; c++)
	    {
	      /* b pression */
	      if (((strcasecmp (capteurs[c].Unite, "hPa") == 0)
		   && (capteurs[c].Unites != 0)))
		{
		  strcat (beacon, "b");
		  z =
		    ((tab[c][0][1][0] * CAD) -
		     capteurs[c].Offset) / capteurs[c].Unites * 10;
		  sprintf (tampon, "%05.0f", z);
		  break;
		}
	    }
	  strcat (beacon, tampon);
	  strcpy (tampon, "");

	}
      strcat (beacon, "xEXO");	/* APRS software & weather unit */
      strcat (beacon, " \"");
      cyan ();
      printf ("\n");
      system (beacon);
/*
      printf ("[Balise No%d  WX APRS envoyee] Port: %s\n", i + 1,
	      Conf.Port[i]);
      resetcouleur ();
      blancvif ();
      printf (beacon);
      resetcouleur ();
      printf ("\n");
*/
      strcpy (tampon, "");
      strcpy (beacon, "");
    }


}
