/*                  HamRadioAX25 F5EXO@@F6KSU.FPDL.FRA.EU                  */
/*                           mail:f5exo@free.fr                            */
/*                     Web:http://f5exo.free.fr/meteo/                     */
/*                            Erick LINE                                   */

/* Pin 11 LPT (busy) utilise en entree pour recevoir sous forme serie      */
/* Pin 2  LPT (D0) utilisee pour generee l'horloge SCLK                    */
/* Pin 3  LPT (D1) utilisee pour generee CS                                */
/* Pin 4  LPT (D2) utilisee pour envoyer les donnees vers le MAX186.       */
/*                                                                         */
/* Pin 15 LPT (/ERROR)     Bit 3   (comptage impulsions) In                */
/* Pin 13 LPT (/SELECT)    Bit 4   (comptage impulsions) In                */
/* Pin 12 LPT (/PAPER OUT) Bit 5   (comptage impulsions) In                */
/*                                                                         */
/* Pin 17 LPT (Select_IN)  Bit 3   (Alarm 2) Out                           */
/* Pin 16 LPT (INIT)       Bit 2   (Alarm 1) Out                           */
/*                                                                         */
/*                   Calcul Valeur analogique                              */
/*           Val analog = (DATA*(Uref/CAN)-Offset)/Unites                  */
/*           Ou DATA    = valeur digitale lue en sortie CAN                */
/*              Uref    = Tension de reference du CAN  4.096               */
/*              CAD     = CAN 12 bits pour MAX186                          */
/*              Offset  = valeur offset du composant capteur               */
/*              Unites  = facteur mutiplicateur du composant capteur       */

/*------------------------------SCANLPT------------------------------------*/

typedef long tabou[6];

static tabou tabo;
static long ouest, sud, i, u;
static double xa, ya, rx, ry;

long
sgn (long sign)
{
  long Result = 0;
  if (sign > 0)
    Result = 1;
  if (sign == 0)
    Result = 0;
  if (sign < 0)
    return -1;
  return Result;
}


void
calcul_coordonnees (long *tabi, double *xx, double *yy, long *t1, long *u1)
{
  long a1 = 65, b1 = 65, c1 = 48, d1 = 48, e1 = 65, f1 = 65, i = -180;
  long xc, yc;
  double y1, x1, x2, y2, x3, y3, TEMP, DUMMY;

  xc = i;
  while (i < 180)
    {
      if (tabi[0] == a1)
	{
	  i = 181;
	  break;
	}
      a1++;
      xc += 20;
      i = xc;
    }
  if (tabi[0] <= 73)
    ouest = -1;
  else
    ouest = 1;
  x1 = xc;
  *t1 = sgn (xc);
  if (*t1 == 0)
    *t1 = 1;
  if (*t1 == -1)
    x1 += 20;
  i = -90;
  yc = i;
  while (i < 90)
    {
      if (tabi[1] == b1)
	{
	  i = 91;
	  break;
	}
      b1++;
      yc += 10;
      i = yc;
    }
  if (tabi[1] <= 74)
    sud = -1;
  else
    sud = 1;
  y1 = yc;
  *u1 = sgn (yc);
  if (*u1 == 0)
    *u1 = 1;
  if (*u1 == -1)
    y1 += 10;
  i = 0;
  xc = i;
  while (i < 20)
    {
      if (tabi[2] == c1)
	{
	  i = 21;
	  break;
	}
      c1++;
      xc += 2;
      i = xc;
    }
  x2 = xc;
  if (*t1 == -1)
    x2 = 18 - x2;
  i = 0;
  yc = i;
  while (i < 10)
    {
      if (tabi[3] == d1)
	{
	  i = 11;
	  break;
	}
      d1++;
      yc++;
      i = yc;
    }
  y2 = yc;
  if (*u1 == -1)
    y2 = 9 - y2;
  i = 0;
  xc = i;
  while (i < 24)
    {
      if (tabi[4] == e1)
	{
	  i = 25;
	  break;
	}
      e1++;
      xc++;
      i = xc;
    }
  x3 = xc;
  if (*t1 == 1)
    x3 /= 12;
  if (*t1 == -1)
    x3 = (24 - x3) / 12;
  i = 0;
  yc = i;
  while (i < 24)
    {
      if (tabi[5] == f1)
	{
	  i = 25;
	  break;
	}
      f1++;
      yc++;
      i = yc;
    }
  y3 = yc;
  if (*u1 == 1)
    y3 /= 24;
  if (*u1 == -1)
    y3 = (24 - y3) / 24;
  rx = x1 + x2 + x3;
  ry = y1 + y2 + y3;
  modf (rx, &TEMP);
  rx = fabs (TEMP + modf (rx, &DUMMY) * 60 / 100) * 100;
  aprs.location[1] = rx;
  modf (ry, &TEMP);
  ry = fabs (TEMP + modf (ry, &DUMMY) * 60 / 100) * 100;
  aprs.location[0] = ry;
  if (*t1 == -1)
    strcpy (aprs.sgnlo, ("W"));
  else
    strcpy (aprs.sgnlo, ("E"));
  if (*u1 == -1)
    strcpy (aprs.sgnla, ("S"));
  else
    strcpy (aprs.sgnla, ("N"));
}

/*void position(char locat[6])*/
double
position (char *locat)
{
  for (i = 1; i <= 6; i++)
    {
      tabo[i - 1] = locat[i - 1];
    }
  calcul_coordonnees (tabo, &xa, &ya, &t, &u);
  return 1;
}
