/*                  HamRadioAX25 F5EXO@@F6KSU.FPDL.FRA.EU                  */
/*                           mail:f5exo@free.fr                            */
/*                     Web:http://f5exo.free.fr/meteo/                     */
/*                            Erick LINE                                   */

/* Pin 11 LPT (busy) utilise en entree pour recevoir sous forme serie      */
/* Pin 2  LPT (D0) utilisee pour generee l'horloge SCLK                    */
/* Pin 3  LPT (D1) utilisee pour generee CS                                */
/* Pin 4  LPT (D2) utilisee pour envoyer les donnees vers le MAX186.       */
/*                                                                         */
/* Pin 15 LPT (/ERROR)     Bit 3   (comptage impulsions) In                */
/* Pin 13 LPT (/SELECT)    Bit 4   (comptage impulsions) In                */
/* Pin 12 LPT (/PAPER OUT) Bit 5   (comptage impulsions) In                */
/*                                                                         */
/* Pin 17 LPT (Select_IN)  Bit 3   (Alarm 2) Out                           */
/* Pin 16 LPT (INIT)       Bit 2   (Alarm 1) Out                           */
/*                                                                         */
/*                   Calcul Valeur analogique                              */
/*           Val analog = (DATA*(Uref/CAN)-Offset)/Unites                  */
/*           Ou DATA    = valeur digitale lue en sortie CAN                */
/*              Uref    = Tension de reference du CAN  4.096               */
/*              CAD     = CAN 12 bits pour MAX186                          */
/*              Offset  = valeur offset du composant capteur               */
/*              Unites  = facteur mutiplicateur du composant capteur       */

/*------------------------------SCANLPT------------------------------------*/

/*
 *	          Simple PMS service for Linux AX.25 kernel
*/
/*      Moved #defines out to config.h file - Terry Dawson VK2KTJ          */
/*              Added Rose support - Terry Dawson VK2KTJ                   */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <ctype.h>
#include <unistd.h>
#include <pwd.h>
#include <time.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <signal.h>
#include <math.h>
#include <getopt.h>
#include "../include/ax25.h"
#include "../include/config.h"
#include "../include/axcalluser.h"
#include "../include/axconfig.h"
#include "../include/meteo.h"
#include "../include/lang.h"
#include "../aprs/loc.c"
#include "../fichiers/txt_upd.c"
#include "../meteoconf.c"
#include "../daemon.c"
#include "../cmd.c"
extern void LogoutUser (void);

extern void UpdateUser (void);

static char Caller[10];

static int IsBBS = 0;

static long CallerPos = -1L;


static char InputBuffer[256];

static int InputPtr = 0;

static int Socket;

static char LineBuffer[256];

static char my_callsign[20];


static char Cmd[48] = { "?,0,1,2,3,4,5,6,7,8,9,A,B,C,D,I,L,H,M,P,Q,T,U,V" };


static char delimiter = '\n';

char *tampon;

void
Menu (void)
#ifdef French
{
  
printf ("Rsum des commandes: %c", delimiter);
  
printf ("[Analogique, Config, Digital, Historique des voies,%c",
	   delimiter);
  
printf ("(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10) Details par voie.%c",
	   delimiter);
  
printf ("Bye, Mail, Info, Port, Quit, Log, Users, Talk, Viewalarm, ?]%c",
	   delimiter);

}
#endif

#ifdef English
{
  
printf ("Commands summary: %c", delimiter);
  
printf ("[Analogic, Config, Digital, Channels Historic,%c", delimiter);
  
printf ("(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10) Channel detail.%c", delimiter);
  
printf ("Bye, Mail, Info, Port, Quit, Log, Users, Talk, Viewalarm,?]%c",
	   delimiter);

}
#endif

#ifdef Deutsch
{
  
printf ("Commands summary: %c", delimiter);
  
printf ("[Analogic, Config, Digital, Channels Historic,%c", delimiter);
  
printf ("(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10) Messwerte eine Kanals...%c",
	   delimiter);
  
printf ("Bye, Mail, Info, Port, Quit, Log, Users, Talk, Viewalarm,?]%c",
	   delimiter);

}
#endif






char *
ReadLine (void)
{
  
char *t;
  
int size;
  

while ((t = memchr (InputBuffer, delimiter, InputPtr)) == NULL)

    {
      
fflush (stdout);
      
size = read (Socket, InputBuffer + InputPtr, 256 - InputPtr);
      
if (size == -1 || size == 0)
	
return NULL;
      
InputPtr += size;
      
if (size >= 256)

	{
	  
InputBuffer[255] = delimiter;
	  
break;
	
}
    
}
  

memcpy (LineBuffer, InputBuffer, t - InputBuffer);
  
LineBuffer[t - InputBuffer] = 0;
  
memcpy (InputBuffer, t + 1, InputPtr - (t - InputBuffer) - 1);
  
InputPtr -= (t - InputBuffer) + 1;

  /* Affichage caracteres en entree (test) */
/*	printf("%c\"%s\"%c",delimiter,LineBuffer,delimiter);*/
  return LineBuffer;

}


int
ParseArgs (char *argv[], char *cmd)
{
  
int ct = 0;
  
while (ct < 31)

    {
      
while (*cmd && isspace (*cmd))
	
cmd++;
      
if (*cmd == 0)

	{
	  
argv[ct] = NULL;
	  
return (ct);
	
}
      
argv[ct++] = cmd;
      
while (*cmd && !isspace (*cmd))

	{
	  
cmd++;
	
}
      
if (*cmd)
	
*cmd++ = 0;
    
}
  
argv[ct] = NULL;
  
return (ct);

}




static int
ReadPair (char *p)
{
  
if (!isdigit (*p) && !isdigit (p[1]))
    
return -1;
  
return ((*p - '0') * 10 + p[1] - '0');

}


static char DayName[] = "Sun\0Mon\0Tue\0Wed\0Thu\0Fri\0Sat";

static char MonName[] =
  "Jan\0Feb\0Mar\0Apr\0May\0Jun\0Jul\0Aug\0Sep\0Oct\0Nov\0Dec";


void
AddReceivedLine (FILE * f, char *in, char *addr, char *date)
{
  
char *adrp;
  
char *adbuf = addr;
  
char *comment = NULL;
  
char *id = NULL;
  
int y, m, d, hr, min;
  
in += 2;			/* skip R: */

  /* We now have a data - occasionally without the trailing 'Z' or 'z'! */
  if (strlen (in) >= 11)

    {
      
struct tm t;
      
struct tm *tp;
      
long tv;
      
y = ReadPair (in);
      
in += 2;
      
m = ReadPair (in);
      
in += 2;
      
d = ReadPair (in);
      
in += 2;
      
if (*in++ != '/')
	
d = -1;
      
hr = ReadPair (in);
      
min = ReadPair (in);
      
if (y < 0 || m < 1 || m > 12 || d < 1 || d > 31 || hr < 0 || hr > 23
	   || min < 0 || min > 59)

	{
	  
*addr = 0;
	  
fprintf (f, "X-Unparseable-R-Line: %s\n", in);
	  
return;
	
}
      
t.tm_year = y;
      
t.tm_mday = d;
      
t.tm_mon = m - 1;
      
t.tm_hour = hr;
      
t.tm_min = min;
      
t.tm_sec = 0;
      
t.tm_isdst = 0;
      
if ((tv = mktime (&t)) == -1)

	{
	  
strcpy (date, "[Unparseable]");
	
}

      else

	{
	  
tv -= timezone;
	  
tp = gmtime (&tv);
	  
sprintf (date, "%s, %d %s %2d:%2d:00 GMT",
		    
&DayName[tp->tm_wday * 4], 
tp->tm_mday,
		    
&MonName[tp->tm_mon * 4], 
tp->tm_hour, 
tp->tm_min 
);
	
}
    

}

  else

    {
      
fprintf (f, "X-Short-R-Line: %s\n", in);
      
*addr = 0;
    
}

  /* Now look for '@' */
  while (*in && isspace (*in))
    
in++;

  /* Check for the funny NNA idents */
  
if (isdigit (*in))

    {
      
id = in;
      
while (*in && isdigit (*in))
	
in++;
      
if (*in && *in != '@')
	
*in++ = 0;
    
}

  /* Now look for addesses. This might be in the ID@BBS form used by NNA or the
     @:bbs used by the rest */
  
adrp = strchr (in, '@');
  
if (adrp == NULL)

    {
      
*addr = 0;
      
return;
    
}
  

adrp++;
  
if (*adrp == ':')
    
adrp++;
  

while (*adrp && !isspace (*adrp))
    
*addr++ = *adrp++;
  
*addr = 0;
  
comment = strchr (adrp, '[');
  
if (comment != NULL)

    {
      
adrp = strchr (comment, ']');
      
if (adrp != NULL)
	
*adrp = 0;
    
}

  /* Look for the normal #: lines. Don't look for BID: or $: lines - few use them and everyone puts
     them in differently */
  
if (id == NULL && adrp != NULL)

    {
      
id = strchr (adrp, '#');
      
if (id != NULL)

	{
	  
adrp = id;
	  
while (*adrp && !isspace (*adrp))
	    
adrp++;
	  
if (*adrp)
	    
*adrp = 0;
	
}
    
}

  /* Now format up the received stuff */
  fprintf (f, "Received: by %s (%s)\n\tid %s; %s\n", adbuf,
	   comment ? comment + 1 : "no info", id ? id : "no-ident", date);

}



void
Talk (int argc, char *argv[])
{
  
system (MY_TALK);

}



void
PostMessage (int argc, char *argv[])
{
  
char *subj;
  
char *msg, *mptr;
  
int msgsize;
  
int mused;
  
char *p;
  
char *to = NULL;
  
char *distrib = NULL;
  
char *from = NULL;
  
char *bid = NULL;
  
int len;
  
char abuf[64];		/* Will hold last R: line data for Reply-To: line */
  
char adate[64];
  
int ct = 1;
  
long tv;
  
struct tm *tp;
  
char *to_username = NULL;
  

*abuf = 0;
  

if (argc == 1)

    {
      
if (!IsBBS)
	
printf ("Destinataire ? (Syntaxe: Mail indicatif)%c", delimiter);

      else
	
printf ("NO%c", delimiter);
      
return;
    
}
  
if (argc != 2 && !IsBBS)

    {
      
printf ("Information supplementaire non autorisee.%c", delimiter);
      
return;
    
}
  
to = strdup (argv[ct++]);
  
if (argv[ct] && strcmp (argv[ct], "@") == 0)

    {
      
ct++;
      
if (argv[ct] == NULL)

	{
	  
free (to);
	  
if (!IsBBS)
	    
printf ("Erreur de syntaxe - Ne sera pas traitee.%c", delimiter);

	  else
	    
printf ("NO%c", delimiter);
	
}
      
distrib = strdup (argv[ct++]);
    
}
  
if (argv[ct] && strcmp (argv[ct], "<") == 0)

    {
      
ct++;
      
if (argv[ct] == NULL)

	{
	  
if (!IsBBS)
	    
printf ("Erreur de syntaxe - missing from.%c", delimiter);

	  else
	    
printf ("NO%c", delimiter);
	  
free (to);
	  
if (distrib)
	    
free (distrib);
	
}
      
from = strdup (argv[ct++]);
    
}
  
if (argv[ct] && *argv[ct] == '$')
    
bid = strdup (argv[ct++]);
  

to_username = getusername (axcalluserid (to));

  /*
     if (!to_username)
     {
     free(to);
     free(bid);
     if (!IsBBS)
     printf("Non autoris..%c",delimiter);
     else
     printf("NO%c",delimiter);
     return;
     }
   */
  time (&tv);
  
tp = gmtime (&tv);
  
sprintf (adate, "%s, %d %s %2d:%2d:00 GMT", 
&DayName[tp->tm_wday * 4],
	    
tp->tm_mday, 
&MonName[tp->tm_mon * 4], 
tp->tm_hour,
	    
tp->tm_min);

  /*
   *      Ok it parses now do the message
   */
  
if (!IsBBS)
    {
      
printf ("Entrez le sujet de votre message.%c", delimiter);
      
printf ("Enter subject.%c", delimiter);
    }

  else
    
printf ("OK%c", delimiter);
  
subj = ReadLine ();
  
if (subj == NULL)

    {
      
LogoutUser ();
      
exit (1);
    
}
  
subj = strdup (subj);
  
if (!IsBBS)
    
printf ("Entrez votre message. Validez par '/EX'.%c", delimiter);
  
msg = malloc (1024);
  
msgsize = 1024;
  
mptr = msg;
  
mused = 0;
  
while (1)

    {
      
p = ReadLine ();
      
if (p == NULL)

	{
	  
LogoutUser ();
	  
exit (1);
	
}
      
if (strcasecmp (p, "/EX") == 0 || strcasecmp (p, "\032") == 0)

	{
	  
*mptr++ = 0;
	  
break;
	
}
      
len = strlen (p);
      
if (len + mused >= msgsize - 3)

	{
	  
msgsize += 1024;
	  
msg = realloc (msg, msgsize);
	  
mptr = &msg[mused];
	
}
      
if (strncmp (mptr, "From", 4) == 0)

	{
	  
mused++;
	  
*mptr++ = '>';
	
}
      
strcpy (mptr, p);
      
mptr += len;
      
mused += len + 1;
      
*mptr++ = delimiter;
    
}

  /* We can now deliver it */
  to_username = getusername (axcalluserid (to));
  
if (to_username)

    {
      
char deliver_command[80];
      
FILE * mb;
      
sprintf (deliver_command, MAIL_DELIVERY_AGENT, to_username);
      
mb = popen (deliver_command, "w");
      
if (mb == NULL)

	{
	  
printf ("Unable to deliver.%c", delimiter);
	  
return;
	
}

      /*
       *      Now convert to approximate RFC822 format
       */
#if defined(MY_GATEWAY)
      fprintf (mb, "From %s@%s %s", from ? from : Caller, MY_GATEWAY,
	       ctime (&tv));

#else /* 
 */
      fprintf (mb, "From %s %s", from ? from : Caller, ctime (&tv));

#endif /* 
 */
      fprintf (mb, "To: %s\n", Lowercase (to));

#if defined(MY_GATEWAY)
      fprintf (mb, "From: %s@%s\n", from ? from : Caller, MY_GATEWAY);

#else /* 
 */
      fprintf (mb, "From: %s\n", from ? from : Caller);

#endif /* 
 */
      if (bid)
	
fprintf (mb, "Message-ID: <%s>\n", bid);
      
fprintf (mb, "Subject: %s\n", subj);

      /*
       *      Now walk the message headers
       *      generating RFC822 received lines
       *      (and figuring the return address)
       */
      p = msg;
      
while (p && *p)

	{
	  
mptr = strchr (p, delimiter);
	  
if (strncmp (p, "R:", 2) == 0)

	    {
	      
if (mptr != NULL)
		
*mptr++ = 0;
	      
AddReceivedLine (mb, p, abuf, adate);
	      
p = mptr;
	      
continue;
	    
}

	  /* Blank line is a seperator */
	  if (*p == delimiter)
	    
break;
	  
if (!IsBBS)
	    
break;
	  
if (mptr != NULL)

	    {
	      
*mptr++ = 0;
	    
}
	  
fprintf (mb, "X-%s\n", p);
	  
p = mptr;
	
}
      
if (*abuf)

	{
	  
fprintf (mb, "Reply-To: <%s@%s>\n", from ? from : Caller, abuf);
	  
fprintf (mb, "Return-Path: <%s@%s>\n", from ? from : Caller, abuf);
	
}
      
fprintf (mb, "Date: %s\n", adate);

      /* Now we are onto the data part (if one exists) */
      fprintf (mb, "\n");	/* End envelope */

      /* Now dump the data part of the message */
      while (p && *p)

	{
	  
mptr = strchr (p, delimiter);
	  
if (mptr != NULL)
	    
*mptr++ = 0;
	  
fprintf (mb, "%s\n", p);
	  
p = mptr;
	
}
      
fclose (mb);
    
}

  /*
   *      Else its a news article
   */
/*	else
	{
		;
	}*/
  free (to);
  
free (subj);
  
if (bid)
    
free (bid);
  
free (msg);
  
if (from)
    
free (from);
  
if (distrib)
    
free (distrib);

}





typedef struct
{
  
char Call[12];
   
int pid;
   
int flags;

#define USER_IS_BBS 1
  long login;
   
long cmdtime;
  

unsigned short ul_type;

/*	
	unsigned short 	dl_type;	
*/
/*	
	char 		ul_name[32];
	char		dl_name[32];
	char		ul_port[32];
	char		dl_port[32];
*/
}
User;


void
LoginUser (void)
{
  
FILE * f = fopen (DATA_METEO_LOGIN_FILE, "r+");
  
User u;
  
long pos = 0L;
  
long free = -1L;
  

if (f == NULL)

    {
      
perror (DATA_METEO_LOGIN_FILE);
      
return;
    
}
  

if (flock (fileno (f), LOCK_EX) == -1)

    {
      
perror ("flock");
      
return;
    
}
  

while (fread (&u, sizeof (u), 1, f) == 1)

    {
      
if (u.pid == -1 
 ||(kill (u.pid, 0) == -1 && errno == ESRCH))
	{
	  free = pos;

/*		if(kill(u.pid,0)==0 || errno!=ESRCH)
			free=pos;
*/ 
break;
	}
      else if (strcmp (Caller, u.Call) == 0)

	{
	  
printf ("Vous etes deja connecte. You are already connected.%c",
		   delimiter);
	  
fclose (f);
	  exit (1);
	}
      

pos += sizeof (u);
    
}
  
if (free != -1L)

    {
      
if (fseek (f, free, 0L) == -1)

	{
	  
perror ("fseek");
	  
exit (1);
	
}
    
}
  

strcpy (u.Call, Caller);
  
u.pid = getpid ();
  
u.flags = 0;
  
if (IsBBS)
    
u.flags |= USER_IS_BBS;
  
time (&u.login);
  
time (&u.cmdtime);
  
fflush (f);
  
CallerPos = ftell (f);
  
fwrite (&u, sizeof (u), 1, f);
  
fflush (f);
  
flock (fileno (f), LOCK_UN);
  
fclose (f);

}


void
lastlog (void)
{
  
struct nodelastlog ll;
  
int last;
  
int count = 0;
  
int hit = 0;
  
int UserId = 0;
  
char tty[LAST_DATA_SIZE];
  
char hostname[LAST_DATA_SIZE];
  
char usercall[10];
  
char *cp;
  
User u;
  
strcpy (usercall, Caller);
  
Lowercase (usercall);

/*  printf("Log des utilisateurs:%s\n",usercall);*/
/*  printf("Socket : %d\n",Socket);*/
  cp = strchr (usercall, '-');
  
if (cp)
    *cp = '\0';
  
strcpy (tty, "");
  

switch (u.ul_type)
    {

/*  
  case AF_FLEXNET: strcpy(hostname, "FlexNet");
    break;

  case AF_AX25: strcpy(hostname, "[");
    strcat(hostname, "AX25");
    strcat(hostname, "] ");
    strcat(hostname, User.call);
    if (strlen(User.ul_name)>0) {
      strcat(hostname, " via ");
      strcat(hostname, User.ul_name);
    }
    break;
  case AF_NETROM: strcpy(hostname, "<");
    strcat(hostname, User.ul_port);
    strcat(hostname, "> ");
    strcat(hostname, User.call);
    if (strlen(User.ul_name)>0) {
      strcat(hostname, "@");
      strcat(hostname, User.ul_name);
    }
    break;
#ifdef HAVE_ROSE
  case AF_ROSE:   strcpy(hostname, User.call);
    if (strlen(User.ul_name)>0) {
      strcat(hostname, " at ");
      strcat(hostname, User.ul_name);
    }
    break;
#endif    
  case AF_INET:   strcpy(hostname, User.ul_name);
    break;
  case AF_UNSPEC: strcpy(hostname, User.call);
    strcat(hostname, " on local");
    break;
*/
    default:
      strcpy (hostname, "");
      
break;
    
}
  

if ((last = open (METEO_LOG_FILE, O_RDWR, 0)) >= 0)
    {
      
lseek (last, (off_t) UserId * sizeof (ll), L_SET);
      
while (read (last, (char *) &ll, sizeof (ll)) == sizeof (ll)
	      && ll.ll_time != 0)
	{
	  
if (strcmp (ll.ll_user, usercall) == 0)
	    {
	      
tb = localtime (&ll.ll_time);
	      
printf ("Last login: %3.3s %d %4.4s %d %2.2d:%2.2d %c" 
,
		       Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
		       
tb->tm_year + 1900, tb->tm_hour, tb->tm_min,
		       delimiter);

/*		      
        if (*ll.ll_host != '\0') printf("\n***              From: %.*s\n",(int)sizeof(ll.ll_host), ll.ll_host);
        else                     printf(" %.*s\n",(int)sizeof(ll.ll_line), ll.ll_line);
*/
	      count = ll.ll_count;
	      
hit++;
	      
break;
	    
}
	  else
	    UserId++;
	
}
      
lseek (last, (off_t) UserId * sizeof (ll), L_SET);
    
}
  
memset ((char *) &ll, 0, sizeof (ll));
  
if (hit == 0)
#ifdef French
    {
      
printf ("*** Bienvenue %s c'est votre premire connexion sur METEO.%c",
	       usercall, delimiter);
      
printf ("Faire ? pour obtenir l'aide.%c", delimiter);
      
count = 0;
    
}
#endif

#ifdef English
  {
    
printf ("*** Welcom %s it's your first connexion to METEO.%c",
	     usercall, delimiter);
    
printf ("? to get help.%c", delimiter);
    
count = 0;
  
}
#endif

#ifdef Deutsch
  {
    
printf ("*** Welcomen %s it's your first connexion to METEO.%c",
	     usercall, delimiter);
    
printf ("? to get help.%c", delimiter);
    
count = 0;
  
}
#endif



  
ll.ll_count = count + 1;
  
(void) time (&ll.ll_time);
  
strncpy (ll.ll_line, tty, sizeof (ll.ll_line));
  
strncpy (ll.ll_user, usercall, sizeof (ll.ll_user));
  
if (hostname)
    strncpy (ll.ll_host, hostname, sizeof (ll.ll_host));
  
write (last, (char *) &ll, sizeof (ll));
  
close (last);

}


void
list_lastlog (char *match)
{
  
int last;
  
int re, cnx = 0;
  
struct nodelastlog ll;
  
int Entries = 0;
  

*call = '\0';
  

if ((last = open (METEO_LOG_FILE, O_RDONLY, 0)) >= 0)
    {
      
lseek (last, (off_t) Entries * sizeof (ll), L_SET);
      
while (read (last, (char *) &ll, sizeof (ll)) == sizeof (ll)
	      && ll.ll_time != 0)
	{
	  
if (*match != '\0' && strcasecmp (match, ll.ll_user) != 0)
	    continue;
	  
if (Entries == 0)
	    {
	      
printf ("Indicatif  Date                     Nb Cnx%c",
		       delimiter);
	      
printf ("---------- -------------------  ------------ %c",
		       delimiter);
	    
}
	  
printf ("%-10s ", ll.ll_user);
	  
tb = localtime (&ll.ll_time);

/*      printf("%3.3s %1.2d %1.4s %1.2d %2.2d:%2.2d",Jours[tb->tm_wday],tb->tm_mday,Mois[tb->tm_mon],
                      tb->tm_year+1900,tb->tm_hour,tb->tm_min);
*/
	  printf ("%1.2d %4.4s %2.2d %2.2d:%2.2d", tb->tm_mday,
		  Mois[tb->tm_mon], 
tb->tm_year + 1900, tb->tm_hour,
		  tb->tm_min);
	  
printf ("%13d%c", ll.ll_count, delimiter);
	  
cnx = cnx + ll.ll_count;

/*      
      if (*ll.ll_host != '\0') printf("  %.*s\n",(int)sizeof(ll.ll_host), ll.ll_host);
      else printf("on %.*s\n",(int)sizeof(ll.ll_line), ll.ll_line);
*/
	  Entries++;
	  
if (Entries % 15 == 0)
	    {

/*       printf("%c",delimiter);
*/
	      printf ("(A)rret - (CR)ontinue");	/* Pagination a 20 lignes */
	      
fflush (stdout);
	      
re = getchar ();
	      
if ((re == 97) || (re == 65))
		{
		  break;
		}
	    
}
	

}
      
lseek (last, (off_t) Entries * sizeof (ll), L_SET);
      
close (last);
    
}
  

if (*match == '\0' && Entries == 0)
    printf ("Aucun utilisateurs ne figurent dans la base.%c", delimiter);
  
if (*match != '\0' && Entries == 0)
    printf ("Ne s'est jamais connect sur ce systme.%c", delimiter);
  
printf ("---------- -------------------  ------------ %c", delimiter);
  
printf ("Total  %6d utilisateurs %15d Cnx%c", Entries, cnx, delimiter);
  
printf ("%c", delimiter);

}


/* Lecture fichier messages */
  void
sysOp (void)
{
  
char *cp;
  
int comp;
  
cp = strchr (Caller, '-');
  
Lowercase (Conf.SysOp);
  
comp = strcmp (Caller, Conf.SysOp);	/* test Utilisateur si sysop */
  
if (comp == 0)
    {
      
catfile (MSG_METEO_DATA_FILE);
    
}

  else
    {
      
printf ("Cmd inconnue, Unknown command !%c", delimiter);
      
Menu ();
    
}

}





void
LogoutUser (void)
{
  
User u;
  
FILE * f = fopen (DATA_METEO_LOGIN_FILE, "r+");
  
if (f == NULL)

    {
      
perror (DATA_METEO_LOGIN_FILE);
      
exit (1);
    
}
  
if (fseek (f, CallerPos, 0) == -1)

    {
      
perror ("fseek");
      
exit (1);
    
}
  
u.pid = -1;
  
fwrite (&u, sizeof (User), 1, f);
  
fclose (f);

}


void
UpdateUser (void)
{
  
User u;
  
FILE * f = fopen (DATA_METEO_LOGIN_FILE, "r+");
  
if (f == NULL)

    {
      
perror (DATA_METEO_LOGIN_FILE);
      
exit (1);
    
}
  
if (fseek (f, CallerPos, 0) == -1)

    {
      
perror ("fseek");
      
exit (1);
    
}
  
if (fread (&u, sizeof (User), 1, f) != 1)

    {
      
perror ("fread");
      
exit (1);
    
}
  
time (&u.cmdtime);
  
if (fseek (f, CallerPos, 0) == -1)

    {
      
perror ("fseek");
      
exit (1);
    
}
  
fwrite (&u, sizeof (User), 1, f);
  
fclose (f);

}


void
UserList (void)
{
  
User u;
  
char *tp;
  
long l;
  
FILE * f = fopen (DATA_METEO_LOGIN_FILE, "r");
  
if (f == NULL)

    {
      
perror (DATA_METEO_LOGIN_FILE);
      
return;
    
}
  
printf ("User          Login         Idle%c", delimiter);
  
while (fread (&u, sizeof (User), 1, f) == 1)

    {
      
if (u.pid == -1 
 ||(kill (u.pid, 0) == -1 && errno == ESRCH))
	continue;
      
printf ("%-14s", u.Call);
      
tp = ctime (&u.login);
      
tp += 4;
      
tp[12] = 0;
      
printf ("%s  ", tp);
      
time (&l);
      
l -= u.cmdtime;
      
if (l < 60)
	
printf ("%-2lds  ", l);

      else

	{
	  
l /= 60;
	  
if (l < 60)
	    
printf ("%-2ldm  ", l);

	  else

	    {
	      
l /= 60;
	      
if (l < 24)
		
printf ("%-2ldh  ", l);

	      else
		
printf ("%-2ldd  ", l / 24);
	    
}
	
}
      
if (u.flags & USER_IS_BBS)
	
printf ("[Mail forward]");
      
printf ("%c", delimiter);
    
}
  
printf ("%c", delimiter);
  
fclose (f);

}


void
Show_Ports (void)
{
  
char *name = NULL;
  
printf ("PORT         BAUD DESCRIPTION%c", delimiter);
  
printf ("-----------------------------%c", delimiter);
  
for (name = ax25_config_get_next (NULL); name;
	
name = ax25_config_get_next (name))
    {
      
printf ("%-9s: %6d %s%c", 
name, 
ax25_config_get_baud (name),
	       
ax25_config_get_desc (name), delimiter);
    
}

}


#define SECONDS_PER_DAY (3600L*24L)
  
void
Show_Heard (void)
{
  
int d, h, m, s;
  
time_t t;
  
FILE * f;
  
char iface[20];
  
char *ifname;
  
char callsign[16];
  
char line[256];
  

f = fopen (PROC_AX25_ROUTE_FILE, "r");
  
if (f == NULL)
    {
      
fprintf (stderr, "meteo: AX25 is not available%c", delimiter);
      
return;
    
}
  
fgets (line, 256, f);	/* Read and discard header line */
  
while (!feof (f))
    {
      
if (fgets (line, 256, f) <= 0)
	
break;
      
sscanf (line, "%s %s %d %ld", callsign, iface, &d, &t);
      
ifname = ax25_config_get_name (iface);
      
t = difftime (time (NULL), t);
      
if (ifname)
	{
	  
printf ("%9s: %-6s ", callsign, ifname);
	  
if (t > SECONDS_PER_DAY)
	    {
	      
d = t / SECONDS_PER_DAY;
	      
t = t % SECONDS_PER_DAY;
	      
if (d > 1)
		
printf ("%d days, ", d);

	      else
		
printf ("1 day, ");
	    
}
	  
h = t / 3600L;
	  
t = t % 3600L;
	  
m = t / 60L;
	  
s = t % 60L;
	  
printf ("%d:%02d:%02d%c", h, m, s, delimiter);
	
}
    
}
  
fclose (f);

}


/*-------------------------------MAIN---------------------------------------*/
int
main (int argc, char *argv[])
{
  
static char iobuf[1500];
  
int paclen = 192;
  

struct full_sockaddr_ax25 sax;
  
int len = sizeof (sax);
  

char *my_argv[32];
  
int my_argc;
  
int s;
  

char *p = (char *) &sax.fsa_ax25.sax25_call;
  

int ct = 0;
  
int stype = ' ';
  

Caller[0] = '\0';
  
while ((s = getopt (argc, argv, "banrip:u:o:v")) != -1)
    {
      
switch (s)
	{
	
case 'b':
	  
IsBBS = 1;
	  
break;
	
case 'a':
	
case 'n':
	
case 'r':
	  
delimiter = '\r';
	
case 'i':
	  
stype = s;
	  
break;
	
case 'p':
	  
paclen = atoi (optarg);
	  
if (paclen > 1500)
	    {
	      
fprintf (stderr, "axmeteo: max paclen is 1500\n");
	      
paclen = 1500;
	    
}
	  
break;
	
case 'o':
	  
strcpy (my_callsign, optarg);
	  
break;
	
case 'u':
	  
strcpy (Caller, optarg);
	  
break;
	
case 'v':
	  
printf ("axmeteo: %s\n", METEO_VERSION);
	  
return 0;
	
case ':':
	  
fprintf (stderr, "axmeteo: options -p, -o and -u need argument\n");
	  
return 1;
	
case '?':
	  
fprintf (stderr,
		    "Usage: axmeteo [-a|-h|-i|-n|-r] -p paclen -u user -o owner -v\n");
	  
return 1;
	
}
    
}

  /* This is a useful trick to avoid stdio generating >mtu sized writes.
     Stdio doesn't really understand sock_seqpacket.... */
  setbuffer (stdout, iobuf, paclen);
  

if (strlen (Caller) == 0)
    {
      
if (stype == 'a' || stype == 'n')
	{
	  
if (getpeername (0, (struct sockaddr *) &sax, &len) == -1)

	    {
	      
perror ("getpeername");
	      
fprintf (stderr,
			"axmeteo: connection is not AX.25, NETROM or ROSE\n");
	      
return 1;
	    
}
	  

while (ct < 7)

	    {
	      
Caller[ct] = (*p >> 1) & 0x7F;
	      
ct++;
	      
p++;
	    
}
	  
Caller[6] = ' ';
	
}
      else
	{
	  
fprintf (stderr,
		    "axmeteo: arg -u required if not AX.25 or NetRom\n");
	  
return 1;
	
}
    
}
  

if (strlen (my_callsign) == 0)
    {
      
fprintf (stderr,
		"axmeteo: arg -o required: callsign of meteo owner.\n");
      
return 1;
    
}
  

if (strchr (Caller, ' ') != NULL)
    
*strchr (Caller, ' ') = 0;

/*	
#ifdef notdef
	if(strncmp(Caller,"GB",2)==0)  
		IsBBS=1;
#endif

*/
  if (ax25_config_load_ports () == 0)
    {
      
fprintf (stderr, "axmeteo: no AX.25 ports configured\n");
      
return 1;
    
}
  

LoginUser ();
  
Get_Conf ();			/* Consultation du fichier de configuration    */
  
position (Conf.locator);
  printf ("[AXMETEO-EXO %s-HM$] PID:%d%c", METEO_VERSION, getpid (),
	  delimiter);
  
printf ("Hello %s ! Welcome in %s%c", Caller, Conf.qth, delimiter);
  
fflush (stdout);		/* Some people insist on getting this alone */
  
catfile (CONF_METEO_MOTD_FILE);	/* Affichage mot dujour meteo.motd  */
  
lastlog ();			/* Recup des stats de cnx si call connu     */
  
Open_Data ();		/* Recup des donnees dans le fichier meteo.dat      */
  
Print_Compteur ();		/* Affichage du compteur d'aquisition       */
  

Print_Analog ();
  printf (tendance = Tendance ());
  printf ("%c", delimiter);
  while (1)

    {
      
if (IsBBS)
	
printf (" >%c", delimiter);

      else
	
printf ("%s METEO %s >%c", my_callsign, Cmd, delimiter);
      
p = ReadLine ();
      
if (p == NULL)

	{
	  
LogoutUser ();
	  
return 1;
	
}
      
UpdateUser ();
      
my_argc = ParseArgs (my_argv, p);
      
if (my_argv[0] == NULL)
	
continue;

      
switch (*my_argv[0])
	{
	
case 'B':
	
case 'b':
	
case 'Q':
	
case 'q':

	  /*Maj_Msg(Caller,*my_argv);
 */
	  printf ("Bye bye 73 de %s%c", my_callsign, delimiter);
	  
LogoutUser ();
	  
return 0;
	

case 'H':
	
case 'h':
	  
Open_Data ();
	  
Maj_Msg (Caller, *my_argv);
	  
Print_Compteur ();
	  
Print_Histo_Analog ();
	  
Date_fr ();
	  
break;
	

case 'F':
	  
Maj_Msg (Caller, *my_argv);
	  
if (IsBBS)

	    {
	      
LogoutUser ();
	      
return 0;
	    
}

	  else
	    
printf ("Forwarding is BBS only.%c", delimiter);
	  
break;
	
case 'I':
	
case 'i':
	  Maj_Msg (Caller, *my_argv);
	  
catfile (CONF_METEO_INFO_FILE);
	  
break;
	
case 'C':
	
case 'c':
	  
Print_Conf ();
	  
Maj_Msg (Caller, *my_argv);
	  
Date_fr ();
	  
break;
	

case 'T':
	

case 't':
	  Maj_Msg (Caller, *my_argv);
	  
Talk (my_argc, my_argv);
	  
break;
	
case 'M':
	
case 'm':
	  
Maj_Msg (Caller, *my_argv);
	  
PostMessage (my_argc, my_argv);
	  
break;
	

case 'L':
	
case 'l':
	  
Maj_Msg (Caller, *my_argv);
	  
list_lastlog (call);
	  
break;
	
case 'U':
	
case 'u':
	  
Maj_Msg (Caller, *my_argv);
	  
UserList ();
	  
break;
	
case 'P':
	
case 'p':
	  
Maj_Msg (Caller, *my_argv);
	  
Show_Ports ();
	  
break;
	

case 'J':

/*
			case 'j':
				Maj_Msg(Caller,*my_argv);
				Show_Heard();				
				break;
*/
	case 's':
	
case 'S':
	  
Maj_Msg (Caller, *my_argv);
	  
sysOp ();
	  
break;
	
case 'a':
	
case 'A':
	  
Open_Data ();
	  
Maj_Msg (Caller, *my_argv);
	  
Print_Compteur ();
	  
Print_Analog ();
	  
printf (tendance = Tendance ());
	  printf ("%c", delimiter);
	  Date_fr ();
	  
break;
	
case 'd':
	
case 'D':
	  
Maj_Msg (Caller, *my_argv);
	  
Print_Compteur ();
	  
Print_Histo_Data ();
	  
Date_fr ();
	  
break;
	
case '0':
	  
Open_Data ();
	  
Maj_Msg (Caller, *my_argv);
	  
Print_Compteur ();
	  
Print_Detail (tab, 0);
	  
Date_fr ();
	  
break;
	
case 'v':
	
case 'V':
	  
Open_Data ();
	  
Maj_Msg (Caller, *my_argv);
	  control_Alarm ();
	  
Date_fr ();
	  
break;
	
case '1':
	  
if (((*my_argv[0]) == '1') && ((*my_argv[1]) == '0'))
	    {
	      
Open_Data ();
	      
Maj_Msg (Caller, *my_argv);
	      
Print_Compteur ();
	      
Print_Detail (tab, 10);
	      
Date_fr ();
	    }
	  else
	    
Open_Data ();
	  
Maj_Msg (Caller, *my_argv);
	  
Print_Compteur ();
	  
Print_Detail (tab, 1);
	  
Date_fr ();
	  
break;
	
case '2':
	  
Open_Data ();
	  
Maj_Msg (Caller, *my_argv);
	  
Print_Compteur ();
	  
Print_Detail (tab, 2);
	  
Date_fr ();
	  
break;
	
case '3':
	  
Open_Data ();
	  
Maj_Msg (Caller, *my_argv);
	  
Print_Compteur ();
	  
Print_Detail (tab, 3);
	  
Date_fr ();
	  
break;
	

case '4':
	  
Open_Data ();
	  
Maj_Msg (Caller, *my_argv);
	  
Print_Compteur ();
	  
Print_Detail (tab, 4);
	  
Date_fr ();
	  
break;
	

case '5':
	  
Open_Data ();
	  
Maj_Msg (Caller, *my_argv);
	  
Print_Compteur ();
	  
Print_Detail (tab, 5);
	  
Date_fr ();
	  
break;
	

case '6':
	  
Open_Data ();
	  
Maj_Msg (Caller, *my_argv);
	  
Print_Compteur ();
	  
Print_Detail (tab, 6);
	  
Date_fr ();
	  
break;
	

case '7':
	  
Open_Data ();
	  
Maj_Msg (Caller, *my_argv);
	  
Print_Compteur ();
	  
Print_Detail (tab, 7);
	  
Date_fr ();
	  
break;
	

case '8':
	  
Open_Data ();
	  
Maj_Msg (Caller, *my_argv);
	  
Print_Compteur ();
	  
Print_Detail (tab, 8);
	  
Date_fr ();
	  
break;
	

case '9':
	  
Open_Data ();
	  
Maj_Msg (Caller, *my_argv);
	  
Print_Compteur ();
	  
Print_Detail (tab, 9);
	  
Date_fr ();
	  
break;

	

default:
	  
printf ("Cmd inconnue, Unknown command '%s'%c", p, delimiter);
	
case '?':
	  
Maj_Msg (Caller, *my_argv);
	  
Menu ();

#ifdef notdef
	  printf ("(Analogique, Bye, Config, Digital, Info, Historique,%c",
		  delimiter);
	  
printf ("Mail, Port, Quit, Log, Talk, Users, Viewalarm, ?)%c",
		   delimiter);
	  
printf ("(0, 1, 2, 3, 4, 5, 6, 7, 8, 9) Voie en detail%c",
		   delimiter);

#endif
	  break;
	
}
    
}

  

return 0;

}
