/*                  HamRadioAX25 F5EXO@@F6KSU.FPDL.FRA.EU                  */
/*                           mail:f5exo@free.fr                            */
/*                     Web:http://f5exo.free.fr/meteo/                     */
/*                            Erick LINE                                   */

/* Pin 11 LPT (busy) utilise en entree pour recevoir sous forme serie      */
/* Pin 2  LPT (D0) utilisee pour generee l'horloge SCLK                    */
/* Pin 3  LPT (D1) utilisee pour generee CS                                */
/* Pin 4  LPT (D2) utilisee pour envoyer les donnees vers le MAX186.       */
/*                                                                         */
/* Pin 15 LPT (/ERROR)     Bit 3   (comptage impulsions) In                */
/* Pin 13 LPT (/SELECT)    Bit 4   (comptage impulsions) In                */
/* Pin 12 LPT (/PAPER OUT) Bit 5   (comptage impulsions) In                */
/*                                                                         */
/* Pin 17 LPT (Select_IN)  Bit 3   (Alarm 2) Out                           */
/* Pin 16 LPT (INIT)       Bit 2   (Alarm 1) Out                           */
/*                                                                         */
/*                   Calcul Valeur analogique                              */
/*           Val analog = (DATA*(Uref/CAN)-Offset)/Unites                  */
/*           Ou DATA    = valeur digitale lue en sortie CAN                */
/*              Uref    = Tension de reference du CAN  4.096               */
/*              CAD     = CAN 12 bits pour MAX186                          */
/*              Offset  = valeur offset du composant capteur               */
/*              Unites  = facteur mutiplicateur du composant capteur       */

/*------------------------------SCANLPT------------------------------------*/

/* axconv.c - A simple AX .25 convers client - version 1.3 *
*	Copyright (C) 1997 Tomi Manninen, OH2BNS, <tomi.manninen @ hut.fi >.
*	Adaptation METEO Erick Line, F5EXO, <f5exo @ free.fr >
*	Compile with:gcc - Wall - O6 - o axconv axconv.c
*
**	Axconv is a simple AX .25 convers client intended to be launched
*	from ax25d.It connects to the conversd system specified and
*	optionally logs in with the user and channel specified.It does
*	the necessary end - of - line conversions and also buffers the traffic 
*	in order to optimise the AX .25 channel usage slightly. 
*	Usage:axconv[-c < channel >][-l][-n < name >][-p < paclen >][-t <timeout>]
*	<host >[<service >] * 
*	Options:	 -c < channel > The channel to log into.Defaults 
*	to nothing.Only valid if name is also specified. * 
*	-l Use LF as end - of - line instead of CR. 
*	-n <name > Use < name > when logging in to the convers server.
*	If omitted,no automatic logging in is done.
*	-p < paclen > Maximum frame length for the client connection.
*	Defaults to 256. 
*	-t < timeout > After < timeout > seconds of inactivity 
*	from the client and convers server the connection is closed.
*	Defaults to * 0 ie.no timeout.
*       ** This program is free software; 
*	you can redistribute it and / or modify it under the terms of the GNU 
*	General Public License as published by the Free Software Foundation; 
*	either version 2 of the License, or (at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program; if not, write to the Free Software
*	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.          */
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <fcntl.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <ctype.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <math.h>
#include "../include/meteo.h"
#include "../fichiers/txt_upd.c"
#include "../include/lang.h"
#include "../couleur/couleur.c"
#include "../aprs/loc.c"
#include "../cmd.c"
#include "../meteoconf.c"
#define	BUFFERSIZE	2048
#define FLUSHTIMEOUT	500000L	/* 0.5 sec */
#define DELAY		2100	/*35mn (2100) */
/*extern int errno;*/
FILE *fp;
FILE *fic;
char *cp;

static char eol = '\r';
#ifdef French
static char topic[80] = { "***><---- INFOS METEO ----><***" };
#endif

#ifdef English
static char topic[80] = { "***><---- WEATHER REPORT ----><***" };
#endif

#ifdef Deutsch
static char topic[80] = { "***><---- WETTER REPORT ----><***" };
#endif


char tampon[BUFFERSIZE] = { };
static char Indicatif[80] = { };
static char Cmd[80] = { };
static char Arrive[BUFFERSIZE] = { };
long compt;
int lenArrive;
static char *usage_string =
  "Usage: axconv [-c <channel>] [-l] [-n <name>] [-p <paclen>] [-t <timeout>] <host> [<service>]";

#define PERROR(s)  fprintf(stderr, "%s: %s%c", (s), strerror(errno), eol)
/*
   Valeurs[c].Maxi      = tab[c][0][0][0];
   Valeurs[c].Inst      = tab[c][0][1][0];
   Valeurs[c].Mini      = tab[c][0][2][0];
   Valeurs[c].Date_Maxi = tab[c][1][0][0];
   Valeurs[c].Date_Inst = tab[c][1][1][0];
   Valeurs[c].Date_Mini = tab[c][1][2][0];
   Valeurs compteur     = tab[0][2][0][0];
   Valeurs Date_Init    = tab[0][2][0][1];
   it (en secondes)     = tab[0][2][0][2];
   temps t              = tab[0][2][0][3];
   temps t-1            = tab[0][2][0][4];
   compteurmaj		= tab[0][2][0][5];
   Valeurs hist mesures  [c][2][1][0----M]
   valeurs hist dates    [c][2][2][0----M]
*/

void
Extract_In (char *Arrive)	/* envoi une bienvenue sur nouvel arrivant */
{
  int i, l = 0;
  static char User_in[20] = { "" };
  static char nom_in[20] = { "" };
  l = strlen (Arrive);
  resetcouleur ();
  /* test sur la sting *** (16:13) f6cwo@NANTES_IP joined channel 151 */
  cp = strrchr (Arrive, '.');
  if ((cp) != NULL)
    {
      strcpy (Arrive, "");
      return;
    }
  cp = strrchr (Arrive, '1');
  if (*cp != '1')
    {
      strcpy (Arrive, "");
      return;
    }
  cp--;
  if (*cp != '5')
    {
      strcpy (Arrive, "");
      return;
    }
  cp--;
  if (*cp != '1')
    {
      strcpy (Arrive, "");
      return;
    }
  strncpy (User_in, Arrive, 20);
  cp = strrchr (User_in, '@');
  if ((cp) == NULL)
    {
      strncpy (Arrive, "", 2);
      return;
    }
  *cp = '\0';
  cp = strrchr (User_in, ' ');
  *cp = '@';
  strcpy (nom_in, User_in);
  l = strlen (nom_in);
  for (i = 0; i < l; i++)
    {
      nom_in[i] = nom_in[(l - 1) - i];
    }
  cp = strchr (nom_in, '@');
  *cp = '\0';
  l = strlen (nom_in);
  strcpy (User_in, nom_in);
  for (i = 0; i < l; i++)
    {
      User_in[i] = nom_in[(l - 1) - i];
    }
/*  printf ("Call entrant: %s\n", User_in);*/
  fprintf (fp, "Welcome ");
  fprintf (fp, User_in);
  fprintf (fp, " ! Send /m ");
  fprintf (fp, Conf.ConvIdent);
  fprintf (fp, " ?  to get help.");
  fprintf (fp, "\n\r");
  fflush (stdout);
  fflush (fp);

  violet ();
#ifdef French
  printf ("Call %s entrant sur la voie 151 ,envoi meteo bienvenue. \n",
	  User_in);
#endif
#ifdef English
  printf ("Channel 151 incoming call %s ,send welcome. \n", User_in);
#endif
#ifdef Deutsch
  printf ("Channel 151 incoming call %s ,send welcome. \n", User_in);
#endif

  resetcouleur ();
  strcpy (Arrive, "");
  strcpy (User_in, "");
  strcpy (nom_in, "");
  return;
}



char *
Extract_Call (char *Indicatif)	/* extract Indicatif du message prive */
{				/* <*f5exo*>: Hello world             */
  /* <*f5exo:Erick*>: Hello world(Avec Nickname */
  int i, l;
  static char cmd[20] = { "/m " };
  l = strlen (Indicatif);
  for (i = 2; i < l; i++)
    {
      Indicatif[i - 2] = Indicatif[i];
    }
  for (i = 0; i < l; i++)
    {
      if (Indicatif[i] == '*')
	{
	  cp = strchr (Indicatif, '*');
	  *cp = ':';
	}
    }
  cp = strchr (Indicatif, ':');
  *cp = '\0';
  strcat (cmd, Indicatif);
  strcpy (Indicatif, cmd);
  strcat (Indicatif, " ");
  strcpy (cmd, "/m ");
  return Indicatif;
}


char *
Extract_Cmd (char *Cmd)		/* extract cmd du message prive */
{				/* <*f5exo*>: Hello world       */
  int l;
  l = strlen (Cmd);
  cp = strchr (Cmd, ' ');
  cp++;
  cp++;
  *cp = '\0';
  l = strlen (Cmd);
  Cmd[0] = Cmd[l - 1];
  Cmd[1] = '\0';
  return Cmd;
}

void
Menu (void)
{
  int c;
  fputc (eol, stdout);
  fprintf (fp, Indicatif);
#ifdef French
  fprintf (fp, "Resume des Cmd: /m ");
#endif
#ifdef English
  fprintf (fp, "Cmd summary: /m ");
#endif
#ifdef Deutsch
  fprintf (fp, "Cmd summary: /m ");
#endif

  fprintf (fp, Conf.ConvIdent);
  fprintf (fp, " [c] ");
  for (c = 0; c < Conf.C; c++)
    {
      if (capteurs[c].Unites > 0)
	{
	  fprintf (fp, "[%d]=> ", c);
	  fprintf (fp, capteurs[c].Mesure);
	  fprintf (fp, ". ");
	}
    }
  fprintf (fp, ",[A]ctuel ,[Q]th ,[V]ersion ,[I]nfo ,?.   Ex: /M %s 0 \r\n",
	   Conf.ConvIdent);
  fflush (stdout);
  fflush (fp);
/* return;    */
}


void
Actuel (void)
{
  int c;
  float z;
  fputc (eol, stdout);
  for (c = 0; c < Conf.C - 2; c++)
    {
      if (capteurs[c].Unites > 0)
	{
	  fprintf (fp, Indicatif);
	  fprintf (fp, "[");
	  fprintf (fp, Legend[7]);
	  fprintf (fp, ": %d  ", c);
	  fprintf (fp, capteurs[c].Mesure);
	  z =
	    ((tab[c][0][1][0] * CAD) -
	     capteurs[c].Offset) / capteurs[c].Unites;
	  fprintf (fp, ":%5.2f ", z);
	  fprintf (fp, capteurs[c].Unite);
	  fprintf (fp, "] ");
	  fprintf (fp, "\n\r");
	  fflush (stdout);
	  fflush (fp);
	}
    }

  for (c = Conf.C - 2; c < Conf.C; c++)
    {
      if (capteurs[c].Unites > 0)
	{
	  fprintf (fp, Indicatif);
	  fprintf (fp, "[");
	  fprintf (fp, Legend[7]);
	  fprintf (fp, ": %d  ", c);
	  fprintf (fp, capteurs[c].Mesure);
	  z = (tab[c][0][1][0] * capteurs[c].Unites);
	  fprintf (fp, ":%5.2f ", z);
	  fprintf (fp, capteurs[c].Unite);
	  fprintf (fp, "] ");
	  fprintf (fp, "\n\r");
	  fflush (stdout);
	  fflush (fp);
	}
    }

}

void
channel (char *msg)
{
  int c;
  float z;
  fputc (eol, stdout);
  fprintf (fp, Indicatif);
  c = atoi (msg);
/* fprintf(fp,"Channel: %d",c);*/
  if (c < Conf.C - 2)
    {
      if (capteurs[c].Unites > 0)
	{
	  fprintf (fp, capteurs[c].Mesure);
	  z =
	    ((tab[c][0][1][0] * CAD) -
	     capteurs[c].Offset) / capteurs[c].Unites;
	  fprintf (fp, ":%5.2f ", z);
	  fprintf (fp, capteurs[c].Unite);
	  fprintf (fp, " [");
	  fprintf (fp, Legend[1]);
	  fprintf (fp, ":");
	  z =
	    ((tab[c][0][0][0] * CAD) -
	     capteurs[c].Offset) / capteurs[c].Unites;
	  fprintf (fp, "%5.2f", z);
	  fprintf (fp, " ");
	  fprintf (fp, Legend[3]);
/*  fprintf (fp, " Mini:");*/
	  z =
	    ((tab[c][0][2][0] * CAD) -
	     capteurs[c].Offset) / capteurs[c].Unites;
	  fprintf (fp, "%5.2f ] ", z);
/*  fprintf (fp, " ");*/
	  fprintf (fp, Legend[0]);
	  fprintf (fp, " ");
	  fprintf (fp, capteurs[c].sensor);
	  fprintf (fp, "\n\r");
	  fflush (stdout);
	  fflush (fp);
	}
    }


  if (c >= Conf.C - 2)
    {
      if (capteurs[c].Unites > 0)
	{
	  fprintf (fp, capteurs[c].Mesure);
	  z = (tab[c][0][1][0] * capteurs[c].Unites);
	  fprintf (fp, ":%5.2f ", z);
	  fprintf (fp, capteurs[c].Unite);

	  fprintf (fp, " [");
	  fprintf (fp, rain[0]);
	  fprintf (fp, ":");
	  z = (tab[c][0][0][0] * capteurs[c].Unites);
	  fprintf (fp, "%5.2f", z);
	  fprintf (fp, " ");
	  fprintf (fp, rain[1]);
/*  fprintf (fp, " Mini:");*/
	  z = (tab[c][0][2][0] * capteurs[c].Unites);
	  fprintf (fp, "%5.2f ] ", z);
/*  fprintf (fp, " ");*/
/*    fprintf (fp, rain[1]);*/
	  fprintf (fp, " ");
	  fprintf (fp, capteurs[c].sensor);
	  fprintf (fp, "\n\r");
	  fflush (stdout);
	  fflush (fp);
	}
    }
}

void
Qth (void)
{
  fputc (eol, stdout);
  position (Conf.locator);
  fprintf (fp, Indicatif);
  fprintf (fp, "Qth: ");
  fprintf (fp, Conf.qth);
  fprintf (fp, "  Latitude: ");
  if ((strlen (Conf.latitude) >= 8) && (strlen (Conf.longitude) >= 8))
    {
      fprintf (fp, Conf.latitude);
      fprintf (fp, " / Longitude: ");
      fprintf (fp, Conf.longitude);
    }
  else
    {
      fprintf (fp, "%07.2f", aprs.location[0]);
      fprintf (fp, aprs.sgnla);
      fprintf (fp, " / Longitude: %08.2f", aprs.location[1]);
      fprintf (fp, aprs.sgnlo);
    }
  fprintf (fp, "\n\r");
  fflush (stdout);
  fflush (fp);
}

void
Version (void)
{
  fputc (eol, stdout);
  fprintf (fp, Indicatif);
#ifdef French
  fprintf (fp, "[METEO Linux Erick Line F5EXO (2000-2003) Version: %sFr",
	   METEO_VERSION);
#endif
#ifdef English
  fprintf (fp, "[WEATHER Linux Erick Line F5EXO (2000-2003) Version: %sEn",
	   METEO_VERSION);
#endif
#ifdef Deutsch
  fprintf (fp, "[WETTER Linux Erick Line F5EXO (2000-2003) Version: %sEn",
	   METEO_VERSION);
#endif


  fprintf (fp, "]\n\r");
  fflush (stdout);
  fflush (fp);
}

void
Conv_Tendance (void)
{
  fputc (eol, stdout);
  fprintf (fp, Indicatif);
  fprintf (fp, "Tendance:");
  fprintf (fp, (tendance = Tendance ()));
  fprintf (fp, "\n\r");
  fflush (stdout);
  fflush (fp);
}

void
Inf (void)
{
  fputc (eol, stdout);
  fprintf (fp, Indicatif);
  fprintf (fp, Conf.LINUX);
  fprintf (fp,
	   " & Interface CAN 12Bits MAX186. Uref: %0.3fVolts Sensors:%d  SysOp:",
	   Uref, Conf.C);
  fprintf (fp, Conf.SysOp);
  fprintf (fp, " a ");
  fprintf (fp, Conf.qth);
  fprintf (fp, " AX25 acces: %s", Conf.ax25Call);
  fprintf (fp, "   %ld Iterations", tab[0][2][0][0]);
  fprintf (fp, "\n\r");
  fflush (stdout);
  fflush (fp);
}

void
Conv_Balise (void)
{
  fputc (eol, stdout);
  {
    time_t t;
    t = time (NULL);
    tb = localtime (&t);
    fprintf (fp, " %d %s  %2.2d:%2.2d ", tb->tm_mday,
	     Mois[tb->tm_mon], tb->tm_hour, tb->tm_min);
  }
  Open_Data ();
  jaune ();
#ifdef French
  printf ("Compteur:%ld Depart balise: %d %s  %2.2d:%2.2d \n", compt,
	  tb->tm_mday, Mois[tb->tm_mon], tb->tm_hour, tb->tm_min);
#endif
#ifdef English
  printf ("Counter:%ld Send beacon: %d %s  %2.2d:%2.2d \n", compt,
	  tb->tm_mday, Mois[tb->tm_mon], tb->tm_hour, tb->tm_min);
#endif
#ifdef Deutsch
  printf ("Counter:%ld Send beacon: %d %s  %2.2d:%2.2d \n", compt,
	  tb->tm_mday, Mois[tb->tm_mon], tb->tm_hour, tb->tm_min);
#endif


  resetcouleur ();
#ifdef French
  fprintf (fp, " [METEO:%s] Aide: /M %s ? ", METEO_VERSION, Conf.ConvIdent);
#endif
#ifdef English
  fprintf (fp, " [METEO:%s] Help: /M %s ? ", METEO_VERSION, Conf.ConvIdent);
#endif
#ifdef Deutsch
  fprintf (fp, " [METEO:%s] Help: /M %s ? ", METEO_VERSION, Conf.ConvIdent);
#endif

  fprintf (fp, "\n\r");
  fprintf (fp, " ");
  fprintf (fp, tendance = Tendance ());
  fprintf (fp, "\n\r");
  fflush (stdout);
  fflush (fp);
}

void
Test (char *arg)
{
  if ((strcmp (Uppercase (arg), "?") == 0) || (strcmp (arg, "H") == 0))
    {
      Menu ();
    }
  if (strcmp (arg, "0") == 0)
    {
      channel (arg);
    }
  if (strcmp (arg, "1") == 0)
    {
      channel (arg);
    }
  if (strcmp (arg, "2") == 0)
    {
      channel (arg);
    }
  if (strcmp (arg, "3") == 0)
    {
      channel (arg);
    }
  if (strcmp (arg, "4") == 0)
    {
      channel (arg);
    }
  if (strcmp (arg, "5") == 0)
    {
      channel (arg);
    }
  if (strcmp (arg, "6") == 0)
    {
      channel (arg);
    }
  if (strcmp (arg, "7") == 0)
    {
      channel (arg);
    }

  if (strcmp (arg, "8") == 0)
    {
      channel (arg);
    }
  if (strcmp (arg, "9") == 0)
    {
      channel (arg);
    }

  if ((strcmp (arg, "A") == 0) || (strcmp (arg, "a") == 0))
    {
      Actuel ();
    }
  if ((strcmp (arg, "Q") == 0) || (strcmp (arg, "q") == 0))
    {
      Qth ();
    }
  if ((strcmp (arg, "V") == 0) || (strcmp (arg, "v") == 0))
    {
      Version ();
    }
  if ((strcmp (arg, "I") == 0) || (strcmp (arg, "i") == 0))
    {
      Inf ();
    }
  if ((strcmp (arg, "T") == 0) || (strcmp (arg, "t") == 0))
    {
      Conv_Tendance ();
    }


/* return;*/
}

void
B_channel (int c)
{
  float z;
  fputc (eol, stdout);
  if (c < Conf.C - 2)
    {
      if (capteurs[c].Unites > 0)
	{
	  fprintf (fp, capteurs[c].Mesure);
	  z =
	    ((tab[c][0][1][0] * CAD) -
	     capteurs[c].Offset) / capteurs[c].Unites;
	  fprintf (fp, ":%5.2f  ", z);
	  fprintf (fp, capteurs[c].Unite);
	  fprintf (fp, "\n\r");
	  fflush (stdout);
	  fflush (fp);
	}
    }
  if (c > Conf.C - 2)
    {
      if (capteurs[c].Unites > 0)
	{
	  fprintf (fp, capteurs[c].Mesure);
	  z = (tab[c][0][1][0] * capteurs[c].Unites);
	  fprintf (fp, ":%5.2f  ", z);
	  fprintf (fp, capteurs[c].Unite);
	  fprintf (fp, "\n\r");
	  fflush (stdout);
	  fflush (fp);
	}
    }
  return;
}


void
proctimer (int i)
{
  int c;
  float z;
  Conv_Balise ();
  for (c = 0; c < Conf.C - 2; c++)
    {
      if (capteurs[c].Unites > 0)
	{
	  if (strcasecmp (capteurs[c].Unite, "Celsius") == 0)
	    {
	      fprintf (fp, capteurs[c].Mesure);
	      z =
		((tab[c][0][1][0] * CAD) -
		 capteurs[c].Offset) / capteurs[c].Unites;
	      fprintf (fp, ":%5.2f  ", z);
	      fprintf (fp, capteurs[c].Unite);
	      fprintf (fp, "  => %9.3d  ", Farenheit (z));
	      fprintf (fp, "Farenheit");
	      fprintf (fp, "\n\r");
	    }
	  else if (strcasecmp (capteurs[c].Unite, "hPa") == 0)
	    {
	      fprintf (fp, capteurs[c].Mesure);
	      z =
		((tab[c][0][1][0] * CAD) -
		 capteurs[c].Offset) / capteurs[c].Unites;
	      fprintf (fp, ":%5.2f  ", z);
	      fprintf (fp, capteurs[c].Unite);
	      fprintf (fp, "  => %9.3d  ", Mercure (z));
	      fprintf (fp, "mm Hg");
	      fprintf (fp, "\n\r");
	    }

	  else if (strcasecmp (capteurs[c].Unite, "M/s") == 0)
	    {
	      fprintf (fp, capteurs[c].Mesure);
	      z =
		((tab[c][0][1][0] * CAD) -
		 capteurs[c].Offset) / capteurs[c].Unites;
	      fprintf (fp, ":%5.2f  ", z);
	      fprintf (fp, capteurs[c].Unite);
	      fprintf (fp, "  => %9.3d  ", Vent (z));
	      fprintf (fp, "Kmh");
	      fprintf (fp, "\n\r");
	    }


	  else if (strcasecmp (capteurs[c].Unite, "Degres") == 0)
	    {
	      fprintf (fp, capteurs[c].Mesure);
	      z =
		((tab[c][0][1][0] * CAD) -
		 capteurs[c].Offset) / capteurs[c].Unites;
	      fprintf (fp, ":%5.2f  ", z);
	      fprintf (fp, capteurs[c].Unite);
	      fprintf (fp, "  => Vent secteur %9.5s", Cadran[Girouette (z)]);
	      fprintf (fp, "\n\r");
	    }
	  else
	    {
	      fprintf (fp, capteurs[c].Mesure);
	      z =
		((tab[c][0][1][0] * CAD) -
		 capteurs[c].Offset) / capteurs[c].Unites;
	      fprintf (fp, ":%5.2f  ", z);
	      fprintf (fp, capteurs[c].Unite);
	      fprintf (fp, "\n\r");

	    }
	}
    }

  for (c = Conf.C - 2; c < Conf.C; c++)
    {
      if (capteurs[c].Unites > 0)
	{
	  fprintf (fp, capteurs[c].Mesure);
	  z = (tab[c][0][1][0] * capteurs[c].Unites);
	  fprintf (fp, ":%5.2f  ", z);
	  fprintf (fp, capteurs[c].Unite);
	  fprintf (fp, "\n\r");
	}
    }
  compt++;
  fprintf (fp, " \n\r");
  fflush (stdout);
  fflush (fp);
}


/*
 * Convert <eol> to <CR><LF>
 */
static int
convert_eol_crlf (char *inbuf, char *outbuf, int len)
{
  int i = 0;

  while (len-- > 0)
    {
      if (*inbuf == eol)
	{
	  outbuf[i++] = '\r';
	  outbuf[i++] = '\n';
	}
      else
	outbuf[i++] = *inbuf;
      inbuf++;
    }
  return i;
}

/*
 * Convert <CR><LF>, <CR><NUL> or a plain <LF> to a eol
 */
static int
convert_crlf_eol (char *inbuf, char *outbuf, int len)
{
  int i = 0;
  while (len-- > 0)
    {
      if (*inbuf == '\r' && (inbuf[1] == '\n' || inbuf[1] == '\0'))
	{
	  /*
	   * <CR><LF> or <CR><NUL>
	   */
	  outbuf[i++] = eol;
	  inbuf++;
	  len--;
	}
      else if (*inbuf == '\n')
	{
	  /*
	   * <LF>
	   */
	  outbuf[i++] = eol;
	}
      else
	outbuf[i++] = *inbuf;
      inbuf++;
    }
  return i;
}

int
main (int argc, char **argv)
{
  char inbuf[BUFFERSIZE], outbuf[BUFFERSIZE];
  char *buf;
  char *name = NULL, *channel = NULL;
  int paclen = 256, timeout = 0, len, fd;	/* TimeOut 0 */
  fd_set fdset;

  struct timeval tv;
  struct sockaddr_in sin;
  struct hostent *hp;
  struct servent *sp;
  struct itimerval timer;

#ifdef BSD
  signal (SIGALRM, proctimer);	/* SIGALRM intercepte et declenche proc */
#else
  struct sigaction act;
  act.sa_handler = proctimer;
  act.sa_flags = SA_RESTART;
  if (sigaction (SIGALRM, &act, NULL) == -1)
    {
      fprintf (stderr, "Erreur in sigaction\n");
      exit (errno);
    }
#endif
  memset (&timer, (char) 0, sizeof (timer));	/*clean la zone timer avec des 0 */
  timer.it_interval.tv_sec = DELAY;	/* Timer 2100 balise 35Mn */
  timer.it_interval.tv_usec = 0;
  timer.it_value.tv_sec = DELAY;	/* Valeur initiale   */
  timer.it_value.tv_usec = 0;

  Clr_scr ();
  Get_Conf ();
  name = Conf.ConvIdent;
  channel = ("151");
/*	signal(SIGALRM, alarm_handler);*/

  while ((len = getopt (argc, argv, "c:ln:p:t:")) != -1)
    {
      switch (len)
	{
	case 'n':
	  name = optarg;
	  break;
	case 'l':
	  eol = '\n';
	  break;
	case 'c':
	  channel = optarg;
	  break;
	case 'p':
	  paclen = atoi (optarg);
	  break;
	case 't':
	  timeout = atoi (optarg);
	  break;
	case ':':
	case '?':
	  fprintf (stderr, "%s%c", usage_string, eol);
	  return 1;
	}
    }

  if (optind == argc)
    {
      argv[optind] = Conf.Ax25Convers;
/*		fprintf(stderr, "%s%c", usage_string, eol);*/
      printf ("\nHost:%s\n", Conf.Ax25Convers);
      /*return 1; */
    }

  if (paclen < 1)
    {
      fprintf (stderr, "Invalid paclen: %d%c", paclen, eol);
      return 1;
    }

  if ((buf = malloc (paclen)) == NULL)
    {
      PERROR ("axconv: malloc");
      return 1;
    }

  setvbuf (stdout, buf, _IOFBF, paclen);

  if ((fd = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    {
      PERROR ("axconv: socket");
      return 1;
    }

  if ((hp = gethostbyname (argv[optind])) == NULL)
    {
      fprintf (stderr, "Unknown host %s%c", argv[optind], eol);
      close (fd);
      return 1;

    }
  sin.sin_family = AF_INET;
  sin.sin_addr.s_addr = ((struct in_addr *) (hp->h_addr))->s_addr;

  sin.sin_port = htons (3600);	/* Port convers */
  if (optind == argc - 2)
    {
      sp = getservbyname (argv[optind + 1], "tcp");
      if (sp != NULL)
	sin.sin_port = sp->s_port;
      else
	sin.sin_port = htons (atoi (argv[optind + 1]));

      if (ntohs (sin.sin_port) == 0)
	{
	  fprintf (stderr, "Unknown service %s%c", argv[optind + 1], eol);
	  return 1;
	}
    }

  printf ("*** Connecting to %s, port %d%c", hp->h_name, ntohs (sin.sin_port),
	  eol);
  fflush (stdout);

  len = sizeof (struct sockaddr_in);
  if (connect (fd, (struct sockaddr *) &sin, len) == -1)
    {
      PERROR ("axconv: connect");
      return 1;
    }
  if ((fp = fdopen (fd, "w+")) == NULL)
    {
      PERROR ("axconv: fdopen");
      return 1;
    }

  if (fcntl (STDIN_FILENO, F_SETFL, O_NONBLOCK) == -1)
    {
      PERROR ("axconv: fcntl");
      exit (1);
    }
  if (fcntl (fd, F_SETFL, O_NONBLOCK) == -1)
    {
      PERROR ("axconv: fcntl");
      exit (1);
    }

  if (name != NULL)
    {
      rouge ();
#ifdef French
      printf ("[METEO Linux Erick Line F5EXO (2000-2003) Version: %sFr\n",
	      METEO_VERSION);
#endif
#ifdef English
      printf ("[WEATHER Linux Erick Line F5EXO (2000-2003) Version: %sEn",
	      METEO_VERSION);
#endif
#ifdef Deutsch
      printf ("[WETTER Linux Erick Line F5EXO (2000-2003) Version: %sDl",
	      METEO_VERSION);
#endif

      resetcouleur ();
      cyan ();
      printf ("*** Logging in as %s", name);
      if (channel != NULL)
	printf (", channel %s", channel);
      fputc (eol, stdout);
      fprintf (fp, "/n %s %s\r\n", name, channel ? channel : "");
      fflush (stdout);
      fflush (fp);
      resetcouleur ();

    }
  /* Envoi de la personalisation /P Laval */
  fputc (eol, stdout);
  fprintf (fp, "/P %s\r\n", Conf.qth);
  fflush (stdout);
  fflush (fp);
  fputc (eol, stdout);
  fprintf (fp, "/TOPIC %s\r\n", topic);
  fflush (stdout);
  fflush (fp);

  fputc (eol, stdout);
  fprintf (fp, "/NI %s\r\n", Conf.qth);
  fflush (stdout);
  fflush (fp);
  fputc (eol, stdout);

  fputc (eol, stdout);
  fprintf (fp, "/hosts\r\n");
  fprintf (fp, "/w \r\n");
/*	fprintf(fp,"/v \r\n");*/
  fflush (stdout);
  fflush (fp);
  fputc (eol, stdout);

#ifdef French
  fprintf (fp, "/ME [.....METEO Linux Version %sFr actif.....]\r\n",
	   METEO_VERSION);
#endif
#ifdef English
  fprintf (fp, "/ME [.....WEATHER Linux Version %sEn Up.....]\r\n",
	   METEO_VERSION);
#endif
#ifdef Deutsch
  fprintf (fp, "/ME [.....WETTER Linux Version %sDl Up.....]\r\n",
	   METEO_VERSION);
#endif

  fflush (stdout);
  fflush (fp);
  fputc (eol, stdout);
#ifdef French
  fprintf (fp, "[.....Faire /m %s ? pour l'aide.....]\r\n", Conf.ConvIdent);
#endif
#ifdef English
  fprintf (fp, "[.....Enter /m %s ? for help.....]\r\n", Conf.ConvIdent);
#endif
#ifdef Deutsch
  fprintf (fp, "[.....Enter /m %s ? fur Hilfe.....]\r\n", Conf.ConvIdent);
#endif

  fflush (stdout);
  fflush (fp);
  fputc (eol, stdout);
/* Fin initialisation cnx */

/*	alarm(timeout); */
  setitimer (ITIMER_REAL, &timer, 0);

  while (1)
    {
      FD_ZERO (&fdset);
      FD_SET (STDIN_FILENO, &fdset);
      FD_SET (fd, &fdset);

      tv.tv_sec = 0;
      tv.tv_usec = FLUSHTIMEOUT;
      len = select (fd + 1, &fdset, 0, 0, &tv);
/*
		if (len == -1) {
			PERROR("axconv: select");
			return 1;
		}
*/

      if (len == 0)
	{
	  fflush (stdout);
	  fflush (fp);
	}

      /* Rx data en sortie */
      if (FD_ISSET (STDIN_FILENO, &fdset))
	{
/*			alarm(timeout);*/
	  len = read (STDIN_FILENO, inbuf, BUFFERSIZE);
	  if (len < 0 && errno != EAGAIN)
	    {
	      PERROR ("axconv: read");
	      break;
	    }
	  if (len == 0)
	    break;
	  len = convert_eol_crlf (inbuf, outbuf, len);
	  fwrite (outbuf, 1, len, fp);
/*			printf("Outbuf Tx :%s\n",outbuf);*/
	}
      /* Rx data en entree */
      if (FD_ISSET (fd, &fdset))
	{
/*			alarm(timeout);*/
	  len = read (fd, inbuf, BUFFERSIZE);
	  if (len < 0 && errno != EAGAIN)
	    {
	      PERROR ("axconv: read");
	      break;
	    }
	  if (len == 0)
	    break;

	  len = convert_crlf_eol (inbuf, outbuf, len);
	  Indicatif[0] = '\0';

	  strncpy (tampon, inbuf, len);

	  tampon[len] = 0;	/* on ne prend que les nouvelles infos */

	  /* detection d'arrive d'un user sur la voie 151 */
	  strncpy (Arrive, "", 2);
/*
	  Arrive[1] = '0';
	  Arrive[len] = 0;
*/
	  if ((tampon[0] == '*') && (tampon[1] == '*') && (tampon[2] == '*')
	      && (tampon[4] == '('))
	    {
	      cp = strrchr (tampon, '@');
	      if ((cp) != NULL)
		{

		  strncpy (Arrive, tampon, len);
		  Extract_In (Arrive);
		  rouge ();
		  printf ("%s", tampon);
		  resetcouleur ();

		}
	    }
	  else if ((tampon[0] == '<') && (tampon[1] == '*')
		   && (tampon[2] != '*'))
	    {
	      bleu ();
	      printf ("%s", tampon);
	    }
	  else
	    {
	      vert ();
	      printf ("%s", tampon);
	      resetcouleur ();
	    }
	  /* selection des infos perso */
	  if ((tampon[0] == '<') && (tampon[1] == '*') && (tampon[2] != '*'))
	    {
	      Open_Data ();
	      strncpy (Indicatif, tampon, len);
	      strncpy (Cmd, tampon, len);
	      Extract_Call (Indicatif);
	      Extract_Cmd (Cmd);
	      Test (Cmd);
	    }

	}
    }
  printf ("*** Disconnected from %s%c", hp->h_name, eol);
  fflush (stdout);
  fclose (fp);
  free (buf);
  return 0;
}
