
/*                  HamRadioAX25 F5EXO@@F6KSU.FPDL.FRA.EU                  */
/*                           mail:f5exo@free.fr                            */
/*                     Web:http://f5exo.free.fr/meteo/                     */
/*                            Erick LINE                                   */

/* Pin 11 LPT (busy) utilise en entree pour recevoir sous forme serie      */
/* Pin 2  LPT (D0) utilisee pour generee l'horloge SCLK                    */
/* Pin 3  LPT (D1) utilisee pour generee CS                                */
/* Pin 4  LPT (D2) utilisee pour envoyer les donnees vers le MAX186.       */
/*                                                                         */
/* Pin 15 LPT (/ERROR)     Bit 3   (comptage impulsions) In                */
/* Pin 13 LPT (/SELECT)    Bit 4   (comptage impulsions) In                */
/* Pin 12 LPT (/PAPER OUT) Bit 5   (comptage impulsions) In                */
/*                                                                         */
/* Pin 17 LPT (Select_IN)  Bit 3   (Alarm 2) Out                           */
/* Pin 16 LPT (INIT)       Bit 2   (Alarm 1) Out                           */
/*                                                                         */
/*                   Calcul Valeur analogique                              */
/*           Val analog = (DATA*(Uref/CAN)-Offset)/Unites                  */
/*           Ou DATA    = valeur digitale lue en sortie CAN                */
/*              Uref    = Tension de reference du CAN  4.096               */
/*              CAD     = CAN 12 bits pour MAX186                          */
/*              Offset  = valeur offset du composant capteur               */
/*              Unites  = facteur mutiplicateur du composant capteur       */

/*-----------------------------------CMD.C---------------------------------*/

// Fichier annee.rrd
void
get_year (void)
{
  char tampon[43] = { "" };
  {
    time_t t;
    t = time (NULL);
  }
  tb = localtime (&t);
  strcpy (tampon, "cp ");
  strcpy (RRD_METEO_DATA_BASE, "");
  strcpy (RRD_FILE, "");
  sprintf (RRD_OLD_FILE, "%d.rrd", tb->tm_year + 1900 - 1);
  strcat (RRD_METEO_DATA_BASE, RRD_METEO_DATA_DIR);
  strcat (tampon, RRD_METEO_DATA_DIR);
  strcat (tampon, RRD_OLD_FILE);
  strcat (tampon, " ");
  strcat (tampon, RRD_METEO_DATA_DIR);
  sprintf (RRD_FILE, "%d.rrd", tb->tm_year + 1900);
  strcat (RRD_METEO_DATA_BASE, RRD_FILE);
  strcat (tampon, RRD_FILE);
  system (tampon);
  sprintf (tampon, " ");
  return;
}




/* Msg des commandes effectuees par les users dans axmeteo */
void
Maj_Msg (char *Caller, char *my_argv)
{
  FILE *msg;
  time_t t;
  t = time (NULL);
  tb = localtime (&t);
  msg = fopen (MSG_METEO_DATA_FILE, "a+");

#ifdef French
  fprintf (msg,
	   "%s %d %s %d %2.2d:%2.2d-->AXMETEO %s a sollicite la cmd: %s.\n",
	   Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
	   tb->tm_year + 1900, tb->tm_hour, tb->tm_min, Caller, my_argv);
#endif
#ifdef English
  fprintf (msg,
	   "%s %d %s %d %2.2d:%2.2d-->AXMETEO request %s cmd from %s.\n",
	   Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
	   tb->tm_year + 1900, tb->tm_hour, tb->tm_min, my_argv, Caller);
#endif
#ifdef Deutsch
  fprintf (msg,
	   "%s %d %s %d %2.2d:%2.2d-->AXMETEO request %s cmd from %s.\n",
	   Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
	   tb->tm_year + 1900, tb->tm_hour, tb->tm_min, my_argv, Caller);
#endif
  fclose (msg);
}


/* Lecture configuration */
void
Print_Conf (void)
{
  char *ssid;
  short int i;
/*
  printf ("Configuration systme / System configuration %s%c",
	  CONF_METEO_CONF_FILE, delimiter);
*/
/*  printf ("%c",delimiter);*/
  printf ("%s ", Legend[7]);
  printf ("%8.8s ", Legend[0]);
  printf ("     Mesure  ");
  printf ("   Offset ");
  printf (" Multipl");
  printf ("    %s", Legend[4]);
  printf (" %15.12s", Legend[9]);
  printf ("%c", delimiter);
  printf
    ("-----------------------------------------------------------------------------%c",
     delimiter);
  for (i = 0; i < Conf.C; i++)
    {
      if (i < 10)
	{
	  printf ("%1.1d ", i);
	}
      else
	{
	  printf ("%1.1d", i);
	}
      printf ("%14.13s", capteurs[i].sensor);
      printf ("%14.13s", capteurs[i].Mesure);
      printf ("%8.3f", capteurs[i].Offset);
      printf ("%8.3f", capteurs[i].Unites);
      printf ("%12.15s", capteurs[i].Unite);
      printf ("%6.2s", capteurs[i].Comp);
      printf ("%8.3f", capteurs[i].Seuil);
      printf ("%c", delimiter);
    }
  printf
    ("-----------------------------------------------------------------------------%c",
     delimiter);
#ifdef French
  printf ("Adresse OUT Port LPT.: %#x.%c", Conf.OUT_PORT, delimiter);
#ifdef DEBUG
  printf (" Tempo Debug....: %d%c", Conf.Sleep, delimiter);
#endif
//  printf (" Mise a jour HTML...: %d Mn%c", Conf.Mn, delimiter);
  printf ("Nombre de capteurs...: %d ", Conf.C - 3);
  printf ("CAN 12 Bits MAX186 & 3 Direct LPT  Uref: %0.3f Volts%c", Uref,
	  delimiter);
  printf ("Rpertoire HTML......: %s", Conf.METEO_HTML_DIR);
  printf (" HTML link : %s%c", Conf.HTMLLink, delimiter);

  printf ("Locator..............: %s", Conf.locator);
  if (strlen (Conf.latitude) >= 8 && strlen (Conf.longitude) >= 8)
    {
      printf ("  Lat/Long => %s - %s%c", Conf.latitude, Conf.longitude,
	      delimiter);
    }
  else
    printf ("  Lat/Long => %07.2f%s - %08.2f%s%c", aprs.location[0],
	    aprs.sgnla, aprs.location[1], aprs.sgnlo, delimiter);

  printf ("QTH..................: %s.", Conf.qth);
  printf (" Alt...: %d metres.%c", Conf.altitude, delimiter);
#endif

#ifdef English
  printf ("OUT Port LPT address.: %#x.%c", Conf.OUT_PORT, delimiter);
#ifdef DEBUG
  printf (" Tempo Debug....: %d%c", Conf.Sleep, delimiter);
#endif
  printf (" TML Update..: %d Mn%c", Conf.Mn, delimiter);
  printf ("Number of sensors....: %d ", Conf.C - 3);
  printf ("CAN 12 Bits MAX186 & 3 Direct LPT  Uref: %0.3f Volts%c", Uref,
	  delimiter);
  printf ("HTML directorie......: %s", Conf.METEO_HTML_DIR);
  printf (" HTML link : %s%c", Conf.HTMLLink, delimiter);

  printf ("Locator..............: %s", Conf.locator);
  if (strlen (Conf.latitude) >= 8 && strlen (Conf.longitude) >= 8)
    {
      printf ("  Lat/Long => %s - %s%c", Conf.latitude, Conf.longitude,
	      delimiter);
    }
  else
    printf ("  Lat/Long => %07.2f%s - %08.2f%s%c", aprs.location[0],
	    aprs.sgnla, aprs.location[1], aprs.sgnlo, delimiter);

  printf ("QTH..................: %s.", Conf.qth);
  printf (" Alt...: %d meters.%c", Conf.altitude, delimiter);
#endif


#ifdef Deutsch
  printf ("OUT Port LPT address.: %#x.%c", Conf.OUT_PORT, delimiter);
#ifdef DEBUG
  printf (" Tempo Debug....: %d%c", Conf.Sleep, delimiter);
#endif
  printf (" HTML Update..: %d Mn%c", Conf.Mn, delimiter);
  printf ("Number of sensors....: %d ", Conf.C - 3);
  printf ("CAN 12 Bits MAX186 & 3 Direct LPT  Uref: %0.3f Volts%c", Uref,
	  delimiter);
  printf ("HTML directorie......: %s", Conf.METEO_HTML_DIR);
  printf (" HTML link : %s%c", Conf.HTMLLink, delimiter);

  printf ("Locator..............: %s", Conf.locator);
  if (strlen (Conf.latitude) >= 8 && strlen (Conf.longitude) >= 8)
    {
      printf ("  Lat/Long => %s - %s%c", Conf.latitude, Conf.longitude,
	      delimiter);
    }
  else
    printf ("  Lat/Long => %07.2f%s - %08.2f%s%c", aprs.location[0],
	    aprs.sgnla, aprs.location[1], aprs.sgnlo, delimiter);

  printf ("QTH..................: %s.", Conf.qth);
  printf (" Alt...: %d meters.%c", Conf.altitude, delimiter);
#endif


  if (Conf.Mn > 5)
    {
      printf ("APRS WX beacon0 via..: %s on port %s%c",
	      Conf.Digi[0], Conf.Port[0], delimiter);
      printf ("APRS WX beacon1 via..: %s on port %s%c",
	      Conf.Digi[1], Conf.Port[1], delimiter);
    }
  printf ("Linux Distrib........: %s%c", Conf.LINUX, delimiter);

  ssid = strchr (Conf.SysOp, '-');
  if (ssid != NULL)
    {
      i = (strlen (Conf.SysOp) - 2);
      Conf.SysOp[i] = ' ';
      Conf.SysOp[i + 1] = ' ';
    }
  printf ("SySop: %s  ax25Call: %s", Conf.SysOp, Conf.ax25Call);
  printf ("  IdConvers: %s Convers: %s%c",
	  Conf.ConvIdent, Conf.Ax25Convers, delimiter);
}

/* Date format francais */
void
Date_fr (void)
{
  time_t t;
  t = time (NULL);
  tb = localtime (&t);
#ifdef French
  printf ("Date systme: %s %d %s %d %2.2d:%2.2d ", Jours[tb->tm_wday],
	  tb->tm_mday, Mois[tb->tm_mon], tb->tm_year + 1900, tb->tm_hour,
	  tb->tm_min);
#endif
#ifdef English
  printf ("System date: %s %d %s %d %2.2d:%2.2d ", Jours[tb->tm_wday],
	  tb->tm_mday, Mois[tb->tm_mon], tb->tm_year + 1900, tb->tm_hour,
	  tb->tm_min);
#endif
#ifdef Deutsch
  printf ("System date: %s %d %s %d %2.2d:%2.2d ", Jours[tb->tm_wday],
	  tb->tm_mday, Mois[tb->tm_mon], tb->tm_year + 1900, tb->tm_hour,
	  tb->tm_min);
#endif

  printf ("%c", delimiter);
}

/* init date dans tableau */
void
init_date (void)
{
  time_t t;
  time (&t);
  tab[0][2][0][1] = t;
}

/* Effacement de l'ecran */
void
Clr_scr (void)
{
  printf ("\033c");		/* reset terminal */
}

/* Affichage date */
void
Print_Date (void)
{
  time_t t;
  time (&t);
#ifdef French
  printf ("Date systme: %s", ctime (&t));
#endif

#ifdef English
  printf ("System date: %s", ctime (&t));
#endif

#ifdef Deutsch
  printf ("System date: %s", ctime (&t));
#endif

}

/* Ouverure du fichier Open_Meteo) */
void
Open_Data (void)
{
  FILE *fic;
  FILE *msg;
  int c;
  if ((fic = fopen (METEO_DATA_FILE, "r")) == NULL)
    {
#ifdef French
      printf ("meteo.dat non trouv ! %c", delimiter);
#endif
#ifdef French
      printf ("meteo.dat not found ! %c", delimiter);
#endif
#ifdef Deutsch
      printf ("meteo.dat not found ! %c", delimiter);
#endif

      msg = fopen (MSG_METEO_DATA_FILE, "a");
      fprintf (msg, "%s %d %s %d %2.2d:%2.2d-->AXMETEO File %s not found.\n",
	       Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
	       tb->tm_year + 1900, tb->tm_hour, tb->tm_min, METEO_DATA_FILE);
      fclose (msg);
      exit (0);
    }
  (fic = fopen (METEO_DATA_FILE, "r"));
  fread (&tab, 4, (Conf.C * 3 * 3 * M), fic);
  fclose (fic);

  for (c = 0; c < Conf.C; c++)
    {
      Valeurs[c].Maxi = tab[c][0][0][0];
      Valeurs[c].Inst = tab[c][0][1][0];
      Valeurs[c].Mini = tab[c][0][2][0];
      
      

      Valeurs[c].Date_Maxi = tab[c][1][0][0];
      Valeurs[c].Date_Inst = tab[c][1][1][0];
      Valeurs[c].Date_Mini = tab[c][1][2][0];
/* 

   Valeurs crete	= tab[c][0][0][1];
   Date crete 		= tab[c][1][0][1];   
   Date min 		= tab[c][1][0][2];      
   
   Valeurs compteur     = tab[0][2][0][0];
   Valeurs Date_Init    = tab[0][2][0][1];
   it (en secondes)     = tab[0][2][0][2];
   temps t              = tab[0][2][0][3];
   temps t-1            = tab[0][2][0][4];
   compteurmaj		= tab[0][2][0][5];
   alarme1		= tab[0][2][0][8];
   alarme2		= tab[0][2][0][9];
   compteur depuis 0H	= tab[0][2][0][10+c];
   Valeurs hist mesures  [c][2][1][0----M] 
   valeurs hist dates    [c][2][2][0----M]  
*/
    }
  compteur = tab[0][2][0][0];
  compteurmaj = tab[0][2][0][5];
  return;
}

/* Affichage Compteur de mesures */
void
Print_Compteur (void)
{
  long int v;
  compteur = tab[0][2][0][0];
  v = tab[0][2][0][1];
  tb = localtime (&v);
#ifdef French
  printf ("%ld acquisitions depuis l'init du %s %d %s %d %2.2d:%2.2d %c",
	  compteur, Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
	  tb->tm_year + 1900, tb->tm_hour, tb->tm_min, delimiter);
#endif
#ifdef English
  printf ("%ld acquisitions since init of %s %d %s %d %2.2d:%2.2d %c",
	  compteur, Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
	  tb->tm_year + 1900, tb->tm_hour, tb->tm_min, delimiter);
#endif
#ifdef Deutsch
  printf ("%ld acquisitions since init of %s %d %s %d %2.2d:%2.2d %c",
	  compteur, Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
	  tb->tm_year + 1900, tb->tm_hour, tb->tm_min, delimiter);
#endif

}

/* Affichage date depuis le fichier (Maxi Temp)*/
void
Print_Dat_Init (void)
{
  long int v;
  v = tab[0][2][0][1];
  tb = localtime (&v);
#ifdef French
  printf ("Date de l'init: %s %d %s %d %2.2d:%2.2d %c", Jours[tb->tm_wday],
	  tb->tm_mday, Mois[tb->tm_mon], tb->tm_year + 1900, tb->tm_hour,
	  tb->tm_min, delimiter);
#endif
#ifdef English
  printf ("Init Date: %s %d %s %d %2.2d:%2.2d %c", Jours[tb->tm_wday],
	  tb->tm_mday, Mois[tb->tm_mon], tb->tm_year + 1900, tb->tm_hour,
	  tb->tm_min, delimiter);
#endif
#ifdef Deutsch
  printf ("Init Date: %s %d %s %d %2.2d:%2.2d %c", Jours[tb->tm_wday],
	  tb->tm_mday, Mois[tb->tm_mon], tb->tm_year + 1900, tb->tm_hour,
	  tb->tm_min, delimiter);
#endif


}


void
Entete (void)
{
/* Clr_scr();*/
  /* printf("%c",delimiter); */
#ifdef French
  printf ("[METEO-Linux Version: %sFr] F5EXO (2000-2006) PID:%d%c",
	  METEO_VERSION, (getpid ()), delimiter);
#endif
#ifdef English
  printf ("[WEATHER-Linux Version: %sEn] F5EXO (2000-2006) PID:%d%c",
	  METEO_VERSION, (getpid ()), delimiter);
#endif
#ifdef Deutsch
  printf ("[WETTER-Linux Version: %sDl] F5EXO (2000-2006) PID:%d%c",
	  METEO_VERSION, (getpid ()), delimiter);
#endif


}


/* Conversion Unites */
int
Farenheit (float z)		/* Conversion degres oC - Farenheit */
{
  z = ((9 * z / 5) + 32);
  return (z);
}

int
Kelvin (float z)		/* Conversion degres oC - Kelvin */
{
  z = (273.15 + z);
  return (z);
}

int
Girouette (float z)		/* Conversion degres - Cardinal */
{
  z = (z / 22.4);
  return (z);
}

int
Vent (float z)			/* Conversion m/s - Km/h */
{
  z = (z * 3.6);
  return (z);
}

int
Noeud (float z)			/* Conversion m/s - Noeuds Miles */
{
  z = (z / 1.852);
  return (z);
}

int
Mercure (float z)		/* Conversion hPa - mm Hg */
{
  z = (z * 0.750);
  return (z);
}

int
Force (float z)			/* Conversion m/s - Beaufort */
{
  z = (z * 3.6);
  z = ((z * z) / 9);
  z = (pow (z, 0.333));
  return (z);
}

int
Inch (float z)			/* Conversion mm - inch */
{
  z = (z / 0.254);
  return (z);
}



void
tambour (void)
{
  int i;
  int j = 0;
  long int v;

//  for (c = Conf.C -3; c < Conf.C; c++)
//          {
//         printf("Capteur No %1.1d\n",c);
  for (i = 0; i < M + 1; i++)
    {
      v = tab[10][2][2][i];
      tb = localtime (&v);

      if ((tab[10][2][1][i]) != 0)
	{
	  printf ("%2.2d:%2.2d *", tb->tm_hour, tb->tm_min);
	  printf ("No:%d * %ld ", i, tab[10][2][1][i]);
	}
      else
	{
	  printf ("%2.2d:%2.2d >", tb->tm_hour, tb->tm_min);
	  printf ("No:%d ", i);
	}
      j = j + 1;
      if (j == 4)
	{
	  printf ("\n");
	  j = 0;
	}
    }
  printf ("\n");

//      }

}

/* Affiche le details pour tous les capeurs */
void
Print_Analog (void)
{
  int c, i;
  float z;
  /*   printf ("%c",delimiter);  */
  if (Conf.C > 3)
    {
      printf
	("==============================================================================%c",
	 delimiter);

      printf ("%7.7s ", Legend[7]);
      printf ("%9.7s ", Legend[8]);
      printf ("%11.7s", Legend[0]);
      printf ("%9.4s", Legend[1]);
      printf ("%9.9s", Legend[2]);
      printf ("%9.4s", Legend[3]);
      printf ("%13.7s", Legend[4]);
      printf ("%9.7s", Legend[10]);
      printf ("%c", delimiter);
      printf
	("------------------------------------------------------------------------------%c",
	 delimiter);

      for (c = 0; c < Conf.C - 3; c++)
	{
	  if (capteurs[c].Unites != 0)
	    {
	      /* positionnement de * si voie en alarme */
	      if (((Alarms[0].Channel == c) && (tab[0][2][0][8] == 1)) ||
		  ((Alarms[1].Channel == c) && (tab[0][2][0][9] == 1)))
		{
//                rouge ();
//                clignotant ();
		  printf ("*");
//                resetcouleur ();
//                jaune ();
		  printf (" %1.1d", c);
		}
	      else
		printf ("  %1.1d", c);

	      printf ("%14.14s", capteurs[c].Mesure);
	      printf ("%12.11s", capteurs[c].sensor);
// affichage  Maxi Actuelle  Mini
	      for (i = 0; i < 3; i++)
		{
		  z =
		    ((tab[c][0][i][0] * CAD) -
		     capteurs[c].Offset) / capteurs[c].Unites;
		  printf ("%9.1f", z);
		}
	      printf ("%13.13s", capteurs[c].Unite);
		  z =
		    ((tab[c][0][0][1] * CAD) -
		     capteurs[c].Offset) / capteurs[c].Unites;
	      
	      printf ("%9.1f%c", z,delimiter);
	    }
	}
      printf
	("-------------------------------------------------------------------------------%c",
	 delimiter);
    }

  /* Direct LPT port */
  if ((capteurs[Conf.C - 1].Unites != 0) || (capteurs[Conf.C - 2].Unites != 0)
      || (capteurs[Conf.C - 3].Unites != 0))
    {
      printf ("%6.7s ", Legend[7]);
      printf ("%9.7s ", Legend[8]);
      printf ("%11.7s", Legend[0]);
      printf ("%11.9s", rain[0]);
      printf ("%11.9s", Legend[2]);
      printf ("%11.9s", rain[1]);
      printf ("%7.7s", Legend[4]);
      printf ("%9.9s", rain[2]);
      printf ("%c", delimiter);
      printf
	("-------------------------------------------------------------------------------%c",
	 delimiter);
    }
  for (c = Conf.C - 3; c < Conf.C; c++)
    {
      if (capteurs[c].Unites != 0)
	{
	  /* positionnement de * si voie en alarme */
	  if (((Alarms[0].Channel == c) && (tab[0][2][0][8] == 1)) ||
	      ((Alarms[1].Channel == c) && (tab[0][2][0][9] == 1)))
	    {
	      if (c >= 10)
		{
//                rouge ();
//                clignotant ();
		  printf ("*");
//                resetcouleur ();
//                jaune ();
		  printf ("%1.2d", c);
		}
	      else
		{
//                rouge ();
//                clignotant ();
		  printf ("*");
//                resetcouleur ();
//                jaune ();
		  printf (" %1.1d", c);
		}
	    }
	  else if (c < 10)
	    {
	      printf ("  %1.1d", c);
	    }
	  else
	    {
	      printf (" %1.1d", c);
	    }
	  printf ("%14.14s", capteurs[c].Mesure);
	  printf ("%12.11s", capteurs[c].sensor);
	  for (i = 0; i < 3; i++)
	    {
	      printf ("%11.0f", tab[c][0][i][0] * capteurs[c].Unites);
	    }
/*      printf ("%11.13s%c", capteurs[c].Unite, delimiter);*/
	  printf ("%7.7s", capteurs[c].Unite);
	  /* + valeur depuis minuit */
	  printf ("%9.0f%c", tab[0][2][0][c + 10] * capteurs[c].Unites,
		  delimiter);
	}
    }
  if ((capteurs[Conf.C - 1].Unites != 0) || (capteurs[Conf.C - 2].Unites != 0)
      || (capteurs[Conf.C - 3].Unites != 0))
    {
      printf
	("===============================================================================%c",
	 delimiter);
    }
/*   printf("%c",delimiter);*/
}



/* Affiche le tableau pour les capteurs C parametres depuis le fichier ) */
void
Print_Detail (long ta[Conf.C][3][3][M], int c)
{
  short int i, ret, m = 0, l = 0;
  long j;
  float z;
  long int v;
  if ((c >= Conf.C) || (capteurs[c].Unites == 0))
    {
      printf ("Channel not active !%c", delimiter);
      return;
    }
  if (c < Conf.C - 3)
    {
      printf ("%c", delimiter);
      printf ("%7.7s ", Legend[7]);
      printf ("%9.7s ", Legend[8]);
      printf ("%11.7s", Legend[0]);
      printf ("%9.4s", Legend[1]);
      printf ("%9.9s", Legend[2]);
      printf ("%9.4s", Legend[3]);
      printf ("%14.7s", Legend[4]);
      printf ("%c", delimiter);
      printf
	("----------------------------------------------------------------------%c",
	 delimiter);
      printf ("%1.1d ", c);
      printf ("%15.14s", capteurs[c].Mesure);
      printf ("%12.11s", capteurs[c].sensor);
      for (j = 0; j < 3; j++)
	{
	  z =
	    ((ta[c][0][j][0] * CAD) -
	     capteurs[c].Offset) / capteurs[c].Unites;
	  printf ("%9.2f", z);
	}
      printf ("%14.13s", capteurs[c].Unite);
      printf ("%c", delimiter);
    }
  if (c >= Conf.C - 3)
    {
      printf
	("-------------------------------------------------------------------------------%c",
	 delimiter);
      printf ("%7.7s ", Legend[7]);
      printf ("%8.7s ", Legend[8]);
      printf ("%11.7s", Legend[0]);
      printf ("%11.9s", rain[0]);
      printf ("%10.9s", Legend[2]);
      printf ("%10.9s", rain[1]);
      printf ("%10.7s", Legend[4]);
      printf ("%10.9s", rain[2]);
      printf ("%c", delimiter);
      printf
	("-------------------------------------------------------------------------------%c",
	 delimiter);

      if (c >= 10)
	{
	  printf ("%1.2d", c);
	}
      else
	{
	  printf (" %1.1d", c);
	}

      printf ("%14.14s", capteurs[c].Mesure);
      printf ("%12.11s", capteurs[c].sensor);
      for (i = 0; i < 3; i++)
	{
	  printf ("%10.3f", ta[c][0][i][0] * capteurs[c].Unites);
	}
      printf ("%11.13s", capteurs[c].Unite);
      printf ("%10.3f%c", tab[0][2][0][c + 10] * capteurs[c].Unites,
	      delimiter);
      printf ("                            ");
      if ((strcasecmp (capteurs[c].Mesure, "Rain") == 0) ||
	  (strcasecmp (capteurs[c].Mesure, "Regen") == 0) ||
	  (strcasecmp (capteurs[c].Mesure, "Pluie") == 0))
	{
	  for (i = 0; i < 3; i++)
	    {
	      printf ("%10.3d", Inch (ta[c][0][i][0] * capteurs[c].Unites));
	    }
	  printf ("%11.13s", "Inch");
	  printf ("%10.3d%c",
		  Inch (tab[0][2][0][c + 10] * capteurs[c].Unites),
		  delimiter);

	}
    }
  printf ("                            ");
  for (j = 0; j < 3; j++)
    {
      z = ((ta[c][0][j][0] * CAD) - capteurs[c].Offset) / capteurs[c].Unites;
      if (strcasecmp (capteurs[c].Unite, "Celsius") == 0)
	{
	  printf ("%9.3d", Farenheit (z));
	}

      else if (strcasecmp (capteurs[c].Unite, "M/s") == 0)
	{
	  printf ("%9.3d", Vent (z));
	}

      else if (strcasecmp (capteurs[c].Unite, "Degres") == 0)
	{
	  printf ("%9.5s", (Cadran[Girouette (z)]));
	}

      else if (strcasecmp (capteurs[c].Unite, "hPa") == 0)
	{
	  printf ("%9.3d", Mercure (z));
	}
    }
  if (strcasecmp (capteurs[c].Unite, "Celsius") == 0)
    {
      printf ("%6.9s", " ");
      printf ("Farenheit");
    }

  else if (strcasecmp (capteurs[c].Unite, "M/s") == 0)
    {
      printf ("%7.9s", " ");
#ifdef French
      printf ("Km/Heure");
#endif
#ifdef English
      printf ("Km/Hour");
#endif

#ifdef Deutsch
      printf ("Km/Hour");
#endif

    }

  else if (strcasecmp (capteurs[c].Unite, "Degres") == 0)
    {
      printf ("%7.9s", " ");
      printf ("Cardinal");
    }

  else if (strcasecmp (capteurs[c].Unite, "hPa") == 0)
    {
      printf ("%10.9s", " ");
      printf ("mm Hg");
    }

  printf ("%c", delimiter);
  printf ("                            ");
  for (j = 0; j < 3; j++)
    {
      z = ((ta[c][0][j][0] * CAD) - capteurs[c].Offset) / capteurs[c].Unites;
      if (strcasecmp (capteurs[c].Unite, "Celsius") == 0)
	{
	  printf ("%9.3d", Kelvin (z));
	}
      else if (strcasecmp (capteurs[c].Unite, "M/s") == 0)
	{
	  printf ("%9.2s", (Beaufort[Force (z)]));
	}
    }
  if (strcasecmp (capteurs[c].Unite, "Celsius") == 0)
    {
      printf ("%9.11s", " ");
      printf ("Kelvin%c", delimiter);
    }

  else if (strcasecmp (capteurs[c].Unite, "M/s") == 0)
    {
      printf ("%1.14s", " ");
      printf ("Force/Beaufort%c", delimiter);
    }

  printf ("%c", delimiter);
  printf ("La valeur %s", Legend[1]);
  tb = localtime (&Valeurs[c].Date_Maxi);
  printf (" relevee le    : %s %d %s %d %2.2d:%2.2d %c",
	  Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
	  tb->tm_year + 1900, tb->tm_hour, tb->tm_min, delimiter);

  printf ("La valeur %s", Legend[2]);
  tb = localtime (&Valeurs[c].Date_Inst);
  printf (" relevee le: %s %d %s %d %2.2d:%2.2d %c", Jours[tb->tm_wday],
	  tb->tm_mday, Mois[tb->tm_mon], tb->tm_year + 1900, tb->tm_hour,
	  tb->tm_min, delimiter);

  printf ("La valeur %s", Legend[3]);
  tb = localtime (&Valeurs[c].Date_Mini);
  printf (" releve le    : %s %d %s %d %2.2d:%2.2d %c",
	  Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
	  tb->tm_year + 1900, tb->tm_hour, tb->tm_min, delimiter);
  printf ("%c", delimiter);

  {

    j = 0;
    printf ("(A)rret - (CR)continue");
    fflush (stdout);
    ret = getchar ();
    if ((ret == 97) || (ret == 65))
      {
	return;
      }
    printf ("%s: %d Historique %s en %s%c", Legend[7], c,
	    capteurs[c].Mesure, capteurs[c].Unite, delimiter);
//    tb = localtime (&Valeurs[c].Date_Inst);
    tb = localtime (&ta[c][2][2][M-2]);
    printf (" %2.2d:%2.2d --> ", tb->tm_hour, tb->tm_min);
    for (i = M - 2; i > 0; i--)
      {
          // affichage de la plus recente date
//          tb = localtime (&ta[c][2][2][i]);
//          printf (" %2.2d:%2.2d --> ", tb->tm_hour, tb->tm_min);                
	/* Afficher que valeur vraies  tester si compteur < a M */
	if ((compteurmaj < M-2) & (m == compteurmaj))
	  {
	    break;
	  }
         // Test si port direct LPT impulsion * par multiplicateur
         if (c >= Conf.C-3)
	{
	  z = (ta[c][2][1][i] *  capteurs[c].Unites);
	}

        else
	{
      	z =
	  ((ta[c][2][1][i] * CAD) - capteurs[c].Offset) / capteurs[c].Unites;
        }
	printf ("%8.1f", z);
	j++;
	if ((j % 8 == 0) && (i != 6))
	  {
	    printf ("%c", delimiter);
	    if (l == 22)
	      {
		printf ("(A)rret - (CR)continue");
		fflush (stdout);
		ret = getchar ();
		if ((ret == 97) || (ret == 65))
		  {
		    break;
		  }
		l = 0;
	      }
	     v = tab[c][2][2][i-1];	
	    tb = localtime (&v);
	    printf (" %2.2d:%2.2d --> ", tb->tm_hour, tb->tm_min);
	    l++;
	  }
	m++;
      }
    printf ("%c", delimiter);
    j = 0;
    printf ("%c", delimiter);
  }

}


/* Affichage valeur histo binaires [c][6] a C[11] */
void
Print_Histo_Data (void)
{
  int c, m, i;
#ifdef French
  printf
    ("Historique des 10 dernires valeurs digitales (sortie CAD 0-4095).%c%c",
     delimiter, delimiter);
#endif
#ifdef English
  printf
    ("Last 10 historic's digitals values (Out CAD 0-4095).%c%c",
     delimiter, delimiter);
#endif

#ifdef Deutsch
  printf
    ("Liste der Sensor-Rohdaten anzeigen (Out CAD 0-4095).%c%c",
     delimiter, delimiter);
#endif


  for (c = 0; c < Conf.C; c++)
    {
      if (capteurs[c].Unites != 0)
	{
	  m = 0;
	  if (c < 10)
	    {
	      printf ("Ch: %1.1d ", c);
	    }
	  else
	    {
	      printf ("Ch:%1.1d ", c);
	    }
	  printf ("%14.14s", capteurs[c].Mesure);
	  for (i = (M - 2); i > ((M - 2) - 10); i--)
	    {
	      printf ("%5.4ld", tab[c][2][1][i]);
	      m++;
	      if ((compteurmaj < M) & (m == compteurmaj))
		{
		  printf ("%c", delimiter);
		  break;
		}
	    }
	  printf ("%c", delimiter);
	}
    }
  printf ("%c", delimiter);
}

/* Affichage valeur histo analogiques [c][6] a C[11] */
void
Print_Histo_Analog (void)
{
  int ret, c, i, m, j = 0, l = 0;
  float z;
  long int v;
#ifdef French
  printf ("Historique des valeurs analogiques.%c", delimiter);
#endif
#ifdef English
  printf ("Analogics historic values.%c", delimiter);
#endif
#ifdef Deutsch
  printf ("Liste der Messwerte anzeigen.%c", delimiter);
#endif



  printf ("%c", delimiter);
  for (c = 0; c < Conf.C; c++)
    {
      if (capteurs[c].Unites != 0)
	{
	  m = 0;
	  v = tab[c][2][2][M-2];
	  printf ("%s: %d %s en %s%c", Legend[7], c, capteurs[c].Mesure,
		  capteurs[c].Unite, delimiter);
	  tb = localtime (&v);
	  printf (" %2.2d:%2.2d --> ", tb->tm_hour, tb->tm_min);

	  for (i = M - 2; i > 0; i--)
	    {
	      if ((compteurmaj < M-2) & (m == compteurmaj))
		{
		  break;
		}

	      z =
		((tab[c][2][1][i] * CAD) -
		 capteurs[c].Offset) / capteurs[c].Unites;
	      printf ("%8.1f", z);
	      j++;
	      v = tab[c][2][2][i-1];
	      if ((j % 8 == 0) && (i != 6))
		{
		  printf ("%c", delimiter);

		  if (l == 22)
		    {
		      printf ("(A)rret - (CR)continue");
		      fflush (stdout);
		      ret = getchar ();
		      l = 0;
		      if ((ret == 97) || (ret == 65))
			{
			  return;
			}
		    }

		  tb = localtime (&v);
		  printf (" %2.2d:%2.2d --> ", tb->tm_hour, tb->tm_min);
		  l++;
		}
	      m++;
	    }
	  printf ("%c", delimiter);
	  j = 0;
	}
    }
}

/* Visu Fichier Texte */
void
catfile (char *fname)
{
  FILE *f;
  int c, ret, l = 0;
  f = fopen (fname, "r");
  if (!f)
    {
      perror (fname);
    }
  else
    {
      while ((c = fgetc (f)) != EOF)
	{
	  if (c == '\n')
	    {
	      c = delimiter;
	      l++;
	    }
	  if (l == 22)
	    {			/* pagination a 22 ligne */
	      printf ("\n(A)rret - (CR)continue");
	      fflush (stdout);
	      ret = getchar ();
	      l = 0;
	      if ((ret == 97) || (ret == 65))
		{
		  return;
		}
	    }
	  putchar (c);
	}
      fclose (f);
    }
}

/* 
Tendance */
/*
    Tendance du baromtre	hPa par heure	volution du temps
    monte			0,25  0,5      venue d'une haute pression( long terme)
    monte			1  2           moyenne pression ( court terme)
    descente			0,25  0,5	venue d'une basse pression( long terme)
    descente			1  2           tempte ; en t, orage.
*/
char *
Tendance (void)
{
  int i;
  float y, delta, z = 0;
  long deltatime;
  deltatime = (60 / Conf.Mn);
  if (compteur < deltatime)
    {
      return retendance;
    }

  for (i = 0; i < Conf.C; i++)
    {
      /* detection de l'utilisation de l'unite hPa */
      if (strcasecmp (capteurs[i].Unite, "hPa") == 0)
	{
	  z =
	    ((tab[i][0][1][0] * CAD) -
	     capteurs[i].Offset) / capteurs[i].Unites;
	  y =
	    ((tab[i][2][1][((M - 2) - deltatime)] * CAD) -
	     capteurs[i].Offset) / capteurs[i].Unites;
	  /* printf ("z: %4.2f y: %4.2f ",z,y); */
	  delta = z - y;
/*       printf ("Ecart pression derniere heure: %+4.4f %s \n",delta,capteurs[i].Unite);*/
	  strcpy (retendance, "/\\_/ Tendance evolution ");
	  if (z < y);
	  {
	    if ((delta >= -2) && (delta <= -1))
	      {
		strcat (retendance, "Risque de tempete ou orage.");
		strcat (retendance, " -**-");
		return retendance;
	      }
	    if ((delta >= (-0.51)) && (delta <= (-0.24)))
	      {
		strcat (retendance,
			"en baisse,venue d'une basse pression a long terme.");
		strcat (retendance, " -**-");
		return retendance;
	      }
	  }
	  if (z > y);
	  {
	    if ((delta >= 1) && (delta <= 2))
	      {
		strcat (retendance,
			"a la hausse a court terme. (moyenne pression).");
		strcat (retendance, " +**+");
		return retendance;
	      }
	    if ((delta >= 0.24) && (delta <= 0.51))
	      {
		strcat (retendance,
			"en hausse,venue d'une haute pression a long terme.");
		strcat (retendance, " +**+");
		return retendance;
	      }
	  }
	  strcat (retendance, "stable. =**=");
	}
    }
  return (retendance);
}


void
control_Alarm (void)
{
  int c;
  printf ("\n\n");
  for (c = 0; c < 2; c++)
    {
      printf ("Alarm%d Channel %d  Seuil %s %d %s\n", c, Alarms[c].Channel,
	      Alarms[c].Comp, Alarms[c].Seuil,
	      capteurs[Alarms[c].Channel].Unite);
    }

}
