/*                  HamRadioAX25 F5EXO@@F6KSU.FPDL.FRA.EU                  */
/*                           mail:f5exo@free.fr                            */
/*                     Web:http://f5exo.free.fr/meteo/                     */
/*                            Erick LINE                                   */

/* Pin 11 LPT (busy) utilise en entree pour recevoir sous forme serie      */
/* Pin 2  LPT (D0) utilisee pour generee l'horloge SCLK                    */
/* Pin 3  LPT (D1) utilisee pour generee CS                                */
/* Pin 4  LPT (D2) utilisee pour envoyer les donnees vers le MAX186.       */
/*                                                                         */
/* Pin 15 LPT (/ERROR)     Bit 3   (comptage impulsions) In                */
/* Pin 13 LPT (/SELECT)    Bit 4   (comptage impulsions) In                */
/* Pin 12 LPT (/PAPER OUT) Bit 5   (comptage impulsions) In                */
/*                                                                         */
/* Pin 17 LPT (Select_IN)  Bit 3   (Alarm 2) Out                           */
/* Pin 16 LPT (INIT)       Bit 2   (Alarm 1) Out                           */
/*                                                                         */
/*                   Calcul Valeur analogique                              */
/*           Val analog = (DATA*(Uref/CAN)-Offset)/Unites                  */
/*           Ou DATA    = valeur digitale lue en sortie CAN                */
/*              Uref    = Tension de reference du CAN  4.096               */
/*              CAD     = CAN 12 bits pour MAX186                          */
/*              Offset  = valeur offset du composant capteur               */
/*              Unites  = facteur mutiplicateur du composant capteur       */

/*-------------------------DEBUT DE LA PARTIE CONFHTML-------------------------*/

void
Conf_html (void)
{
  FILE *fic;
  int i;
  char METEO_CONF_HTML_FILE[15] = { "meteocfg.html" };
  char htmlfic[80] = { };
  strcpy (htmlfic, Conf.METEO_HTML_DIR);
  fic = fopen (strcat (htmlfic, METEO_CONF_HTML_FILE), "w");
  fprintf (fic, "<HTML><HEAD><TITLE>[CONFIGURATION SYSTEME METEO version %s]",
	   METEO_VERSION);
  fprintf (fic, "</TITLE>");

  fprintf (fic, "<META HTTP-EQUIV=\"Pragma\"  CONTENT=\"no-cache\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"generator\" CONTENT=\"METEO Linux Version %s\">\n",
	   METEO_VERSION);
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Author\"    CONTENT=\"LINE Erick F5EXO\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Keywords\"  CONTENT=\"METEO,AX25,MAX186,F5EXO\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Description\"   CONTENT=\"Linux ax25 meteo server configuration\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Content-Type\"  CONTENT=\"text/html; charset=iso-8859-1\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"image/x-xbitmap%c%c\">\n",
	   10, 10);

  fprintf (fic, "<META HTTP-EQUIV=\"Window-target\" CONTENT=\"_top\">\n");

  fprintf (fic, "</HEAD>");
  fprintf (fic,
	   "<BODY BGCOLOR=\"#990909\" TEXT=\"#000000\" LINK=\"#0000FF\" VLINK=\"#800080\" ALINK=\"#0000FF\">\n");
  fprintf (fic,
	   "<CENTER><FONT SIZE=-1 COLOR=\"#FFF000\"><B>[METEO Linux version %s]</B></FONT><BR>\n",
	   METEO_VERSION);
#ifdef French
  fprintf (fic,
	   "<FONT COLOR=\"#FFF000\"><B>CONFIGURATION SYSTEME</B></FONT></CENTER>\n");
#endif
#ifdef English
  fprintf (fic,
	   "<FONT COLOR=\"#FF00FF\"><B>SYSTEM CONFIGURATION</B></FONT></CENTER>\n");
#endif
#ifdef Deutzch
  fprintf (fic,
	   "<FONT COLOR=\"#FF00FF\"><B>SYSTEM CONFIGURATION</B></FONT></CENTER>\n");
#endif

  fprintf (fic, "<CENTER>\n");
  fprintf (fic, "<TABLE BGCOLOR=\"#990909\" BORDER=\"0\">\n");
  fprintf (fic, "<TR ALIGN=\"CENTER\">\n");
#ifdef French
  fprintf (fic,
	   "<TD><FONT COLOR=\"#FFF000\"><B> Platforme Linux %s </B></FONT></TD>\n",
	   Conf.LINUX);
#endif
#ifdef English
  fprintf (fic,
	   "<TD><FONT COLOR=\"#2200FF\"><B> Linux Platform %s </B></FONT></TD>\n",
	   Conf.LINUX);
#endif
#ifdef Deutzch
  fprintf (fic,
	   "<TD><FONT COLOR=\"#2200FF\"><B> Linux Platform %s </B></FONT></TD>\n",
	   Conf.LINUX);
#endif

  fprintf (fic, "</TR>\n");
  fprintf (fic, "</TABLE>\n");
  fprintf (fic, "</CENTER>\n");
  fprintf (fic, "<CENTER>\n");
  fprintf (fic, "<TABLE BGCOLOR=\"#E4E2D6\" BORDER=\"1\">\n");
  fprintf (fic, "<TR ALIGN=\"CENTER\">\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#2200FF\"><B> SysOp </B></FONT></TD>\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#2200FF\"><B> Locator </B></FONT></TD>\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#2200FF\"><B> QTH </B></FONT></TD>\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#2200FF\"><B> Altitude </B></FONT></TD>\n");
  fprintf (fic, "</TR>\n");
  fprintf (fic, "<TR ALIGN=\"CENTER\">\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\"><B> %s </B></FONT></TD>\n",
	   Conf.SysOp);
  if (strlen (Conf.latitude) >= 8 && strlen (Conf.longitude) >= 8)
    {
      fprintf (fic,
	       "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\"><B> %s %s/%s </B></FONT></TD>\n",
	       Conf.locator, Conf.latitude, Conf.longitude);
    }
  else
    {
      fprintf (fic,
	       "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\"><B> %07.2f%s/%08.2f%s </B></FONT></TD>\n",
	       aprs.location[0], aprs.sgnla, aprs.location[1], aprs.sgnlo);
    }
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\"><B> %s </B></FONT></TD>\n",
	   Conf.qth);
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\"><B> %d Metres </B></FONT></TD>\n",
	   Conf.altitude);
  fprintf (fic, "</TR>\n");
  fprintf (fic, "</TABLE>\n");

  fprintf (fic, "<TABLE BGCOLOR=\"#E4E2D6\" BORDER=\"3\">\n");
  fprintf (fic, "<TR ALIGN=\"CENTER\">\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\">");
  fprintf (fic, "<B> %s </B>", Legend[7]);
  fprintf (fic, "</FONT>\n</TD>\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\">");
  fprintf (fic, "<B> %s </B>", Legend[0]);
  fprintf (fic, "</FONT>\n</TD>\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\">");
  fprintf (fic, "<B>  MESURE </B>");
  fprintf (fic, "</FONT>\n</TD>\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\">");
  fprintf (fic, "<B> Offset </B>");
  fprintf (fic, "</FONT>\n</TD>\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\">");
  fprintf (fic, "<B> Multiplicateur </B>");
  fprintf (fic, "</FONT>\n</TD>\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\">");
  fprintf (fic, "<B> %s </B>", Legend[4]);
  fprintf (fic, "</FONT>\n</TD>\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF00FF\">");
  fprintf (fic, "<B> %s </B>", Legend[9]);
  fprintf (fic, "</FONT>\n</TD>\n");

  fprintf (fic, "</TR>\n");

  for (i = 0; i < Conf.C; i++)
    {
      fprintf (fic,
	       "<TR ALIGN=\"CENTER\">\n<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#2200FF\">");
      fprintf (fic, "<B>  %d </B>", i);
      fprintf (fic, "</FONT>\n</TD>\n");
      fprintf (fic,
	       "<TH><FONT FACE=\"time new roman\" size=\"1\"> %s</FONT></TH>\n",
	       capteurs[i].sensor);
      fprintf (fic,
	       "<TH><FONT FACE=\"time new roman\" size=\"1\"> %s</FONT></TH>\n",
	       capteurs[i].Mesure);
      fprintf (fic,
	       "<TH><FONT FACE=\"time new roman\" size=\"1\"> %f</FONT></TH>\n",
	       capteurs[i].Offset);
      fprintf (fic,
	       "<TH><FONT FACE=\"time new roman\" size=\"1\"> %f</FONT></TH>\n",
	       capteurs[i].Unites);
      fprintf (fic,
	       "<TH><FONT FACE=\"time new roman\" size=\"1\"> %s</FONT></TH>\n",
	       capteurs[i].Unite);

      if (strcasecmp (capteurs[i].Comp, "!") != 0)
	{
	  fprintf (fic,
		   "<TH><FONT COLOR=\"#FF0000\" FACE=\"time new roman\" size=\"1\">%s %5.3f</FONT></TH>\n",
		   capteurs[i].Comp, capteurs[i].Seuil);
	}
      else
	{
	  fprintf (fic,
		   "<TH><FONT FACE=\"time new roman\" size=\"1\"><PR>%s%5.3f</PR></FONT></TH>\n",
		   capteurs[i].Comp, capteurs[i].Seuil);
	}
      fprintf (fic, "</TR>\n");
    }
  fprintf (fic, "</TABLE>\n");


  fprintf (fic, "<TABLE BGCOLOR=\"#E4E2D6\" BORDER=\"2\">\n");
  fprintf (fic, "<TR ALIGN=\"CENTER\">\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#2200FF\"><B> Port LPT </B></FONT></TD>\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#2200FF\"><B> CAN </B></FONT></TD>\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#2200FF\"><B> Uref </B></FONT></TD>\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#2200FF\"><B> Tempo </B></FONT></TD>\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#2200FF\"><B> HTML Update </B></FONT></TD>\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#2200FF\"><B> sensors </B></FONT></TD>\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#2200FF\"><B> html dir </B></FONT></TD>\n");
  fprintf (fic, "</TR>\n");

  fprintf (fic, "<TR ALIGN=\"CENTER\">\n");
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\"><B> %#x </B></FONT></TD>\n",
	   Conf.OUT_PORT);
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\"><B> %d bits </B></FONT></TD>\n",
	   CAN);
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\"><B> %0.3f Volts </B></FONT></TD>\n",
	   Uref);
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\"><B> %d </B></FONT></TD>\n",
	   Conf.Sleep);
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\"><B> %d Minutes </B></FONT></TD>\n",
	   Conf.Mn);
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\"><B> %d </B></FONT></TD>\n",
	   Conf.C);
  fprintf (fic,
	   "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF0000\"><B> %s </B></FONT></TD>\n",
	   Conf.METEO_HTML_DIR);
  fprintf (fic, "</TR>\n");
  fprintf (fic, "</TABLE>\n</CENTER>\n");


  if ((strcmp (Conf.Port[0], "none") != 0)
      && (strcmp (Conf.Port[1], "none") != 0)
      && (strcmp (Conf.Digi[0], "none") != 0)
      && (strcmp (Conf.Digi[1], "none") != 0))
    {

      fprintf (fic, "<CENTER>\n");
      fprintf (fic, "<TABLE BGCOLOR=\"#CCC000\" BORDER=\"1\">\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">\n");
      fprintf (fic,
	       "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#2200FF\"><B> APRS WX Beacon </B></FONT></TD>\n");
      fprintf (fic,
	       "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF00FF\"><B> %s on port %s </B></FONT></TD>\n",
	       Conf.Digi[0], Conf.Port[0]);
      fprintf (fic,
	       "<TD><FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FF00FF\"><B> %s on port %s </B></FONT></TD>\n",
	       Conf.Digi[1], Conf.Port[1]);

      fprintf (fic, "</TR>\n");
      fprintf (fic, "</TABLE>\n");
      fprintf (fic, "</CENTER>\n");

    }

  fprintf (fic, "<BR>\n<BR>\n");
  fprintf (fic,
	   "<CENTER>\n<HR WIDTH=\"50%\" SIZE=\"3\" COLOR=\"#FFF000\">\n</CENTER>\n");
  fprintf (fic,
	   "<CENTER>\n<FONT FACE=\"time new roman\" size=\"1\" COLOR=\"#FFF000\"><U>Best 73s From SysOp : %s</U></FONT>\n</CENTER>\n",
	   Conf.SysOp);
  fprintf (fic,
	   "<CENTER>\n<FONT FACE=\"time new roman\" size=\"1\">Erick LINE F5EXO [METEO (2000-2004) Version: %s]</FONT>\n</CENTER>\n",
	   METEO_VERSION);
  fprintf (fic, "</BODY>\n</HTML>\n");
  fclose (fic);
/*  printf(" [Fichier %s cree] \n",htmlfic);*/

  /* Creation des pages pour chaque voie */
  for (i = 0; i < Conf.C; i++)
    {
      if (capteurs[i].Unites != 0)
	{
	  char METEO_CONF_HTML_FILE[15] = { ".html" };
	  char htmlfic[80] = { };
	  strcpy (htmlfic, Conf.METEO_HTML_DIR);
	  strcat (htmlfic, capteurs[i].Mesure);
	  fic = fopen (strcat (htmlfic, METEO_CONF_HTML_FILE), "w");
	  fprintf (fic, "<HTML><HEAD><TITLE>[METEO version %s] %s\n",
		   METEO_VERSION, capteurs[i].Mesure);
	  fprintf (fic, "</TITLE>\n");

	  fprintf (fic,
		   "<META HTTP-EQUIV=\"Pragma\"  CONTENT=\"no-cache\">\n");
	  fprintf (fic,
		   "<META HTTP-EQUIV=\"generator\" CONTENT=\"METEO Linux Version %s\">\n",
		   METEO_VERSION);
	  fprintf (fic,
		   "<META HTTP-EQUIV=\"Description\"   CONTENT=\"Meteo Linux %s\">\n",
		   capteurs[i].Mesure);


	  fprintf (fic, "<META HTTP-EQUIV=\"refresh\"CONTENT=\"600\">\n");


	  fprintf (fic, "</HEAD>\n");
	  fprintf (fic,
		   "<BODY BGCOLOR=\"#990909\" TEXT=\"#FFFFFF\" LINK=\"#0000FF\" VLINK=\"#800080\" ALINK=\"#0000FF\">\n");
	  fprintf (fic, "<CENTER>\n");
/*   fprintf(fic,"<A HREF=\"%s.gif\" TARGET=\"WIN2\" ALT=\"%s sur un mois\">\n",capteurs[i].Mesure,capteurs[i].Mesure);*/
	  fprintf (fic,
		   "<IMG SRC=\"%s.png\" BORDER=\"0\" ALT=\"%s dernieres 24H\"",
		   capteurs[i].Mesure, capteurs[i].Mesure);
//	  fprintf (fic, " WIDTH=495 HEIGHT=172>\n");
	  fprintf (fic, "</CENTER>\n");

	  fprintf (fic, "<CENTER>\n<BR>\n");
	  fprintf (fic,
		   "<IMG SRC=\"%smois.png\" BORDER=\"0\" ALT=\"%s du mois\"",
		   capteurs[i].Mesure, capteurs[i].Mesure);
//	  fprintf (fic, " WIDTH=495 HEIGHT=172>\n");
	  fprintf (fic, "</CENTER>\n");

	  fprintf (fic, "<CENTER><BR>\n");
	  fprintf (fic,
		   "<IMG SRC=\"%san.png\" BORDER=\"0\" ALT=\"%s de l'ann&eacute;e\"",
		   capteurs[i].Mesure, capteurs[i].Mesure);
//	  fprintf (fic, " WIDTH=495 HEIGHT=172>\n");
	  fprintf (fic, "</CENTER>\n<BR>\n<BR>\n");

	  fprintf (fic,
		   "<CENTER>\n<HR WIDTH=\"50%\" SIZE=\"2\" COLOR=\"#FFF000\">\n</CENTER>\n<BR><BR>\n");
	  fprintf (fic, "</BODY>\n</HTML>\n");
	  fclose (fic);
	}
    }

}


void
Index_html (void)
{
  FILE *fic;
  char METEO_CONF_HTML_FILE[15] = { "index.html" };
  char htmlfic[80] = { };
  strcpy (htmlfic, Conf.METEO_HTML_DIR);
  fic = fopen (strcat (htmlfic, METEO_CONF_HTML_FILE), "w");
  fprintf (fic, "<HTML>\n<HEAD>\n<TITLE>SYSTEME METEO version %s]",
	   METEO_VERSION);
  fprintf (fic, "</TITLE>\n");
  fprintf (fic, "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"generator\" CONTENT=\"METEO Linux Version %s\">\n",
	   METEO_VERSION);
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Author\" CONTENT=\"LINE Erick F5EXO\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Keywords\" CONTENT=\"METEO,AX25,MAX186,F5EXO\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Description\" CONTENT=\"Linux ax25 meteo server\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=iso-8859-1\">\n");
  fprintf (fic, "<META HTTP-EQUIV=\"Window-target\" CONTENT=\"_top\">\n");
  fprintf (fic, "</HEAD>\n");

  fprintf (fic, "<FRAMESET COLS=\"14%,*\">\n");
  fprintf (fic, "<FRAMESET ROWS=\"86%,*\">\n");
  fprintf (fic,
	   "<FRAME SRC=\"menu.html\" NAME=\"WIN1\" SCROLLING=\"yes\">\n");
  fprintf (fic,
	   "<FRAME SRC=\"alarms.html\" NAME=\"WIN3\" SCROLLING=\"NO\">\n");
  fprintf (fic, "</FRAMESET>\"\n");
  fprintf (fic,
	   "<FRAME SRC=\"logo.html\" NAME=\"WIN2\" SCROLLING=\"YES\">\n");
  fprintf (fic, "</FRAMESET>\n");
  fprintf (fic, "<BODY>\n");
  fprintf (fic, "No frame...!\n");
  fprintf (fic, "</BODY>\n");
  fprintf (fic, "</HTML>\n");
  fclose (fic);
/* printf(" [Fichier %s a cree] \n",htmlfic);*/

}


void
logo_html (void)
{
  FILE *fic;
  char METEO_CONF_HTML_FILE[15] = { "logo.html" };
  char htmlfic[80] = { };
  strcpy (htmlfic, Conf.METEO_HTML_DIR);
  fic = fopen (strcat (htmlfic, METEO_CONF_HTML_FILE), "w");
  fprintf (fic, "<HTML>\n<HEAD>\n<TITLE>SYSTEME METEO version %s]\n",
	   METEO_VERSION);
  fprintf (fic, "</TITLE>\n");
  fprintf (fic, "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"generator\" CONTENT=\"METEO Linux Version %s\">\n",
	   METEO_VERSION);
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Author\" CONTENT=\"LINE Erick F5EXO\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Keywords\" CONTENT=\"METEO,AX25,MAX186,F5EXO\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Description\" CONTENT=\"Linux ax25 meteo server\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=iso-8859-1\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"image/x-xbitmap\">\n");

  fprintf (fic, "<META HTTP-EQUIV=\"Window-target\" CONTENT=\"_top\">\n");
  fprintf (fic, "</HEAD>\n");

  fprintf (fic,
	   "<!--Backround White, links blue (unvisited), navy (visited, red (active) -->\n");
  fprintf (fic,
	   "<BODY\n BGCOLOR=\"#990909\" TEXT=\"#FFB500\" LINK=\"#FFB500\" VLINK=\"#FFB500\" ALINK=\"#FFB500\">\n");
  fprintf (fic, "<CENTER>\n");
  fprintf (fic,
	   "<IMG BORDER=\"0\" SRC=\"logometeo.jpg\" ALT=\"LOGO METEO LINUX\">\n");
  fprintf (fic, "</CENTER>\n");
  fprintf (fic,
	   "<FONT SIZE=-1 COLOR=\"#FAFAFC\">\n<CENTER>\n[Version %s]</CENTER>\n</FONT>\n",
	   METEO_VERSION);
  fprintf (fic, "<BR>\n");
  fprintf (fic, "<CENTER>\n");
  fprintf (fic,
	   "<FONT FACE=\"time new roman\" size=\"3\" COLOR=\"#FAFAFC\"> %s / %s </FONT>\n",
	   Conf.locator, Conf.qth);
  fprintf (fic, "<BR>\n");

  if (strcmp (Conf.Partner, "none") != 0)
    {
      fprintf (fic,
	       "<a href=\"http://%s\" target=\"new\"><img src=\"partner.jpg\" alt=\"http://%s\" border=\"0\"></A>\n",
	       Conf.Partner, Conf.Partner);

    }
  fprintf (fic, "<HR WIDTH=\"50%\" SIZE=\"2\"><BR>\n");
  fprintf (fic, "<ALIGN=CENTER><IMG SRC=\"/cgi-bin/compteur.cgi\">\n");
  fprintf (fic, "</CENTER>\n");
  fprintf (fic, "</BODY>\n</HTML>\n");
  fclose (fic);
/* printf(" [Fichier %s a cree] \n",htmlfic);*/

}







/*--------------- Fin -----------------------------------------------------*/
