/*                  HamRadioAX25 F5EXO@@F6KSU.FPDL.FRA.EU                  */
/*                           mail:f5exo@free.fr                            */
/*                     Web:http://f5exo.free.fr/meteo/                     */
/*                            Erick LINE                                   */

/* Pin 11 LPT (busy) utilise en entree pour recevoir sous forme serie      */
/* Pin 2  LPT (D0) utilisee pour generee l'horloge SCLK                    */
/* Pin 3  LPT (D1) utilisee pour generee CS                                */
/* Pin 4  LPT (D2) utilisee pour envoyer les donnees vers le MAX186.       */
/*                                                                         */
/* Pin 15 LPT (/ERROR)     Bit 3   (comptage impulsions) In                */
/* Pin 13 LPT (/SELECT)    Bit 4   (comptage impulsions) In                */
/* Pin 12 LPT (/PAPER OUT) Bit 5   (comptage impulsions) In                */
/*                                                                         */
/* Pin 17 LPT (Select_IN)  Bit 3   (Alarm 2) Out                           */
/* Pin 16 LPT (INIT)       Bit 2   (Alarm 1) Out                           */
/*                                                                         */
/*                   Calcul Valeur analogique                              */
/*           Val analog = (DATA*(Uref/CAN)-Offset)/Unites                  */
/*           Ou DATA    = valeur digitale lue en sortie CAN                */
/*              Uref    = Tension de reference du CAN  4.096               */
/*              CAD     = CAN 12 bits pour MAX186                          */
/*              Offset  = valeur offset du composant capteur               */
/*              Unites  = facteur mutiplicateur du composant capteur       */

/*------------------------------SCANLPT------------------------------------*/

/* maj fichier meteo.html*/

char METEO_HTML_FILE[11] = { "meteo.html" };
char METEO_HTML_ALARM[12] = { "alarms.html" };
char METEO_HTML_ALLSENSOR[15] = {"allsensor.html" };

void
maj_html (void)
{
  FILE *fic;
  char *ssid;
  int c = 0, i;
  float z;
  long int v;
  char htmlfic[80] = { };
  strcpy (htmlfic, Conf.METEO_HTML_DIR);
  fic = fopen (strcat (htmlfic, METEO_HTML_FILE), "w");
  fprintf (fic, "<HTML><HEAD><TITLE>[METEO Linux Version %s]", METEO_VERSION);
  fprintf (fic, "</TITLE>\n");

  fprintf (fic, "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"%d\">\n",
	   Conf.Mn * 120);
  fprintf (fic, "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"generator\" CONTENT=\"METEO Linux Version %s\">\n",
	   METEO_VERSION);
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Author\" CONTENT=\"LINE Erick F5EXO\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Keywords\" CONTENT=\"METEO,AX25,MAX186,F5EXO\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Description\" CONTENT=\"Linux ax25 meteo server\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=iso-8859-1\">\n");

  fprintf (fic, "</HEAD>\n");
  fprintf (fic,
	   "<BODY BGCOLOR=\"#990909\" TEXT=\"#000000\" LINK=\"#0000FF\" VLINK=\"#800080\" ALINK=\"#FFFFF0\">\n");
/* fprintf(fic,"<CENTER><H1>[METEO Linux version %s] <B> STATION %s</B></H1>",METEO_VERSION,Conf.SysOp); */
/* fprintf(fic,"<FONT SIZE=-2> Erick LINE F5EXO (2000-2002)</FONT></CENTER><BR></A>\n");*/
  fprintf (fic,
	   "<CENTER><FONT FACE=\"times new roman\" size=\"2\" COLOR=\"#E2E4D6\"><B> 100\% HomeMade Hard & Soft</B></FONT></CENTER>\n");
  fprintf (fic,
	   "<CENTER><FONT FACE=\"times new roman\" size=\"2\" COLOR=\"#E2E4D6\"><B>%ld</B> ITERATIONS</FONT></CENTER>\n",
	   tab[0][2][0][0]);
  {
    v = tab[0][2][0][1];
    tb = localtime (&v);
#ifdef French
    fprintf (fic,
	     "<CENTER><FONT FACE=\"times new roman\" size=\"2\" COLOR=\"#E2E4D6\">Date de l'init :<B>");
#endif
#ifdef English
    fprintf (fic,
	     "<CENTER><FONT FACE=\"times new roman\" size=\"2\" COLOR=\"#E2E4D6\">Init date :<B>");
#endif
#ifdef Deutsch
    fprintf (fic,
	     "<CENTER><FONT FACE=\"times new roman\" size=\"2\" COLOR=\"#E2E4D6\">Init date :<B>");
#endif

    fprintf (fic, "%s %d %s %d %2.2d:%2.2d</B></FONT></CENTER>",
	     Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
	     tb->tm_year + 1900, tb->tm_hour, tb->tm_min);
  }

  fprintf (fic, "<CENTER>\n");
  fprintf (fic, "<FONT COLOR=\"#E4E2D6\"><B>");
  {
    {
      time_t t;
      time (&t);
      tb = localtime (&t);
    }
    fprintf (fic, "%s %d %s %d %2.2d:%2.2d ", Jours[tb->tm_wday], tb->tm_mday,
	     Mois[tb->tm_mon], tb->tm_year + 1900, tb->tm_hour, tb->tm_min);
  }
#ifdef French
  fprintf (fic, "a %s", Conf.qth);
#endif
#ifdef English
  fprintf (fic, "in %s", Conf.qth);
#endif
#ifdef Deutzch
  fprintf (fic, "in %s", Conf.qth);
#endif

  fprintf (fic, "</B>\n</FONT>\n</CENTER>\n");
//  fprintf (fic,
//         "<CENTER><HR WIDTH=\"50%\" SIZE=\"4\" COLOR=\"#FFFF00\"></CENTER>\n");

//  fprintf (fic,
//         "<CENTER><HR WIDTH=\"50%\" SIZE=\"4\"></CENTER>\n");

  for (c = 0; c < Conf.C; c++)
    {
      if ((strcasecmp (capteurs[c].Unite, "hPa") == 0)
	  && (capteurs[c].Unites != 0))
	{
	  fprintf (fic, "<CENTER>\n");
	  fprintf (fic, "<TABLE BGCOLOR=\"#990909\" BORDER=\"0\">\n");
	  fprintf (fic, "<TR ALIGN=\"CENTER\">");
	  fprintf (fic,
		   "<TD><FONT FACE=\"times new roman\" size=\"2\" COLOR=\"#FFFF00\"><B>");
	  fprintf (fic, (tendance = Tendance ()));
	  fprintf (fic, "</B>\n</FONT>\n</TD>\n");
	  fprintf (fic, "</TR>\n</TABLE>\n</CENTER>\n");
	}
    }

/*  fprintf (fic,"</FONT></CENTER>");*/
  fprintf (fic, "<BR>\n");

  if (Conf.C > 3)
    {
      fprintf (fic, "<CENTER>");
      fprintf (fic, "<TABLE BGCOLOR=\"#E4E2D6\" BORDER=\"2\">\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">");
      for (c = 0; c < Conf.C - 3; c++)
	{
	  if (capteurs[c].Unites != 0)
	    {
	      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
	      fprintf (fic,
		       "<A HREF=\"%s.html\" TARGET=\"WIN2\"> Channel No %d </A>",
		       capteurs[c].Mesure, c);
	      fprintf (fic, "</FONT></TH>\n");
	    }
	}
    }

  if (Conf.C > 3)
    {
      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
      fprintf (fic, " Historique ");
      fprintf (fic, "</FONT></TH></TR>\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">");
      for (c = 0; c < Conf.C - 3; c++)
	{
	  if (capteurs[c].Unites != 0)
	    {
	      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
	      fprintf (fic, " %s ", capteurs[c].Mesure);
	      fprintf (fic, "</FONT></TH>\n");
	    }
	}
      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
      fprintf (fic, " Mesure ");
      fprintf (fic, "</FONT></TH></TR>\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">");
      for (c = 0; c < Conf.C - 3; c++)
	{
	  if (capteurs[c].Unites != 0)
	    {
	      fprintf (fic, "<TD>");
	      z =
		((tab[c][0][0][0] * CAD) -
		 capteurs[c].Offset) / capteurs[c].Unites;
	      fprintf (fic,
		       "<FONT FACE=\"times new roman\" size=\"1\" COLOR=\"#FF0000\">");
	      fprintf (fic, " %7.2f ", z);
	      fprintf (fic, "</FONT></TD>\n");
	    }
	}
      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
      fprintf (fic, " %s ", Legend[1]);	/* Maxi */
      fprintf (fic, "</FONT></TH></TR>\n");

      fprintf (fic, "<TR ALIGN=\"CENTER\">");
      for (c = 0; c < Conf.C - 3; c++)
	{
	  if (capteurs[c].Unites != 0)
	    {
	      fprintf (fic, "<TD>");
	      z =
		((tab[c][0][1][0] * CAD) -
		 capteurs[c].Offset) / capteurs[c].Unites;

	      if (((Alarms[0].Channel == c) && (tab[0][2][0][8] == 1)) ||
		  ((Alarms[1].Channel == c) && (tab[0][2][0][9] == 1)))
		{
		  fprintf (fic,
			   "<FONT FACE=\"times new roman\" size=\"1\" COLOR=\"green\"><BLINK><B>");
		  fprintf (fic, " %7.2f ", z);
		  fprintf (fic, "</B></BLINK></FONT></TD>\n");

		}
	      else
		{
		  fprintf (fic,
			   "<FONT FACE=\"times new roman\" size=\"1\" COLOR=\"blue\"><B>");
		  fprintf (fic, " %7.2f ", z);
		  fprintf (fic, "</B></FONT></TD>\n");
		}
	    }
	}
      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
      fprintf (fic, " %s ", Legend[2]);	/* Actuelle */
      fprintf (fic, "</FONT></TH></TR>\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">");
      for (c = 0; c < Conf.C - 3; c++)
	{
	  if (capteurs[c].Unites != 0)
	    {
	      fprintf (fic, "<TD>");
	      z =
		((tab[c][0][2][0] * CAD) -
		 capteurs[c].Offset) / capteurs[c].Unites;
	      fprintf (fic,
		       "<FONT FACE=\"times new roman\" size=\"1\" COLOR=\"#FF00FF\">");
	      fprintf (fic, " %7.2f ", z);
	      fprintf (fic, "</FONT></TD>\n");
	    }
	}
      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
      fprintf (fic, " %s ", Legend[3]);	/* Mini */
      fprintf (fic, "</FONT></TH></TR>\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">");
      for (c = 0; c < Conf.C - 3; c++)
	{
	  if (capteurs[c].Unites != 0)
	    {
	      fprintf (fic, "<TD>");
	      fprintf (fic,
		       "<FONT FACE=\"times new roman\" size=\"1\" COLOR=\"#000000\"><B>");
	      fprintf (fic, " %s ", capteurs[c].Unite);
	      fprintf (fic, "</B></FONT></TD>\n");
	    }
	}
      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
      fprintf (fic, " %s ", Legend[4]);	/* Unite */
      fprintf (fic, "</FONT></TH></TR>\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">");
      for (c = 0; c < Conf.C - 3; c++)
	{
	  if (capteurs[c].Unites != 0)
	    {
	      fprintf (fic, "<TD>");
	      fprintf (fic,
		       "<FONT FACE=\"times new roman\" size=\"1\" COLOR=\"blue\"><B>");
	      fprintf (fic, " %s ", capteurs[c].sensor);	/* type capteurs */
	      fprintf (fic, "</B></FONT></TD>\n");
	    }
	}
      fprintf (fic, "<TH>\n");
      fprintf (fic,
	       "<FONT FACE=\"times new roman\" size=\"1\" COLOR=\"blue\"><B>");
      fprintf (fic, " %s ", Legend[0]);	/* Unite */
      fprintf (fic, "</B></FONT></TH>");

      fprintf (fic, "</TR></TABLE></CENTER>");
      fprintf (fic, "<BR>\n");

/*-- Affichage des dates Maxi & Mini -------*/
      fprintf (fic, "<CENTER>");
      fprintf (fic, "<TABLE BGCOLOR=\"#E4E2D6\" BORDER=\"2\">\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">");
      for (c = 0; c < Conf.C - 3; c++)
	{
	  if (capteurs[c].Unites != 0)
	    {
	      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
	      fprintf (fic, " %s ", capteurs[c].Mesure);
	      fprintf (fic, "</FONT></TH>\n");
	    }
	}
      fprintf (fic, "</TR>\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">");
      for (c = 0; c < Conf.C - 3; c++)
	{
	  if (capteurs[c].Unites != 0)
	    {
	      fprintf (fic, "<TD>");
	      v = tab[c][1][0][0];
	      tb = localtime (&v);
	      fprintf (fic,
		       "<FONT FACE=\"times new roman\" size=\"1\" COLOR=\"#FF0000\">");
	      fprintf (fic, " %d %1.4s %d %2.2d:%2.2d \n", tb->tm_mday,
		       Mois[tb->tm_mon], tb->tm_year + 1900, tb->tm_hour,
		       tb->tm_min);
	      fprintf (fic, "</FONT></TD>");
	    }
	}
      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\"><B>");
      fprintf (fic, " %s ", Legend[1]);	/* Maxi */
      fprintf (fic, "</B></FONT></TH></TR>\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">");
      for (c = 0; c < Conf.C - 3; c++)
	{
	  if (capteurs[c].Unites != 0)
	    {
	      fprintf (fic, "<TD>");
	      v = tab[c][1][2][0];
	      tb = localtime (&v);
	      fprintf (fic,
		       "<FONT FACE=\"times new roman\" size=\"1\" COLOR=\"#FF00FF\">");
	      fprintf (fic, " %d %1.4s %d %2.2d:%2.2d \n", tb->tm_mday,
		       Mois[tb->tm_mon], tb->tm_year + 1900, tb->tm_hour,
		       tb->tm_min);
	      fprintf (fic, "</FONT></TD>");
	    }
	}
      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\"><B>\n");
      fprintf (fic, " %s ", Legend[3]);	/* Mini */
      fprintf (fic, "</B></FONT></TH></TR>\n");
      fprintf (fic, "</TABLE>");
      fprintf (fic, "</CENTER><BR>");
    }
/*--------------------------------------------------------------------*/
/* Direct ACCES PORT LPT  */

/*  fprintf (fic, "<BR>\n");*/

  if ((capteurs[Conf.C - 1].Unites != 0) || (capteurs[Conf.C - 2].Unites != 0)
      || (capteurs[Conf.C - 3].Unites != 0))
    {
      fprintf (fic, "<CENTER>");
      fprintf (fic, "<TABLE BGCOLOR=\"#E4E2D6\" BORDER=\"2\">\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">");
    }
  for (c = Conf.C - 3; c < Conf.C; c++)
    {
      if (capteurs[c].Unites != 0)
	{
	  fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
	  fprintf (fic,
		   "<A HREF=\"%s.html\" TARGET=\"WIN2\"> Channel No %d </A>",
		   capteurs[c].Mesure, c);
	  fprintf (fic, "</FONT></TH>\n");
	}
    }
  if ((capteurs[Conf.C - 1].Unites != 0) || (capteurs[Conf.C - 2].Unites != 0)
      || (capteurs[Conf.C - 3].Unites != 0))
    {

      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
      fprintf (fic, " Historique ");
      fprintf (fic, "</FONT></TH></TR>\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">");
    }
  for (c = Conf.C - 3; c < Conf.C; c++)
    {
      if (capteurs[c].Unites != 0)
	{
	  fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
	  fprintf (fic, " %s ", capteurs[c].Mesure);
	  fprintf (fic, "</FONT></TH>\n");
	}
    }
  if ((capteurs[Conf.C - 1].Unites != 0) || (capteurs[Conf.C - 2].Unites != 0)
      || (capteurs[Conf.C - 3].Unites != 0))
    {

      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
      fprintf (fic, " Mesure ");
      fprintf (fic, "</FONT></TH></TR>\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">");
    }
  for (c = Conf.C - 3; c < Conf.C; c++)
    {
      if (capteurs[c].Unites != 0)
	{
	  fprintf (fic, "<TD>");
	  z = (tab[0][2][0][10 + c] * capteurs[c].Unites);
	  fprintf (fic,
		   "<FONT FACE=\"times new roman\" size=\"1\" COLOR=\"#9000FF\"><B>");
	  fprintf (fic, " %7.0f ", z);
	  fprintf (fic, "</B></FONT></TD>\n");
	}
    }
  if ((capteurs[Conf.C - 1].Unites != 0) || (capteurs[Conf.C - 2].Unites != 0)
      || (capteurs[Conf.C - 3].Unites != 0))
    {

      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
      fprintf (fic, " %s ", rain[2]);	/* Since 0:00 */
      fprintf (fic, "</FONT></TH></TR>\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">");
    }
  for (c = Conf.C - 3; c < Conf.C; c++)
    {
      if (capteurs[c].Unites != 0)
	{
	  fprintf (fic, "<TD>");
	  z = (tab[c][0][0][0] * capteurs[c].Unites);
	  fprintf (fic,
		   "<FONT FACE=\"times new roman\" size=\"1\" COLOR=\"#FF0000\">");
	  fprintf (fic, " %7.0f ", z);
	  fprintf (fic, "</FONT></TD>\n");
	}
    }
  if ((capteurs[Conf.C - 1].Unites != 0) || (capteurs[Conf.C - 2].Unites != 0)
      || (capteurs[Conf.C - 3].Unites != 0))
    {

      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
      fprintf (fic, " %s ", rain[0]);	/* Last 24H */
      fprintf (fic, "</FONT></TH></TR>\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">");
    }
  for (c = Conf.C - 3; c < Conf.C; c++)
    {
      if (capteurs[c].Unites != 0)
	{
	  fprintf (fic, "<TD>");
	  z = (tab[c][0][2][0] * capteurs[c].Unites);	/* last 1H */
	  fprintf (fic,
		   "<FONT FACE=\"times new roman\" size=\"1\" COLOR=\"#000FFF\"><B>");
	  fprintf (fic, " %7.0f ", z);
	  fprintf (fic, "</B></FONT></TD>\n");
	}
    }
  if ((capteurs[Conf.C - 1].Unites != 0) || (capteurs[Conf.C - 2].Unites != 0)
      || (capteurs[Conf.C - 3].Unites != 0))
    {

      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
      fprintf (fic, " %s ", rain[1]);	/* Last 1H */
      fprintf (fic, "</FONT></TH></TR>\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">");
    }
  for (c = Conf.C - 3; c < Conf.C; c++)
    {
      if (capteurs[c].Unites != 0)
	{
	  fprintf (fic, "<TD>");
	  z = (tab[c][0][1][0] * capteurs[c].Unites);	/* actuel */

	  if (((Alarms[0].Channel == c) && (tab[0][2][0][8] == 1)) ||
	      ((Alarms[1].Channel == c) && (tab[0][2][0][9] == 1)))
	    {
	      fprintf (fic,
		       "<FONT FACE=\"times new roman\" size=\"1\" COLOR=\"#00FF00\">");
	      fprintf (fic, "<BLINK><B> %7.2f </B></BLINK>", z);
	      fprintf (fic, "</FONT></TD>\n");
	    }

	  else
	    {
	      fprintf (fic,
		       "<FONT FACE=\"times new roman\" size=\"1\" COLOR=\"#FF00FF\">");
	      fprintf (fic, " %7.0f ", z);
	      fprintf (fic, "</FONT></TD>\n");
	    }
	}
    }
  if ((capteurs[Conf.C - 1].Unites != 0) || (capteurs[Conf.C - 2].Unites != 0)
      || (capteurs[Conf.C - 3].Unites != 0))
    {

      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
      fprintf (fic, " %s ", Legend[2]);	/* Unite */
      fprintf (fic, "</FONT></TH></TR>\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">");
    }
  for (c = Conf.C - 3; c < Conf.C; c++)
    {
      if (capteurs[c].Unites != 0)
	{
	  fprintf (fic, "<TD>");
	  fprintf (fic,
		   "<FONT FACE=\"times new roman\" size=\"1\" COLOR=\"#000000\"><B>");
	  fprintf (fic, " %s ", capteurs[c].Unite);
	  fprintf (fic, "</B></FONT></TD>\n");
	}
    }
  if ((capteurs[Conf.C - 1].Unites != 0) || (capteurs[Conf.C - 2].Unites != 0)
      || (capteurs[Conf.C - 3].Unites != 0))
    {

      fprintf (fic, "<TH><FONT FACE=\"times new roman\" size=\"1\">");
      fprintf (fic, " %s ", Legend[4]);	/* Actuelle */
      fprintf (fic, "</FONT></TH></TR>\n");
      fprintf (fic, "<TR ALIGN=\"CENTER\">");
    }
  for (c = Conf.C - 3; c < Conf.C; c++)
    {
      if (capteurs[c].Unites != 0)
	{
	  fprintf (fic, "<TD>");
	  fprintf (fic,
		   "<FONT FACE=\"times new roman\" size=\"1\" COLOR=\"#000FFF\"><B>");
	  fprintf (fic, " %s ", capteurs[c].sensor);	/* type capteurs */
	  fprintf (fic, "</B></FONT></TD>\n");
	}
    }
  if ((capteurs[Conf.C - 1].Unites != 0) || (capteurs[Conf.C - 2].Unites != 0)
      || (capteurs[Conf.C - 3].Unites != 0))
    {

      fprintf (fic, "<TH>\n");
      fprintf (fic,
	       "<FONT FACE=\"times new roman\" size=\"1\" COLOR=\"#000FFF\"><B>");
      fprintf (fic, " %s ", Legend[0]);	/* Unite */
      fprintf (fic, "</B></FONT></TH>");
      fprintf (fic, "</TR></TABLE></CENTER>");
    }
  fprintf (fic, "<BR>\n");


  /*  fprintf (fic,"<BR>"); */
  ssid = strchr (Conf.SysOp, '-');
  if (ssid != NULL)
    {
      i = (strlen (Conf.SysOp) - 2);
      Conf.SysOp[i] = ' ';
      Conf.SysOp[i + 1] = ' ';
    }

  if (strcmp (Conf.Partner, "none") != 0)
    {
      fprintf (fic,
	       "<CENTER><a href=\"http://%s\" target=\"new\"><img src=\"partner.jpg\" alt=\"http://%s\" border=\"0\"></A></CENTER><BR>\n",
	       Conf.Partner, Conf.Partner);
    }

  fprintf (fic, "<CENTER><HR WIDTH=\"50%\" SIZE=\"1\"></CENTER>\n");
  fprintf (fic,
	   "<CENTER><FONT FACE=\"times new roman\" size=\"1\" COLOR=\"#FAFAFC\"><U><B>Best 73s From SysOp : %s</B></U></FONT></CENTER>\n",
	   Conf.SysOp);
  fprintf (fic,
	   "<CENTER><FONT SIZE=-2><U><B>METEO Linux Version: %s </B></U></FONT></CENTER>\n",
	   METEO_VERSION);
  fprintf (fic, "</BODY></HTML>");
  fclose (fic);


/*---------------------ALARMES---------------------------------------------*/
  strcpy (htmlfic, Conf.METEO_HTML_DIR);
  fic = fopen (strcat (htmlfic, METEO_HTML_ALARM), "w");
  fprintf (fic, "<HTML><HEAD><TITLE>[ALARMS METEO Linux Version %s]",
	   METEO_VERSION);
  fprintf (fic, "</TITLE>\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=iso-8859-1\">\n");

  fprintf (fic, "</HEAD>\n");
  fprintf (fic,
	   "<BODY BGCOLOR=\"#E4E2D6\" TEXT=\"#000000\" LINK=\"#0000FF\" VLINK=\"#800080\" ALINK=\"#FFFFF0\">\n");


  fprintf (fic, "<TABLE WIDTH=\"100%\">\n");
  fprintf (fic, "<TR>\n");
  fprintf (fic, "<TH BGCOLOR=\"#990909\" ALIGN=center>\n");
  fprintf (fic,
	   "<FONT FACE=\"Arial\" size=-1 color=\"#FFFFFF\">ALARMES</FONT>\n");
  fprintf (fic, "</TH>\n</TR>\n</TABLE>\n");


//  fprintf (fic, "<CENTER>");
  i = 1;
  for (c = 0; c < Conf.C; c++)
    {
      if (((Alarms[0].Channel == c) && (tab[0][2][0][8] == 1)) ||
	  ((Alarms[1].Channel == c) && (tab[0][2][0][9] == 1)))
	{
	  fprintf (fic,
		   "<FONT FACE=\"times new roman\" size=\"2\" COLOR=\"#FF0000\">%d : <BLINK><B>%s</B></BLINK>\n</FONT>\n<BR>\n",
		   i, capteurs[c].Mesure);
	  i++;
	}
    }

//  fprintf (fic, "</CENTER>");
  fprintf (fic, "</BODY>\n</HTML>\n");
  fclose (fic);
  return;
/*  printf("[%s  jour] \n",htmlfic);*/
}





void
allsensor_html (void)
{
  FILE *fic;
  int i=0 ;
  int c = 0;
  long int v;

  /* Creation de la page 24h pour chaque voie */


  char htmlfic[80] = { };
  strcpy (htmlfic, Conf.METEO_HTML_DIR);
  fic = fopen (strcat (htmlfic, METEO_HTML_ALLSENSOR), "w");
  fprintf (fic, "<HTML><HEAD><TITLE>[METEO version %s] Valeurs sur 24h\n",
	   METEO_VERSION);
  fprintf (fic, "</TITLE>\n");

  fprintf (fic, "<META HTTP-EQUIV=\"Pragma\"  CONTENT=\"no-cache\">\n");
  fprintf (fic,
	   "<META HTTP-EQUIV=\"generator\" CONTENT=\"METEO Linux Version %s\">\n",
	   METEO_VERSION);
  fprintf (fic,
	   "<META HTTP-EQUIV=\"Description\"   CONTENT=\"Meteo Linux %s\">\n",
	   METEO_VERSION);


  fprintf (fic, "<META HTTP-EQUIV=\"refresh\"CONTENT=\"600\">\n");

  fprintf (fic, "</HEAD>\n");
  fprintf (fic,
	   "<BODY BGCOLOR=\"#990909\" TEXT=\"#FFFFFF\" LINK=\"#0000FF\" VLINK=\"#800080\" ALINK=\"#0000FF\">\n");
//        fprintf (fic, "<CENTER>\n");
/*   fprintf(fic,"<A HREF=\"%s.gif\" TARGET=\"WIN2\" ALT=\"%s sur un mois\">\n",capteurs[i].Mesure,capteurs[i].Mesure);*/

 {
    v = tab[0][2][0][1];
    tb = localtime (&v);
#ifdef French
    fprintf (fic,
	     "<CENTER><FONT FACE=\"times new roman\" size=\"2\" COLOR=\"#E2E4D6\">Date de l'init :<B>");
#endif
#ifdef English
    fprintf (fic,
	     "<CENTER><FONT FACE=\"times new roman\" size=\"2\" COLOR=\"#E2E4D6\">Init date :<B>");
#endif
#ifdef Deutsch
    fprintf (fic,
	     "<CENTER><FONT FACE=\"times new roman\" size=\"2\" COLOR=\"#E2E4D6\">Init date :<B>");
#endif

    fprintf (fic, "%s %d %s %d %2.2d:%2.2d</B></FONT></CENTER>",
	     Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
	     tb->tm_year + 1900, tb->tm_hour, tb->tm_min);
  }

  fprintf (fic, "<CENTER>\n");
//  fprintf (fic, "<FONT COLOR=\"#E4E2D6\"><B>");
  fprintf (fic, "<FONT COLOR=\"#FFF000\"><B>");  
  
  {
    {
      time_t t;
      time (&t);
      tb = localtime (&t);
    }
    fprintf (fic, "%s %d %s %d %2.2d:%2.2d ", Jours[tb->tm_wday], tb->tm_mday,
	     Mois[tb->tm_mon], tb->tm_year + 1900, tb->tm_hour, tb->tm_min);
  }
#ifdef French
  fprintf (fic, "a %s", Conf.qth);
#endif
#ifdef English
  fprintf (fic, "in %s", Conf.qth);
#endif
#ifdef Deutzch
  fprintf (fic, "in %s", Conf.qth);
#endif

  fprintf (fic, "</B>\n</FONT>\n</CENTER>\n");
//  fprintf (fic,
//         "<CENTER><HR WIDTH=\"50%\" SIZE=\"4\" COLOR=\"#FFFF00\"></CENTER>\n");

//  fprintf (fic,
//         "<CENTER><HR WIDTH=\"50%\" SIZE=\"4\"></CENTER>\n");

  for (c = 0; c < Conf.C; c++)
    {
      if ((strcasecmp (capteurs[c].Unite, "hPa") == 0)
	  && (capteurs[c].Unites != 0))
	{
	  fprintf (fic, "<CENTER>\n");
	  fprintf (fic, "<TABLE BGCOLOR=\"#990909\" BORDER=\"0\">\n");
	  fprintf (fic, "<TR ALIGN=\"CENTER\">");
	  fprintf (fic,
		   "<TD><FONT FACE=\"times new roman\" size=\"2\" COLOR=\"#F9C2DE\"><B>");
	  fprintf (fic, (tendance = Tendance ()));
	  fprintf (fic, "</B>\n</FONT>\n</TD>\n");
	  fprintf (fic, "</TR>\n</TABLE>\n</CENTER>\n");
	}
    }

/*  fprintf (fic,"</FONT></CENTER>");*/
  fprintf (fic, "<BR>\n");

  for (i = 0; i < Conf.C; i++)
    {
      if (capteurs[i].Unites != 0)
	{
	  fprintf (fic, "<CENTER>\n");
	  fprintf (fic,  
	  "<A HREF=\"%s.html\" TARGET=\"WIN2\"><IMG SRC=\"%s.png\" BORDER=\"0\" ALT=\"%s dernieres 24H\"",
		   capteurs[i].Mesure,capteurs[i].Mesure, capteurs[i].Mesure);
//	  fprintf (fic, " WIDTH=495 HEIGHT=172></A>\n");
	  fprintf (fic, "</A></CENTER><BR>\n");

	}
    }

  if (strcmp (Conf.Partner, "none") != 0)
    {
      fprintf (fic,
	       "<br><center><a href=\"http://%s\" target=\"new\"><img src=\"partner.jpg\" alt=\"%s\" border=\"0\"></a></center><br>\n",
	       Conf.Partner, Conf.Partner);

    }


  fprintf (fic,
	   "<CENTER>\n<HR WIDTH=\"50%\" SIZE=\"2\" COLOR=\"#FFF000\">\n</CENTER>\n<BR><BR>\n");
  fprintf (fic, "</BODY>\n</HTML>\n");
  fclose (fic);
  return;

}





/*--------------------------FIN DE LA PARTIE HTML--------------------------*/
