/*                  HamRadioAX25 F5EXO@@F6KSU.FPDL.FRA.EU                  */
/*                           mail:f5exo@free.fr                            */
/*                     Web:http://f5exo.free.fr/meteo/                     */
/*                            Erick LINE                                   */

/* Pin 11 LPT (busy) utilise en entree pour recevoir sous forme serie      */
/* Pin 2  LPT (D0) utilisee pour generee l'horloge SCLK                    */
/* Pin 3  LPT (D1) utilisee pour generee CS                                */
/* Pin 4  LPT (D2) utilisee pour envoyer les donnees vers le MAX186.       */
/*                                                                         */
/* Pin 15 LPT (/ERROR)     Bit 3   (comptage impulsions) In                */
/* Pin 13 LPT (/SELECT)    Bit 4   (comptage impulsions) In                */
/* Pin 12 LPT (/PAPER OUT) Bit 5   (comptage impulsions) In                */
/*                                                                         */
/* Pin 17 LPT (Select_IN)  Bit 3   (Alarm 2) Out                           */
/* Pin 16 LPT (INIT)       Bit 2   (Alarm 1) Out                           */
/*                                                                         */
/*                   Calcul Valeur analogique                              */
/*           Val analog = (DATA*(Uref/CAN)-Offset)/Unites                  */
/*           Ou DATA    = valeur digitale lue en sortie CAN                */
/*              Uref    = Tension de reference du CAN  4.096               */
/*              CAD     = CAN 12 bits pour MAX186                          */
/*              Offset  = valeur offset du composant capteur               */
/*              Unites  = facteur mutiplicateur du composant capteur       */

/*------------------------------SCANLPT------------------------------------*/

/*-------------------------DEBUT DE LA PARTIE HTML-------------------------*/

char METEO_MAP_FILE[12] = { "map.html" };
char METEO_MENU_FILE[12] = { "menu.html" };

void
maj_map (void)
{
  FILE *fic;
  int c = 0;
  int A = 179, B = 188;
  char htmlfic[80] = { };
  strcpy (htmlfic, Conf.METEO_HTML_DIR);
  fic = fopen (strcat (htmlfic, METEO_MAP_FILE), "w");

  {
    t = time (NULL);
    tb = localtime (&t);
  }

/* fprintf(fic,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n\r");*/
  fprintf (fic, "<html>\r\n");
  fprintf (fic, "<head>\r\n");
  fprintf (fic,
	   "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=windows-1252\">\n\r");
  fprintf (fic,
	   "<meta name=\"Creator\" content=\"METEO Linux %s by Erick Lin; f5exo@free.fr\">\n\r",
	   METEO_VERSION);
  fprintf (fic,
	   "<meta name=\"Subject\" content=\"METEO; AX25; MAX186\">\n\r");
  fprintf (fic, "<meta name=\"Version\" content=\"%s\">\n\r", METEO_VERSION);
  fprintf (fic, "<meta name=\"Date\" content=\"%d/%s/%2.2d\">\n\r",
	   tb->tm_mday, Mois[tb->tm_mon], tb->tm_year + 1900);

  fprintf (fic, "<title>METEO  %s</title>\n\r", Conf.qth);

  fprintf (fic, "</HEAD>\n\r");
  fprintf (fic, "<BODY BGCOLOR=\"#FFFF00\">\n\r");

  fprintf (fic,
	   "<CENTER><FONT COLOR=\"#000000\"><B>Station %s  %s</B>&nbsp;</FONT></CENTER>\n\r",
	   Conf.ax25Call, Conf.qth);

  fprintf (fic, "<BR>\n");
  fprintf (fic, "<CENTER>\n");

  fprintf (fic,
	   "<A HREF=\"meteocfg.html\" TARGET=\"WIN2\"><FONT FACE =\"times new roman\" size=\"2\">Configuration</A> &nbsp&nbsp\n\r");
  fprintf (fic,
	   "<A HREF=\"meteo.html\" TARGET=\"WIN2\">Mini & Maxi</A> &nbsp&nbsp\n\r");

  fprintf (fic,
	   "<A HREF=\"%s\" TARGET=\"NEW\">Link</A> &nbsp&nbsp\n\r",
	   Conf.HTMLLink);

  fprintf (fic,
	   "<A HREF=\"http://f5exo.free.fr/\" TARGET=\"new\">Info</A>&nbsp&nbsp</FONT>\n\r");

  fprintf (fic, "</CENTER>\n");
/*  fprintf (fic, "<BR>\n");*/
  fprintf (fic, "<MAP NAME=\"METEO\">\n\r");
/* coordonnes A, B, C, C des zones reactives des capteurs actifs */
  for (c = 0; c < Conf.C - 3; c++)
    {
      if (capteurs[c].Unites != 0)
	{

	  if (c > (Conf.C - 1))
	    {
	      /*    fprintf(fic,"<B></B>\n\r"); */
	    }
	  else
	    {
	      fprintf (fic,
		       "<AREA SHAPE=\"RECT\" COORDS=\"%d,25,%d,80\" HREF=\"%s.html\" TARGET=\"WIN2\">\n\r",
		       A, B, capteurs[c].Mesure);
	    }
	}
      B = B - 15;
      A = A - 15;
    }
  B = 62;
  A = 54;
  for (c = Conf.C - 3; c < Conf.C; c++)
    {
      if (capteurs[c].Unites != 0)
	{
	  fprintf (fic,
		   "<AREA SHAPE=\"RECT\" COORDS=\"%d,25,%d,80\" HREF=\"%s.html\" TARGET=\"WIN2\">\n\r",
		   A, B, capteurs[c].Mesure);
	}
      B = B - 12;
      A = A - 12;
    }
  fprintf (fic,
	   "<AREA SHAPE=\"RECT\" COORDS=\"96,118,173,132\" HREF=\"http://dbserv.maxim-ic.com/quick_view2.cfm?qv_pk=1070\" TARGET=\"NEW\">\n\r");

  fprintf (fic,
	   "<AREA SHAPE=\"RECT\" COORDS=\"4,291,43,341\" HREF=\"./%s\" TARGET=\"NEW\">\n\r",
	   TXT_FILE);


  fprintf (fic, "</MAP>\n\r");
  fprintf (fic, "<CENTER>\n\r");
  fprintf (fic,
	   "<IMG SRC=\"synop.gif\" ALT=\"[METEO Version:%s]\" BORDER=\"0\" USEMAP=\"#METEO\">\n\r",
	   METEO_VERSION);
  fprintf (fic, "</CENTER>\n\r");
  fprintf (fic, "</BODY>\n\r");
  fprintf (fic, "</HTML>\n\r");
  fclose (fic);

}



void
maj_menu (void)
{
  FILE *fic;
  int c = 0;
  char htmlfic[80] = { };
  strcpy (htmlfic, Conf.METEO_HTML_DIR);
  fic = fopen (strcat (htmlfic, METEO_MENU_FILE), "w");

  {
    t = time (NULL);
    tb = localtime (&t);
  }
/* fprintf(fic,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n\r");*/
  fprintf (fic, "<html>\n");
  fprintf (fic, "<head>\n");
  fprintf (fic,
	   "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=windows-1252\">\n\r");
  fprintf (fic,
	   "<meta name=\"Creator\" content=\"METEO Linux %s by Erick Lin; f5exo@free.fr\">\n",
	   METEO_VERSION);
  fprintf (fic, "<meta name=\"Subject\" content=\"METEO; AX25; MAX186\">\n");
  fprintf (fic, "<meta name=\"Version\" content=\"%s\">\n", METEO_VERSION);
  fprintf (fic, "<meta name=\"Date\" content=\"%d/%s/%2.2d\">\n",
	   tb->tm_mday, Mois[tb->tm_mon], tb->tm_year + 1900);

  fprintf (fic, "<title>METEO  %s</title>\n", Conf.qth);

  fprintf (fic, "</HEAD>\n");
  fprintf (fic, "<BODY BGCOLOR=\"#E4E2D6\">\n");
//  fprintf (fic, "<BODY BGCOLOR=\"#990909\">\n\r");


//  fprintf (fic, "<BR>\n");
  fprintf (fic,
	   "<TABLE WIDTH=\"100%\">\n<TR>\n<TH BGCOLOR=\"#990909\" ALIGN=center>\n");
  fprintf (fic,
	   "<FONT FACE =\"ARIAL\" size=-1 color=\"#FFFFFF\">CAPTEURS</FONT>\n");
  fprintf (fic, "</TH>\n</TR>\n</TABLE>\n");

//  fprintf (fic, "<FONT FACE =\"Arial\" size=-1>\n");

  fprintf (fic, "<OL TYPE=\"SQUARE\">\n");
  fprintf (fic, "<FONT FACE =\"Arial\" size=-1>\n");
  for (c = 0; c < Conf.C - 3; c++)
    {
      if (capteurs[c].Unites != 0)
	{

	  if (c > (Conf.C - 1))
	    {
	      /*    fprintf(fic,"<B></B>\n\r"); */
	    }
	  else
	    {
	      fprintf (fic,
		       "<LI><A HREF=\"%s.html\" TARGET=\"WIN2\">%s</A></LI>\n",
		       capteurs[c].Mesure, capteurs[c].Mesure);
	    }
	}
    }

  fprintf (fic, "</OL>\n");

  fprintf (fic, "<OL TYPE=\"CIRCLE\">\n");
  for (c = (Conf.C - 3); c < Conf.C; c++)
    {
      if (capteurs[c].Unites != 0)
	{

	  if (c > (Conf.C - 1))
	    {
	      /*    fprintf(fic,"<B></B>\n\r"); */
	    }
	  else
	    {
	      fprintf (fic,
		       "<LI><A HREF=\"%s.html\" TARGET=\"WIN2\">%s</A></LI>\n",
		       capteurs[c].Mesure, capteurs[c].Mesure);
	    }
	}
    }
//      fprintf (fic,"<BR>\n");


  fprintf (fic,
	   "<A HREF=\"allsensor.html\" TARGET=\"WIN2\"><B>24h</B></A>\n");


  fprintf (fic, "</FONT>\n");
  fprintf (fic, "</OL>\n");

//  fprintf (fic, "</FONT>\n<HR>\n");
//  fprintf (fic, "<HR>\n");

  fprintf (fic,
	   "<TABLE WIDTH=\"100%\"><TR>\n<TH BGCOLOR=\"#990909\" ALIGN=center>\n");
  fprintf (fic,
	   "<FONT FACE =\"ARIAL\" size=-1 color=\"#FFFFFF\"> MAXI & MINI</FONT>\n");
  fprintf (fic, "</TH>\n</TR>\n</TABLE>\n");

//  fprintf (fic, "<DT>\n");
  fprintf (fic, "<FONT FACE =\"Arial\" size=-2>\n");
  fprintf (fic,
	   "<LI><A HREF=\"meteo.html\" TARGET=\"WIN2\">TABLEAU</A></LI>\n");
  fprintf (fic, "</FONT>\n");
//  fprintf (fic, "</DT>\n");
//  fprintf (fic, "<HR>\n");

  fprintf (fic,
	   "<TABLE WIDTH=\"100%\">\n<TR>\n<TH BGCOLOR=\"#990909\" ALIGN=center>\n");
  fprintf (fic,
	   "<FONT FACE =\"ARIAL\" size=-1 color=\"#FFFFFF\"> SYSTEME</FONT>\n");
  fprintf (fic, "</TH>\n</TR>\n</TABLE>\n");

//  fprintf (fic, "<DL>\n");
  fprintf (fic, "<FONT FACE =\"Arial\" size=-2>\n");
  fprintf (fic,
	   "<LI><A HREF=\"meteocfg.html\" TARGET=\"WIN2\">CONFIGURATION</A></LI>\n");

//  fprintf (fic,
//         "<LI><A HREF=\"./%s\" TARGET=\"NEW\">Tableur</A></LI>\n",
//         TXT_FILE);
  fprintf (fic, "</FONT><BR>\n");
/*
  fprintf (fic,
	   "<TABLE WIDTH=\"100%\">\n<TR>\n<TH BGCOLOR=\"#990909\" ALIGN=center>\n");
  fprintf (fic,
	   "<FONT FACE =\"ARIAL\" size=-1 color=\"#FFFFFF\">TABLEUR</FONT>\n");
  fprintf (fic, "</TH>\n</TR>\n</TABLE>\n");
*/
  fprintf (fic, "<CENTER>\n");
  fprintf (fic,
	   "<FORM METHOD=\"POST\" action=\"/cgi-bin/tableur.cgi\" target=\"new\">\n");
  fprintf (fic, "<SELECT NAME=\"mois\" size=\"3\">\n");
  for (c = 1; c < 13; c++)
    {
      fprintf (fic,
	       "<option value=\"%stableur/%d%d\">%d %d</option>\n",
	       Conf.METEO_HTML_DIR, c, tb->tm_year + 1900, c,
	       tb->tm_year + 1900);
    }
  fprintf (fic, "</SELECT>\n");

  fprintf (fic, "<input type=\"submit\" value=\"Tableur\">\n");
  fprintf (fic, "</FORM>\n");
  fprintf (fic, "</CENTER>\n");
//  fprintf (fic, "</DL>\n");
//  fprintf (fic, "<HR>\n");

  fprintf (fic,
	   "<TABLE WIDTH=\"100%\">\n<TR>\n<th BGCOLOR=\"#990909\" ALIGN=center>\n");
  fprintf (fic,
	   "<FONT FACE =\"ARIAL\" size=-1 color=\"#FFFFFF\"> LINKS</FONT>\n");
  fprintf (fic, "</TH>\n</TR>\n</TABLE>\n");

//  fprintf (fic, "<DL>\n");
  fprintf (fic, "<FONT FACE=\"Arial\" size=-2>\n");
  fprintf (fic,
	   "<LI><A HREF=\"http://f5exo.free.fr/\" TARGET=\"NEW\">INFOS</A></LI>\n");

  fprintf (fic,
	   "<LI><A HREF=\"%s\" TARGET=\"NEW\">LINKS</A></LI>\n",
	   Conf.HTMLLink);

  fprintf (fic,
	   "<LI><a HREF=\"http://dbserv.maxim-ic.com/quick_view2.cfm?qv_pk=1070\" TARGET=\"NEW\">MAX186</A></LI>\n");
  fprintf (fic, "</FONT>\n");
//  fprintf (fic, "</DL>\n");
//  fprintf (fic, "<HR>\n");

  fprintf (fic,
	   "<TABLE WIDTH=\"100%\">\n<TR>\n<TH BGCOLOR=\"#990909\" ALIGN=center>\n");
  fprintf (fic,
	   "<FONT FACE =\"ARIAL\" size=-1 color=\"#FFFFFF\"> DOWNLOAD</FONT>\n");
  fprintf (fic, "</TH>\n</TR>\n</TABLE>\n");

//  fprintf (fic, "<DL>\n");
  fprintf (fic, "<FONT FACE =\"Arial\" size=-2>\n");
  fprintf (fic,
	   "<LI><A HREF=\"%s\" TARGET=\"WIN2\">%s</A></LI>\n",package,package);
  fprintf (fic, "</FONT>\n");
//  fprintf (fic, "</DL>\n");
//  fprintf (fic, "<HR>\n");
  fprintf (fic, "</BODY>\n");
  fprintf (fic, "</HTML>\n");
  fclose (fic);

}

/*--------------------------FIN DE LA PARTIE HTML--------------------------*/
