/*
 * This file is used to configure the locations of essential files required
 * by ax25-utils. It is modified by the 'configure' script, but once created
 * the file config.h may be edited by hand to fit in with non-standard
 * systems.
 */

#ifndef	CONFIG_H
#define	CONFIG_H

/*
 * Some global #defines for programmers to use for conditional compilation
 */
#define HAVEAX25
#define HAVEROSE
#define HAVENETROM


/*
 * The /proc filesystem entries
 */
#define	PROC_AX25_FILE		"/proc/net/ax25"
#define	PROC_AX25_CALLS_FILE	"/proc/net/ax25_calls"
#define	PROC_AX25_ROUTE_FILE	"/proc/net/ax25_route"

#define	PROC_NR_FILE		"/proc/net/nr"
#define	PROC_NR_NEIGH_FILE	"/proc/net/nr_neigh"
#define	PROC_NR_NODES_FILE	"/proc/net/nr_nodes"

#define PROC_RS_FILE		"/proc/net/rose"
#define PROC_RS_NEIGH_FILE	"/proc/net/rose_neigh"
#define PROC_RS_NODES_FILE	"/proc/net/rose_nodes"
#define PROC_RS_ROUTES_FILE	"/proc/net/rose_routes"

#define	PROC_IP_ROUTE_FILE	"/proc/net/route"

#define PROC_AX25_SYSCTL_DIR	"/proc/sys/net/ax25"
#define PROC_NR_SYSCTL_DIR	"/proc/sys/net/netrom"
#define PROC_RS_SYSCTL_DIR	"/proc/sys/net/rose"

/*
 * THE configuration files
 */
#define	CONF_AXPORTS_FILE	"/etc/ax25/axports"
#define	CONF_NRPORTS_FILE	"/etc/ax25/nrports"
#define	CONF_RSPORTS_FILE	"/etc/ax25/rsports"

/*
 * mheard specific
 */
#define	DATA_MHEARD_FILE	"/var/ax25/mheard/mheard.dat"

/*
 * ttylinkd specific
 */
#define	CONF_TTYLINKD_FILE	"/etc/ax25/ttylinkd.conf"

/*
 * Location of serial port lock files
 */
#define	LOCK_SERIAL_DIR		"/var/lock"

#endif
