/*                  HamRadioAX25 F5EXO@@F6KSU.FPDL.FRA.EU                  */
/*                           mail:f5exo@free.fr                            */
/*                     Web:http://f5exo.free.fr/meteo/                     */
/*                            Erick LINE                                   */

/* Pin 11 LPT (busy) utilise en entree pour recevoir sous forme serie      */
/* Pin 2  LPT (D0) utilisee pour generee l'horloge SCLK                    */
/* Pin 3  LPT (D1) utilisee pour generee CS                                */
/* Pin 4  LPT (D2) utilisee pour envoyer les donnees vers le MAX186.       */
/*                                                                         */
/* Pin 15 LPT (/ERROR)     Bit 3   (comptage impulsions) In                */
/* Pin 13 LPT (/SELECT)    Bit 4   (comptage impulsions) In                */
/* Pin 12 LPT (/PAPER OUT) Bit 5   (comptage impulsions) In                */
/*                                                                         */
/* Pin 17 LPT (Select_IN)  Bit 3   (Alarm 2) Out                           */
/* Pin 16 LPT (INIT)       Bit 2   (Alarm 1) Out                           */
/*                                                                         */
/*                   Calcul Valeur analogique                              */
/*           Val analog = (DATA*(Uref/CAN)-Offset)/Unites                  */
/*           Ou DATA    = valeur digitale lue en sortie CAN                */
/*              Uref    = Tension de reference du CAN  4.096               */
/*              CAD     = CAN 12 bits pour MAX186                          */
/*              Offset  = valeur offset du composant capteur               */
/*              Unites  = facteur mutiplicateur du composant capteur       */

/*------------------------------SCANLPT------------------------------------*/

#ifdef French
static char Jours[7][9] = {
  "Dimanche", "Lundi", "Mardi", "Mercredi", "Jeudi", "Vendredi",
  "Samedi"
};


static char Mois[12][10] = {
  "Janvier", "Fvrier", "Mars", "Avril", "Mai", "Juin", "Juillet", "Aout",
  "Septembre",
  "Octobre", "Novembre", "Dcembre"
};


static char Legend[11][13] = {
  "Capteurs", "Maxi", "Actuelle", "Mini", "Units", "Date", "Val binaire",
  "Channel", "Mesure", "Seuil Alarme","Peak"
};
static char Beaufort[13][20] =
  { "0 Calme", "1 Trs lgre brise", "2 Lgre brise", "3 Petite brise",
  "4 Jolie brise",
  "5 Bonne brise",
  "6 Vent frais", "7 Grand frais", "8 Coup de vent",
  "9 Fort coup de vent",
  "10 Tempete",
  "11 Violente tempete", "12 Ouragan"
};


static char Cadran[16][5] = {
  "Nord", "N.N.E", "N.E", "E.N.E", "Est", "E.S.E", "S.E", "S.S.E", "Sud",
  "S.S.O",
  "S.O", "O.S.O", "Ouest", "O.N.O", "N.O", "N.N.O"
};

/*static char State[2][5] = { "Bas","Haut"};*/
static char rain[3][12] = { "24 Heure", "1 Heure", "Apres 0h" };
#endif





#ifdef English

static char Jours[7][10] = {
  "Sunday", "Monday", "Thuesday", "Wednesday", "Thursday", "Friday",
  "Saturday"
};


static char Mois[12][10] = {
  "January", "February", "March", "April", "May", "June", "July", "August",
  "September",
  "October", "November", "December"
};


static char Legend[11][12] = {
  "Sensors", "Maxi", "Current", "Mini", "Units", "Date", "Val binaire",
  "Channel", "Measure", "Alarm level","Peak"
};
static char Beaufort[13][20] =
  { "0 Calm", "1 Light air", "2 Light breeze", "3 Gentle breeze",
  "4 Moderate breeze",
  "5 Fresh breeze", "6 Strong breeze",
  "7 Moderate gale", "8 Fresh gale",
  "9 Strong gale",
  "10 Whole gale", "11 Storm", "12 Hurricane"
};


static char Cadran[16][5] = {
  "North", "N.N.E", "N.E", "E.N.E", "East", "E.S.E", "S.E", "S.S.E",
  "South",
  "S.S.W",
  "S.W", "W.S.W", "West", "W.N.W", "N.W", "N.N.W"
};

/*static char State[2][6] = { "Low","Hight"};*/
static char rain[3][11] = { "Last 24H", "Last 1h", "Since 0h" };
#endif




#ifdef Deutsch

static char Jours[7][11] = {
  "Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag",
    "Samstag"
};


static char Mois[12][10] = {
  "Januar", "Februar", "Mrz", "April", "Mai", "Juni", "Juli", "August",
  "September",
  "October", "November", "December"
};


static char Legend[11][12] = {
  "Sensoren", "Maximal", "Momentan", "Minimal", "Einheit", "Datum",
    "Binrwert",
  "Kanal", "Messwert", "Alarm level","Peak"
};
static char Beaufort[13][22] =
  { "0 Windstille", "1 leichter Zug", "2 leichter Wind", "3 schwacher Wind",
  "4 miger Wind",
  "5 frischer Wind", "6 starker Wind",
  "7 steifer Wind", "8 strmischer Wind",
  "9 Sturm",
  "10 schwerer Sturm", "11 orkanartiger Sturm", "12 Orkan"
};


static char Cadran[16][5] = {
  "Nord", "NNO", "NO", "ONO", "Ost", "OSO", "SO", "SSO",
  "Sd",
  "SSW",
  "SW", "OSW", "West", "WNW", "NW", "NNW"
};

/*static char State[2][6] = { "Low","Hight"};*/
static char rain[3][11] = { "Letzte 24H", "Letzte 1h", "Seit 0h" };
#endif
