/*                  HamRadioAX25 F5EXO@@F6KSU.FPDL.FRA.EU                  */
/*                           mail:f5exo@free.fr                            */
/*                     Web:http://f5exo.free.fr/meteo/                     */
/*                            Erick LINE                                   */

/* Pin 11 LPT (busy) utilise en entree pour recevoir sous forme serie      */
/* Pin 2  LPT (D0) utilisee pour generee l'horloge SCLK                    */
/* Pin 3  LPT (D1) utilisee pour generee CS                                */
/* Pin 4  LPT (D2) utilisee pour envoyer les donnees vers le MAX186.       */
/*                                                                         */
/* Pin 15 LPT (/ERROR)     Bit 3   (comptage impulsions) In                */
/* Pin 13 LPT (/SELECT)    Bit 4   (comptage impulsions) In                */
/* Pin 12 LPT (/PAPER OUT) Bit 5   (comptage impulsions) In                */
/*                                                                         */
/* Pin 17 LPT (Select_IN)  Bit 3   (Alarm 2) Out                           */
/* Pin 16 LPT (INIT)       Bit 2   (Alarm 1) Out                           */
/*                                                                         */
/*                   Calcul Valeur analogique                              */
/*           Val analog = (DATA*(Uref/CAN)-Offset)/Unites                  */
/*           Ou DATA    = valeur digitale lue en sortie CAN                */
/*              Uref    = Tension de reference du CAN  4.096               */
/*              CAD     = CAN 12 bits pour MAX186                          */
/*              Offset  = valeur offset du composant capteur               */
/*              Unites  = facteur mutiplicateur du composant capteur       */

/*------------------------------SCANLPT------------------------------------*/

#ifdef French
static char menu[4][57] = {
  "meteo (sans arg) = valeures actuelles.\n\n",
  "Syntaxe: meteo -arg\n",
  "arg [ -0 -1 -2 -3 -4 -5 -6 -7 -8 -9 -10\n",
  "-b -i -c -D -H -l -S -A -N -x -d -e -g  -v -rl -rm -mn]\n\n"
};

static char detail_menu[17][78] = {
  "-b      Envoi balise WX APRS.\n",
  "-c      Lecture configuration.\n",
  "-S      Voir les messages systme.\n",
  "-i      Init fichier data (meteo.dat).\n",
  "-D      Debug trace les entres.\n",
  "-0..10  Voir Channel No 0...10.\n",
  "-A      Historique analogique.\n",
  "-N      Historique numerique.\n",
  "-e      Valeurs actuelles.\n",
  "-g      Generation graphiques.\n",
  "-l      Affichage log AX25.\n",
  "-x      Exploration et acquisition des mesures et mise  jour fichiers.\n",
  "-d      Explo et acquisition des mesures en daemon.\n",
  "-v      Visualisation des sorties alarmes.\n",
  "-rl     Raz process meteo var/lock.\n",
  "-rm     Raz messages system meteo.\n"    
  "-mn     Raz maxi & mini.\n"    
};
#endif


#ifdef English
static char menu[4][56] = {
  "meteo (without arg) = Current values.\n\n",
  "Syntax: meteo -arg\n",
  "arg [ -0 -1 -2 -3 -4 -5 -6 -7 -8 -9 -10\n",
  "-b -i -c -D -H -l -S -A -N -x -d -e -g -v -rl -rm -mn]\n\n"
};

static char detail_menu[17][60] = {
  "-b     Send APRS WX Beacon.\n",
  "-c     Show Configuration.  (meteo.conf)\n",
  "-S     Show System messages.(meteo.msg)\n",
  "-i     Init data file.      (meteo.dat)\n",
  "-D     Debug trace input datas.\n",
  "-0..10 View  Channel No 0....10.\n",
  "-A     View Analog historic.\n",
  "-N     View Numeric historic.\n",
  "-e     Current values.\n",
  "-g     Graphics.\n",
  "-l     View AX25 log.\n",
  "-x     Scanning sensors and update data files.\n",
  "-d     Scanning sensors and update data files in daemon.\n",
  "-v     View warning output.\n",
  "-rl    Raz process meteo var/lock.\n",
  "-rm    Delete meteo messages system.\n"  
  "-mn    Raz maxi & mini.\n"  
};
#endif


#ifdef Deutsch
static char menu[4][56] = {
  "meteo (ohne Argument) = aktuelle Messwerte.\n\n",
  "Syntax: meteo -arg\n",
  "arg [ -0 -1 -2 -3 -4 -5 -6 -7 -8 -9 -10\n",
  "-b -i -c -D -H -l -S -A -N -x -d -e -g -v -rl -rm -mn]\n\n"
};

static char detail_menu[17][65] = {
  "-b     APRS-Wetterbake senden.\n",
  "-c     Konfiguration der Wetterstation zeigen.(meteo.conf)\n",
  "-S     Systemmeldungen zeigen.(meteo.msg)\n",
  "-i     Datenbank initialisieren.(meteo.dat)\n",
  "-D     aktuelle Sensor-Rohdaten ausgeben.\n",
  "-0..10 Messwerte eines Kanals (0..10) ausgeben.\n",
  "-A     Liste der Messwerte anzeigen.\n",
  "-N     Liste der Sensor-Rohdaten anzeigen.\n",
  "-e     Aktuelle Messwerte.\n",
  "-g     Grafiken erzeugen.\n",
  "-l     AX25-Log zeigen.\n",
  "-x     Sensoren abfragen, Datenbank aktualisieren.\n",
  "-d     Sensoren abfragen, Datenbank aktualisieren als Daemon.\n",
  "-v     View warning output.\n",
  "-rl    Raz process meteo var/lock.\n",
  "-rm    Delete meteo messages system.\n"
  "-mn    Raz maxi & mini.\n"    
};
#endif
