/*                  HamRadioAX25 F5EXO@@F6KSU.FPDL.FRA.EU                  */
/*                           mail:f5exo@free.fr                            */
/*                     Web:http://f5exo.free.fr/meteo/                     */
/*                            Erick LINE                                   */

/* Pin 11 LPT (busy) utilise en entree pour recevoir sous forme serie      */
/* Pin 2  LPT (D0) utilisee pour generee l'horloge SCLK                    */
/* Pin 3  LPT (D1) utilisee pour generee CS                                */
/* Pin 4  LPT (D2) utilisee pour envoyer les donnees vers le MAX186.       */
/*                                                                         */
/* Pin 15 LPT (/ERROR)     Bit 3   (comptage impulsions) In                */
/* Pin 13 LPT (/SELECT)    Bit 4   (comptage impulsions) In                */
/* Pin 12 LPT (/PAPER OUT) Bit 5   (comptage impulsions) In                */
/*                                                                         */
/* Pin 17 LPT (Select_IN)  Bit 3   (Alarm 2) Out                           */
/* Pin 16 LPT (INIT)       Bit 2   (Alarm 1) Out                           */
/*                                                                         */
/*                   Calcul Valeur analogique                              */
/*           Val analog = (DATA*(Uref/CAN)-Offset)/Unites                  */
/*           Ou DATA    = valeur digitale lue en sortie CAN                */
/*              Uref    = Tension de reference du CAN  4.096               */
/*              CAD     = CAN 12 bits pour MAX186                          */
/*              Offset  = valeur offset du composant capteur               */
/*              Unites  = facteur mutiplicateur du composant capteur       */

/*------------------------------SCANLPT------------------------------------*/

#define METEO_VERSION		"2.4.4"

/* A Valider pour l'observation des sigaux LPT */
//#define DEBUG

/* Define Language */

#define French
//#define English
//#define Deutsch

#define RRDTOOL

#define CONF_METEO_INFO_FILE    "/etc/meteo/meteo.info"
#define CONF_METEO_CONF_FILE    "/etc/meteo/meteo.conf"
#define CONF_METEO_MOTD_FILE    "/etc/meteo/meteo.motd"
#define DATA_METEO_LOGIN_FILE   "/var/meteo/loggedin"
#define MSG_METEO_DATA_FILE     "/var/meteo/meteo.msg"
#define RRD_METEO_DATA_DIR     "/var/meteo/"
#define DATA_METEO_TALK_FILE    "/var/meteo/talk.pm/pipe.%d"
#define METEO_DATA_FILE         "/var/meteo/meteo.dat"
#define METEO_LOG_FILE          "/var/meteo/meteo.log"
#define METEO_LOCK_FILE         "/var/lock/meteo"


#define MAIL_DELIVERY_AGENT     "/usr/sbin/sendmail %s"
#define MY_TALK                 "/usr/sbin/ttylinkd"

#define LAST_DATA_SIZE 10	/* Lastlog defines */

#define CAN  	12		/* 12bits resolution CAN MAX186        */
#define CS   	2		/* CS   pin 18 MAX186 (pin 3 DB25 D1)  */
#define DIN  	4		/* DIN  pin 17 MAX186 (pin 4 DB25 D2)  */
#define SCLK 	1		/* SCLK pin 19 MAX186 (pin 2 DB25 D0)  */
#define INIT 	0x02		/* 00000010 CS line D1 LPT             */
#define PAS  	4095		/* 2e12 */
#define CAD 	(Uref/PAS)
#define pi	3.1415926
#define M 	1440
#define xTempo	1000

//static char chaine [600];

char package [15]= "axmeteo244.tgz";

long tab[11][3][3][M] = { };
long durees;
long dureeus;
struct tm *tb;
char RRD_FILE[9];
char TXT_FILE[9];
char RRD_OLD_FILE[9];
char RRD_METEO_DATA_BASE[20];
char METEO_TXT_BASE[64];
char param[3];
float Uref;
int IN_PORT, IN_PORT_2, OUT_PORT_2, alarm1, alarm2, out = 0;
long t, compteur, compteurmaj;
char beacon[250] = { };
char actuel[7] = {"%.1lf "};
static char retendance[80];
char *tendance;

static char delimiter;		/* Caractere de saut de ligne ou CR suivant local ou AX25 */

int intch[8][20] = {		/*chronograme CONTROL BYTE MAX186 (voir data sheet P10-11) */
/*Ch 0 */ {2, 0, 4, 5, 0, 1, 0, 1, 0, 1, 4, 5, 4, 5, 4, 5, 0, 1},
/*Ch 1 */ {2, 0, 4, 5, 4, 5, 0, 1, 0, 1, 4, 5, 4, 5, 4, 5, 0, 1},
/*Ch 2 */ {2, 0, 4, 5, 0, 1, 0, 1, 4, 5, 4, 5, 4, 5, 4, 5, 0, 1},
/*Ch 3 */ {2, 0, 4, 5, 4, 5, 0, 1, 4, 5, 4, 5, 4, 5, 4, 5, 0, 1},
/*Ch 4 */ {2, 0, 4, 5, 0, 1, 4, 5, 0, 1, 4, 5, 4, 5, 4, 5, 0, 1},
/*Ch 5 */ {2, 0, 4, 5, 4, 5, 4, 5, 0, 1, 4, 5, 4, 5, 4, 5, 0, 1},
/*Ch 6 */ {2, 0, 4, 5, 0, 1, 4, 5, 4, 5, 4, 5, 4, 5, 4, 5, 0, 1},
/*Ch 7 */ {2, 0, 4, 5, 4, 5, 4, 5, 4, 5, 4, 5, 4, 5, 4, 5, 0, 1}
/*               cs  sta s2  s1  s0  uni sin pd1 pd0                        		
                     1   x   x   x   1   1   1   0 
		         No de voie
*/
};

struct Conf
{
  char SysOp[7];
  char locator[7];
  char latitude[10];
  char longitude[10];
  char qth[32];
  int altitude;
  char ax25Call[9];
  char ConvIdent[9];
  char Ax25Convers[16];
  char HTMLLink[64];
  char Partner[64];
  char Digi[2][160];
  char Port[2][50];
  int OUT_PORT;
  char METEO_HTML_DIR[64];
  unsigned C;
  unsigned Sleep;
  int Mn;
   char LINUX[64];
}
Conf;

struct
{
  char sgnla[1];
  double location[2];
  char sgnlo[1];
}
aprs;
struct capteurs
{
  char Mesure[14];
   				/* Type de mesure,Temp,vent */
  char sensor[14];
   				/* reference du capteur     */
  float Unites;
   				/* Multiplicateur           */
  float Offset;
   				/* offset constructeur      */
  char Unite[14];
   				/* Degres, hPa,%HR...etc    */
  char Comp[1];			/* Comparateur Alarme ! = pas d'alarme, =, >, <  */

  float Seuil;
   				/* Seuil Alarme             */

}
capteurs[11];


struct Alarms
{
  int Channel;
  char Comp[1];
  int Seuil;
}
Alarms[2];

struct Valeurs
{
  long Maxi;
  long Inst;
  long Mini;
  long Date_Maxi;
  long Date_Inst;
  long Date_Mini;
}
Valeurs[11];


char call[10];
struct nodelastlog
{
  char ll_user[8];
   long ll_time;
   char ll_line[LAST_DATA_SIZE];
   char ll_host[LAST_DATA_SIZE];
   int ll_count;
};
typedef struct
{
  char indic[12];
   long date;
   long cnt;
   char cmd[12];
 }
Log;

// Fin //
