/*                  HamRadioAX25 F5EXO@@F6KSU.FPDL.FRA.EU                  */
/*                           mail:f5exo@free.fr                            */
/*                     Web:http://f5exo.free.fr/meteo/                     */
/*                            Erick LINE                                   */

/* Pin 11 LPT (busy) utilise en entree pour recevoir sous forme serie      */
/* Pin 2  LPT (D0) utilisee pour generee l'horloge SCLK                    */
/* Pin 3  LPT (D1) utilisee pour generee CS                                */
/* Pin 4  LPT (D2) utilisee pour envoyer les donnees vers le MAX186.       */
/*                                                                         */
/* Pin 15 LPT (/ERROR)     Bit 3   (comptage impulsions) In                */
/* Pin 13 LPT (/SELECT)    Bit 4   (comptage impulsions) In                */
/* Pin 12 LPT (/PAPER OUT) Bit 5   (comptage impulsions) In                */
/*                                                                         */
/* Pin 17 LPT (Select_IN)  Bit 3   (Alarm 2) Out                           */
/* Pin 16 LPT (INIT)       Bit 2   (Alarm 1) Out                           */
/*                                                                         */
/*                   Calcul Valeur analogique                              */
/*           Val analog = (DATA*(Uref/CAN)-Offset)/Unites                  */
/*           Ou DATA    = valeur digitale lue en sortie CAN                */
/*              Uref    = Tension de reference du CAN  4.096               */
/*              CAD     = CAN 12 bits pour MAX186                          */
/*              Offset  = valeur offset du composant capteur               */
/*              Unites  = facteur mutiplicateur du composant capteur       */

/*------------------------------SCANLPT------------------------------------*/

/* Msg des commandes effectuees par les users dans axmeteo */

/* Consultation log ax25 */
void
Visu_logAX25 (void)
{
  int last;
  int re, cnx = 0;
  struct nodelastlog ll;
  int Entries = 0;
  *call = '\0';
  {
    time_t t;
    time (&t);
  }


  if ((last = open (METEO_LOG_FILE, O_RDONLY, 0)) >= 0)
    {
      lseek (last, (off_t) Entries * sizeof (ll), L_SET);
      while (read (last, (char *) &ll, sizeof (ll)) == sizeof (ll)
	     && ll.ll_time != 0)
	{
	  if (Entries == 0)
	    {
	      blancvif ();
	      printf ("Indicatif  Date                     Nb Cnx%c",
		      delimiter);
	      printf ("---------- -------------------  ------------ %c",
		      delimiter);
	      resetcouleur ();
	    }
	  jaune ();
	  printf ("%-10s ", ll.ll_user);
	  resetcouleur ();
	  tb = localtime (&ll.ll_time);

	  printf ("%1.2d %4.4s %2.2d %2.2d:%2.2d", tb->tm_mday,
		  Mois[tb->tm_mon], tb->tm_year + 1900, tb->tm_hour,
		  tb->tm_min);

	  printf ("%13d%c", ll.ll_count, delimiter);
	  cnx = cnx + ll.ll_count;

	  Entries++;

	  if (Entries % 21 == 0)
	    {
	      vert ();
	      printf ("(A)rret - (CR)ontinue\n");
	      resetcouleur ();
/*       Pagination a 22 lignes */
	      fflush (stdout);
	      re = getchar ();
	      if ((re == 97) || (re == 65))
		{
		  break;
		}
	      blancvif ();
	      printf ("Indicatif  Date                     Nb Cnx%c",
		      delimiter);
	      printf ("---------- -------------------  ------------ %c",
		      delimiter);
	      resetcouleur ();

	    }

	}
      lseek (last, (off_t) Entries * sizeof (ll), L_SET);
      close (last);
    }
  blancvif ();
  printf ("---------- -------------------  ------------ %c", delimiter);
  blancvif ();
  resetcouleur ();
  bleu ();
  printf ("Total  %6d utilisateurs %15d Cnx%c", Entries, cnx, delimiter);
  resetcouleur ();
  printf ("%c", delimiter);
}
