/*                  HamRadioAX25 F5EXO@@F6KSU.FPDL.FRA.EU                  */
/*                           mail:f5exo@free.fr                            */
/*                     Web:http://f5exo.free.fr/meteo/                     */
/*                            Erick LINE                                   */

/* Pin 11 LPT (busy) utilise en entree pour recevoir sous forme serie      */
/* Pin 2  LPT (D0) utilisee pour generee l'horloge SCLK                    */
/* Pin 3  LPT (D1) utilisee pour generee CS                                */
/* Pin 4  LPT (D2) utilisee pour envoyer les donnees vers le MAX186.       */
/*                                                                         */
/* Pin 15 LPT (/ERROR)     Bit 3   (comptage impulsions) In                */
/* Pin 13 LPT (/SELECT)    Bit 4   (comptage impulsions) In                */
/* Pin 12 LPT (/PAPER OUT) Bit 5   (comptage impulsions) In                */
/*                                                                         */
/* Pin 17 LPT (Select_IN)  Bit 3   (Alarm 2) Out                           */
/* Pin 16 LPT (INIT)       Bit 2   (Alarm 1) Out                           */
/*                                                                         */
/*                   Calcul Valeur analogique                              */
/*           Val analog = (DATA*(Uref/CAN)-Offset)/Unites                  */
/*           Ou DATA    = valeur digitale lue en sortie CAN                */
/*              Uref    = Tension de reference du CAN  4.096               */
/*              CAD     = CAN 12 bits pour MAX186                          */
/*              Offset  = valeur offset du composant capteur               */
/*              Unites  = facteur mutiplicateur du composant capteur       */

/*------------------------------SCANLPT------------------------------------*/

#include <stdio.h>

#include <linux/mc146818rtc.h>

#include <sys/ioctl.h>
#include <fcntl.h>
#include <sched.h>

#include <string.h>
#include <ctype.h>
#include <signal.h>
#include <time.h>
#include <sys/time.h>
#include <stdlib.h>


#include <unistd.h>
#include <asm/io.h>
#include <math.h>
#include <errno.h>



#include "include/meteo.h"
#include "include/lang.h"
#include "include/menu.h"
#include "fichiers/txt_upd.c"
#include "meteoconf.c"
#include "aprs/loc.c"
#include "daemon.c"
#include "rrdtool/rrdwrap.c"
#include "rrdtool/rrd.c"
#include "couleur/couleur.c"
#include "cmd.c"
#include "aprs/aprs.c"
#include "rrdtool/meteograph.c"
#include "rrdtool/meteohist.c"
#include "rrdtool/meteoanhist.c"
#include "html/html.c"
#include "html/map.c"
#include "html/confhtml.c"
#include "scanlpt.c"
#include "logax25.c"

static char delimiter = '\n';

void
raz_msg (void)
{
  FILE *msg;
  char raz[25] = { "rm -f " };
  strcat (raz, MSG_METEO_DATA_FILE);
  printf (raz);
  printf ("\n");
  system (raz);
  {
    time_t t;
    t = time (NULL);
    tb = localtime (&t);

    msg = fopen (MSG_METEO_DATA_FILE, "w");
    fprintf (msg, "%s %d %s %d %2.2d:%2.2d-->File %s clear \n",
	     Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
	     tb->tm_year + 1900, tb->tm_hour, tb->tm_min,
	     MSG_METEO_DATA_FILE);
  }
  fclose (msg);
}

void
RAZ_lock_var (void)
{
  char raz[25] = { "" };
  strcpy (raz, "rm -f /var/lock/meteo");
  printf (raz);
  printf ("\n");
  system (raz);
}


/* Init fichier meteo.dat */
void
init_file (void)
{
  FILE *msg;
  FILE *fic;
  int i, j;
  char htmlfic[80] = { };
  char png[80] = { "rm -f " };
  char htm[80] = { "rm -f " };

  msg = fopen (MSG_METEO_DATA_FILE, "w");
  fic = fopen (METEO_DATA_FILE, "w");
  Test_IO ();
  remove (METEO_LOCK_FILE);
  for (i = 0; i < Conf.C - 3; i++)
    {
      tab[i][0][2][0] = 4096;
    }

  // valeur crete mini 
  for (i = 0; i < Conf.C - 3; i++)
    {
      tab[i][0][0][2] = 4096;
    }


  for (i = 0; i < Conf.C - 3; i++)
    {
      tab[i][0][0][0] = 0;
    }

// mise a 0 de l'histo

  for (i = 0; i < Conf.C - 3; i++)
    {
      for (j = 0; j > M; j++)
	{
	  tab[i][2][1][j] = 0;
	  tab[i][2][2][j] = 0;
	}
    }


  /* valeurs Mini configues au maxi pour le comparatif Mini */
  init_date ();
  fwrite (&tab, 4, (Conf.C * 3 * 3 * M), fic);
  fclose (fic);
#ifdef  French
  printf ("OK Fichier initalis aux valeurs 0.%c", delimiter);
#endif
#ifdef  English
  printf ("OK File set to 0 value.%c", delimiter);
#endif
#ifdef  Deutsch
  printf ("OK File set to 0 value.%c", delimiter);
#endif

  {
    time_t t;
    t = time (NULL);
    tb = localtime (&t);
    fprintf (msg, "%s %d %s %d %2.2d:%2.2d-->Fichier %s initialise.\n",
	     Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
	     tb->tm_year + 1900, tb->tm_hour, tb->tm_min,
	     MSG_METEO_DATA_FILE);
    fprintf (msg, "%s %d %s %d %2.2d:%2.2d-->Fichier %s initialise.\n",
	     Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
	     tb->tm_year + 1900, tb->tm_hour, tb->tm_min, METEO_DATA_FILE);
  }
  fclose (msg);
  /* effacement des eventuels graphs dans html dir */
  printf ("Effacement des anciens graphes. Eraze old graphics\n");
  strcpy (htmlfic, Conf.METEO_HTML_DIR);
//      strcat (htmlfic, capteurs[i].Mesure);
  strcat (png, htmlfic);
  strcat (png, "*.png");
  printf (png);
  printf ("\n");
  system (png);
  strcpy (png, "");
  strcat (htm, htmlfic);
  strcat (htm, "*.html");
  printf (htm);
  printf ("\n");
  system (htm);

  RAZ_lock_var ();
  rrd_ini ();
  init_out2 ();
  printf ("RAZ Alarms\n");
  return;
}


/* Ouverure du fichier Open_Meteo) */
void
Open_Meteo (void)
{
  FILE *fic;
  int c;
  if ((fic = fopen (METEO_DATA_FILE, "r")) == NULL)
    {
#ifdef French
      printf ("meteo.dat non trouv ! Initialisation du fichier.%c",
	      delimiter);
#endif
#ifdef English
      printf ("meteo.dat nor found ! Init file.%c", delimiter);
#endif
#ifdef Deutsch
      printf ("meteo.dat nicht fund ! Init file.%c", delimiter);
#endif
      init_file ();
    }
  (fic = fopen (METEO_DATA_FILE, "r"));
  fread (&tab, 4, (Conf.C * 3 * 3 * M), fic);
  fclose (fic);

  for (c = 0; c < Conf.C; c++)
    {
      Valeurs[c].Maxi = tab[c][0][0][0];
      Valeurs[c].Inst = tab[c][0][1][0];
      Valeurs[c].Mini = tab[c][0][2][0];

      Valeurs[c].Date_Maxi = tab[c][1][0][0];
      Valeurs[c].Date_Inst = tab[c][1][1][0];
      Valeurs[c].Date_Mini = tab[c][1][2][0];
/* 
   Valeurs compteur     = tab[0][2][0][0];
   Valeurs Date_Init    = tab[0][2][0][1];
   it (en secondes)     = tab[0][2][0][2];
   temps t              = tab[0][2][0][3];
   temps t-1            = tab[0][2][0][4];
   compteurmaj		= tab[0][2][0][5];
   Valeurs hist mesures  [c][2][1][0----M] 
   valeurs hist dates    [c][2][2][0----M]  
*/
    }
  compteur = tab[0][2][0][0];
  compteurmaj = tab[0][2][0][5];
  return;
}


void
Set_MaxMin (void)
{
  FILE *msg;
  FILE *fic;
  int i;
  msg = fopen (MSG_METEO_DATA_FILE, "w");
  fic = fopen (METEO_DATA_FILE, "w");
  Test_IO ();
  for (i = 0; i < Conf.C - 3; i++)
    {
      tab[i][0][2][0] = 4096;
      tab[i][0][0][0] = 0   ;
      tab[i][0][0][1] = 0   ;
    }

  /* valeurs Mini configues au maxi pour le comparatif Mini */
  fwrite (&tab, 4, (Conf.C * 3 * 3 * M), fic);
  fclose (fic);
#ifdef  French
  printf ("OK Valeur Maxi & Mini initalis aux valeurs 0.%c", delimiter);
#endif
#ifdef  English
  printf ("OK Maxi & Mini set to 0 value.%c", delimiter);
#endif
#ifdef  Deutsch
  printf ("OK Maxi & Mini set to 0 value.%c", delimiter);
#endif

  {
    time_t t;
    t = time (NULL);
    tb = localtime (&t);
    fprintf (msg, "%s %d %s %d %2.2d:%2.2d-->Fichier %s initialise.\n",
	     Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
	     tb->tm_year + 1900, tb->tm_hour, tb->tm_min,
	     MSG_METEO_DATA_FILE);
    fprintf (msg, "%s %d %s %d %2.2d:%2.2d-->Fichier %s initialise.\n",
	     Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
	     tb->tm_year + 1900, tb->tm_hour, tb->tm_min, METEO_DATA_FILE);
  }
  fclose (msg);
  return;
}

/* Syntaxe parametre */
void
print_syntax (void)
{
  int i;
  Clr_scr ();
  rouge ();
  Entete ();
  resetcouleur ();
  blancvif ();
  for (i = 0; i < 4; i++)
    {
      printf (menu[i]);
    }
  resetcouleur ();
  bleu ();
  for (i = 0; i < 16; i++)
    {
      printf (detail_menu[i]);
    }
  resetcouleur ();
  printf ("\n\r");
}

/* Affiche le resume des valeurs actuelles */
void
Print_Resume (void)
{
  int c;
  int j = 0;
  float z;
  printf ("\n");
  printf ("[METEO-Linux version %s] F5EXO QTH %s\r", METEO_VERSION, Conf.qth);
  Open_Meteo ();
  printf ("\n");
  for (c = 0; c < 4; c++)
    {
/*  z=tab[c][1];*/
      z = ((Valeurs[c].Inst * CAD) - capteurs[c].Offset) / capteurs[c].Unites;
      printf ("[%3.1f %1.12s] ", z, capteurs[c].Unite);
    }
  printf ("\n");
  for (c = 4; c < Conf.C; c++)
    {
/*  z=tab[c][1];*/
      z = ((Valeurs[c].Inst * CAD) - capteurs[c].Offset) / capteurs[c].Unites;
      printf ("[%1.8s %3.1f %1.12s] ", capteurs[c].Mesure, z,
	      capteurs[c].Unite);
      j++;
      if (j % 3 == 0)
	{
	  printf ("\n");
	}
    }
  Date_fr ();
}

/************************ Main Programme Principal ************************/
int
main (int argc, char **argv)
{
  FILE *lock;
  FILE *msg;
#ifdef BSD
  signal (SIGALRM, graphtimer);
#else
  struct sigaction act;
  act.sa_handler = graphtimer;
  act.sa_flags = SA_RESTART;

  if (sigaction (SIGALRM, &act, NULL) == -1)
    {
      fprintf (stderr, "Erreur in sigaction\n");
      exit (errno);
    }
#endif

  Get_Conf ();			//   recup de la config dans /etc/ax25/meteo.conf  
  get_year ();
  Test_IO ();
  // Conversion locator en Lat/Long
  position (Conf.locator);

  if (argc == 1)
    {				// printf("Nombre d'argument = 1 (1 caratere).!\n"); 
      Clr_scr ();
      rouge ();
      Entete ();
      resetcouleur ();
      Open_Meteo ();		//  recuperartion des donnees depuis le fichier 
      Print_Compteur ();
      vert ();
      Print_Analog ();
      resetcouleur ();
      cyan ();
      printf (tendance = Tendance ());
      resetcouleur ();
      printf ("\n");
      printf ("\n");
      Date_fr ();
      printf ("Aide / Help => capteurs -?\n");
      exit (1);
    }
  if (strlen (argv[1]) > 3)
    {
      print_syntax ();		// printf("Argument trop long (1 caratere seulement).!\n"); 
      exit (1);
    }
  if (argc > 3)
    {
      print_syntax ();		// printf("Nombre d'argument >1 (1 caratere).!\n"); 
      exit (1);
    }
  strcpy (param, argv[1]);
  if (strlen (argv[1]) == 2)
    {
      if (param[0] == 45)	// le - 
	{
	  if ((param[1] == 105) || (param[1] == 73))	// Test sur i et I 
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
#ifdef French
	      printf ("Initialisation du fichier %s ...\n", METEO_DATA_FILE);
#endif
#ifdef English
	      printf ("Init file %s ...\n", METEO_DATA_FILE);
#endif

#ifdef Deutsch
	      printf ("Init file %s ...\n", METEO_DATA_FILE);
#endif
	      init_file ();
	      exit (1);
	    }

	  if ((param[1] == 99) || (param[1] == 67))	/* Test sur c et C */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();
	      Print_Conf ();
	      Conf_html ();
	      Index_html ();
	      logo_html ();
	      allsensor_html ();
	      maj_menu ();
	      exit (1);
	    }

	  if ((param[1] == 101) || (param[1] == 69))	/* Test sur e et E */
	    {
	      Print_Resume ();
	      printf ("\n");
	      exit (1);
	    }

	  if ((param[1] == 68))	/* Test sur D  */
	    {
	      if ((lock = fopen (METEO_LOCK_FILE, "r")) != NULL)
		{
		  blancvif ();
#ifdef French
		  printf ("\n *** Port LPT busy par le process meteo PID:");
#endif
#ifdef English
		  printf ("\n *** Port LPT busy by process meteo PID:");
#endif
#ifdef Deutsch
		  printf ("\n *** Port LPT busy by process meteo PID:");
#endif

		  catfile (METEO_LOCK_FILE);
		  printf (" ***\n\n");
		  resetcouleur ();
		  exit (1);
		}
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Debug_in ();
	      exit (1);
	    }

	  if ((param[1] == 48))	/* Test sur  0 */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();	/*   recuperartion des donnees depuis le fichier */
	      Print_Compteur ();
	      Print_Detail (tab, 0);	/* Detail Voie 0 */
	      Date_fr ();
	      printf ("\n");
	      exit (1);
	    }

	  if ((param[1] == 49))	/* Test sur  1 */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();	/*   recuperartion des donnees depuis le fichier */
	      Print_Compteur ();
	      Print_Detail (tab, 1);	/*   Detail Voie 1 */
	      Print_Date ();
	      exit (1);
	    }

	  if ((param[1] == 50))	/* Test sur  2 */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();	/*   recuperartion des donnees depuis le fichier */
	      Print_Compteur ();
	      Print_Detail (tab, 2);	/*   Detail Voie 2 */
	      Date_fr ();
	      printf ("\n");
	      exit (1);
	    }
	  if ((param[1] == 52))	/* Test sur  4 */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();	/*   recuperartion des donnees depuis le fichier */
	      Print_Compteur ();
	      Print_Detail (tab, 4);	/*   Detail Voie 4 */
	      Print_Date ();
	      exit (1);
	    }

	  if ((param[1] == 51))	/* Test sur  3 */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();	/*   recuperartion des donnees depuis le fichier */
	      Print_Compteur ();
	      Print_Detail (tab, 3);	/*   Detail Voie 3 */
	      Print_Date ();
	      exit (1);
	    }

	  if ((param[1] == 53))	/* Test sur  5 */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();	/*   recuperartion des donnees depuis le fichier */
	      Print_Compteur ();
	      Print_Detail (tab, 5);	/*   Detail Voie 5 */
	      Print_Date ();
	      exit (1);
	    }
	  if ((param[1] == 54))	/* Test sur  6 */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();	/*   recuperation des donnees depuis le fichier */
	      Print_Compteur ();
	      Print_Detail (tab, 6);	/*   Detail Voie 6 */
	      Date_fr ();
	      printf ("\n");
	      exit (1);
	    }
	  if ((param[1] == 55))	/* Test sur 7 */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();	/*   recuperation des donnees depuis le fichier */
	      Print_Compteur ();
	      Print_Detail (tab, 7);	/*   Detail Voie 7 */
	      Date_fr ();
	      printf ("\n");
	      exit (1);
	    }

	  if ((param[1] == 56))	/* Test sur 8 */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();	/*   recuperation des donnees depuis le fichier */
	      Print_Compteur ();
	      Print_Detail (tab, 8);	/*   Detail Voie 8 */
	      Date_fr ();
	      printf ("\n");
	      exit (1);
	    }

	  if ((param[1] == 57))	/* Test sur 9 */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();	/*   recuperation des donnees depuis le fichier */
	      Print_Compteur ();
	      Print_Detail (tab, 9);	/*   Detail Voie 9 */
	      Date_fr ();
	      printf ("\n");
	      exit (1);
	    }

	  if ((param[1] == 78) || (param[1] == 110))	/* Test sur N */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();	/*   recuperartion des donnees depuis le fichier */
	      Print_Compteur ();
	      Print_Histo_Data ();	/*   Historique Numerique */
	      Date_fr ();
	      printf ("\n");
	      exit (1);
	    }
	  if ((param[1] == 65) || (param[1] == 97))	/* Test sur A et a  */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();	/*   recuperartion des donnees depuis le fichier */
	      Print_Compteur ();
	      Print_Histo_Analog ();	/*   Historique analogique */
	      Date_fr ();
	      printf ("\n");
	      exit (1);
	    }

	  if ((param[1] == 115) || (param[1] == 83))	/* Test sur S et s  */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      catfile (MSG_METEO_DATA_FILE);
	      Date_fr ();
	      printf ("\n");
	      exit (1);
	    }

	  if ((param[1] == 120) || (param[1] == 88))	/* Test sur x  Exploration capteurs */
	    {
	      if ((lock = fopen (METEO_LOCK_FILE, "r")) != NULL)

		{
		  blancvif ();
#ifdef French
		  printf ("\n *** Port LPT busy par le process meteo PID:");
#endif
#ifdef English
		  printf ("\n *** Port LPT busy by process meteo PID:");
#endif
#ifdef Deutsch
		  printf ("\n *** Port LPT busy by process meteo PID:");
#endif

		  catfile (METEO_LOCK_FILE);
		  printf (" ***\n\n");
		  resetcouleur ();
		  exit (1);
		}
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();
	      resetcouleur ();
	      Conf_html ();
	      Index_html ();
	      allsensor_html ();
	      logo_html ();
	      maj_menu ();
	      blancvif ();
	      printf
		("\nDemarrage en cours veuillez patienter...1mn environ...\n");
	      printf ("Starting process Please wait...1mn about...\n");
	      for (i = 0; i < 60; i++)
		{
		  {
		    t = time (NULL);
		    tb = localtime (&t);
		  }
		  if ((tb->tm_sec) == 0)
		    {
		      msg = fopen (MSG_METEO_DATA_FILE, "a+");
		      fprintf (msg, "Demarrage meteo -x le : %s ",
			       ctime (&t));
		      fclose (msg);
		      Boucle_Explo ();
		      exit (1);
		    }
		  sleep (1);
		}
	      printf ("Fin du process !\n");
	      exit (1);
	    }

	  if ((param[1] == 100))	/* Test sur d Exploration capteurs en daemon */
	    {
	      if (!daemon_start (TRUE))
		{
#ifdef French
		  fprintf (stderr,
			   "meteo, Impossible de lancer le daemon!\n");
#endif
#ifdef English
		  fprintf (stderr, "meteo, Impossible to run daemon!\n");
#endif
#ifdef Deustch
		  fprintf (stderr, "meteo, Impossible to run daemon!\n");
#endif

		  return 1;
		}
	      if ((lock = fopen (METEO_LOCK_FILE, "r")) != NULL)
		{
		  blancvif ();
#ifdef French
		  printf ("\n *** Port LPT busy par le process meteo PID:");
#endif
#ifdef English
		  printf ("\n *** Port LPT busy by process meteo PID:");
#endif
#ifdef Deutsch
		  printf ("\n *** Port LPT busy by process meteo PID:");
#endif
		  catfile (METEO_LOCK_FILE);
		  printf (" ***\n\n");
		  resetcouleur ();
		  exit (1);
		}
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();
	      Conf_html ();
	      Index_html ();
	      allsensor_html ();
	      logo_html ();
	      maj_menu ();
	      blancvif ();
	      printf
		("Demarrage en cours veuillez patienter...1mn environ...\n");
	      printf ("Starting process Please wait...1mn about...\n");
	      for (i = 0; i < 60; i++)
		{
		  {
		    t = time (NULL);
		    tb = localtime (&t);
		  }
		  if ((tb->tm_sec) == 0)
		    {
		      msg = fopen (MSG_METEO_DATA_FILE, "a+");
		      fprintf (msg, "Demarrage meteo -d (daemon) le : %s ",
			       ctime (&t));
		      fclose (msg);
		      Boucle_Explo ();
		      exit (1);
		    }
		  sleep (1);
		}
	      printf ("Fin du process !\n");
	      exit (1);
	    }

	  if ((param[1] == 103) || (param[1] == 71))	/* Test sur g  test vers commande systeme */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();
#ifdef French
	      printf ("Generation des graphiques & pages html.\n");
#endif
#ifdef English
	      printf ("Creation of graphics & html pages.\n");
#endif
#ifdef Deutsch
	      printf ("Creation of graphics & html pages.\n");
#endif
	      maj_menu ();
	      Conf_html ();
	      Index_html ();
	      logo_html ();
	      allsensor_html ();
	      maj_html ();
	      meteograph ();
	      Meteohist ();
	      Meteoanhist ();
	      printf ("Fin.End\n");
	      exit (1);
	    }

	  if ((param[1] == 116) || (param[1] == 84))	/* Test sur t  test vers commande systeme */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();
	      printf ("Cmd test.\n");
	      blancvif ();
//            bogomips ();
//            resetcouleur ();
//            allsensor_html();
//	      tambour ();
	      meteograph();
	      resetcouleur ();
	      printf ("End test.\n");
	      exit (1);
	    }

	  if ((param[1] == 118) || (param[1] == 86))	/* Test sur v visu alarmes */
	    {
	      Clr_scr ();
	      Open_Meteo ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      blancvif ();
	      control_Alarm ();
	      resetcouleur ();
	      View_Alarm ();
	      resetcouleur ();
	      exit (1);
	    }

	  if ((param[1] == 108) || (param[1] == 76))	/* Test sur l & L Log ax25 */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();
	      blancvif ();
	      printf ("AX25 connections.\n");
	      resetcouleur ();
	      Visu_logAX25 ();
	      exit (1);
	    }

	  if ((param[1] == 66) || (param[1] == 98))	/* Test sur b B */
	    {
	      Clr_scr ();
	      rouge ();
	      Entete ();
	      resetcouleur ();
	      Open_Meteo ();
	      Aprs ();
/*      printf("Envoi de la Balise APRS.\n\n"); */
	      exit (1);
	    }
	}
    }

  if (strlen (argv[1]) == 3)
    {
      if ((param[1] == 49) && (param[2] == 48))	/* Test sur  10 */
	{
	  Clr_scr ();
	  rouge ();
	  Entete ();
	  resetcouleur ();
	  Open_Meteo ();	/*   recuperartion des donnees depuis le fichier */
	  Print_Compteur ();
	  Print_Detail (tab, 10);	/*   Detail Voie 10 */
	  Print_Date ();
	  exit (1);
	}

      if ((param[1] == 114) && (param[2] == 109))	/* Test sur  rm */
	{
	  Clr_scr ();
	  rouge ();
	  Entete ();
	  resetcouleur ();
	  raz_msg ();
	  Print_Date ();
	  exit (1);
	}

      if ((param[1] == 114) && (param[2] == 108))	/* Test sur  rl */
	{
	  Clr_scr ();
	  rouge ();
	  Entete ();
	  resetcouleur ();
	  RAZ_lock_var ();
	  Print_Date ();
	  exit (1);
	}


      if ((param[1] == 109) && (param[2] == 110))	/* Test sur mn set MaxMin */
	{
	  Clr_scr ();
	  Open_Meteo ();
	  rouge ();
	  Entete ();
	  resetcouleur ();
	  blancvif ();
	  Set_MaxMin ();
	  resetcouleur ();
	  resetcouleur ();
	  exit (1);
	}

    }

  else
    Clr_scr ();
  rouge ();
  Entete ();
  resetcouleur ();
  print_syntax ();
  exit (1);
}

// Fin de programme 
