/*                  HamRadioAX25 F5EXO@@F6KSU.FPDL.FRA.EU                  */
/*                           mail:f5exo@free.fr                            */
/*                     Web:http://f5exo.free.fr/meteo/                     */
/*                            Erick LINE                                   */

/* Pin 11 LPT (busy) utilise en entree pour recevoir sous forme serie      */
/* Pin 2  LPT (D0) utilisee pour generee l'horloge SCLK                    */
/* Pin 3  LPT (D1) utilisee pour generee CS                                */
/* Pin 4  LPT (D2) utilisee pour envoyer les donnees vers le MAX186.       */
/*                                                                         */
/* Pin 15 LPT (/ERROR)     Bit 3   (comptage impulsions) In                */
/* Pin 13 LPT (/SELECT)    Bit 4   (comptage impulsions) In                */
/* Pin 12 LPT (/PAPER OUT) Bit 5   (comptage impulsions) In                */
/*                                                                         */
/* Pin 17 LPT (Select_IN)  Bit 3   (Alarm 2) Out                           */
/* Pin 16 LPT (INIT)       Bit 2   (Alarm 1) Out                           */
/*                                                                         */
/*                   Calcul Valeur analogique                              */
/*           Val analog = (DATA*(Uref/CAN)-Offset)/Unites                  */
/*           Ou DATA    = valeur digitale lue en sortie CAN                */
/*              Uref    = Tension de reference du CAN  4.096               */
/*              CAD     = CAN 12 bits pour MAX186                          */
/*              Offset  = valeur offset du composant capteur               */
/*              Unites  = facteur mutiplicateur du composant capteur       */

/*------------------------------SCANLPT------------------------------------*/
/*
 *                Standalone BogoMips program
 *
 * Based on code Linux kernel code in init/main.c and
 * include/linux/delay.h
 *
 * For more information on interpreting the results, see the BogoMIPS
 * Mini-HOWTO document.
 *
 * version: 1.3 
 *  author: Jeff Tranter (Jeff_Tranter@Mitel.COM)
 *
 */
/* portable version */

static void
delay (int loops)
{
  long i;
  for (i = loops; i >= 0; i--)
    ;
}


int
bogomips (void)
{
  unsigned long loops_per_sec = 1;
  unsigned long ticks;
  float z = 0;

  while ((loops_per_sec <<= 1))
    {
      ticks = clock ();
      delay (loops_per_sec);
      ticks = clock () - ticks;
      if (ticks >= CLOCKS_PER_SEC)
	{
	  loops_per_sec = (loops_per_sec / ticks) * CLOCKS_PER_SEC;
	  z = loops_per_sec / (500000);
	  printf ("Bogomips : %0.3f\n", z);
	  return 1;
	}
    }
  return -1;
}

/* Lecture configuration dans /etc/meteo/meteo.conf */

/*fonction majuscule */
char *
Uppercase (char *x)
{
  char *p = x;
  while (*p)
    {
      if (islower (*p))
	*p = toupper (*p);
      p++;
    }
  return x;
}

/*fonction minuscule */
char *
Lowercase (char *x)
{
  char *p = x;
  while (*p)
    {
      if (isupper (*p))
	*p = tolower (*p);
      p++;
    }
  return x;
}

void
Get_Conf (void)
{
  FILE *msg;
  FILE *fic;
  char buf[1024], *cp, *pt;
  char Version[20] = { };
  int comp, i, p = 0;
  {
    time_t t;
    time (&t);
  }
  msg = fopen (MSG_METEO_DATA_FILE, "a+");
  if ((fic = fopen (CONF_METEO_CONF_FILE, "r")) == NULL)
    {
      fprintf (stderr,
	       "Can't open file %s.Impossible d'ouvrir le fichier %s\n",
	       CONF_METEO_CONF_FILE, CONF_METEO_CONF_FILE);
      fprintf (msg,
	       "%s -->Can't open file %s. Impossible d'ouvrir le fichier %s\n",
	       ctime (&t), CONF_METEO_CONF_FILE, CONF_METEO_CONF_FILE);
      fclose (msg);
      exit (1);
    }
  while (fgets (buf, sizeof (buf), fic))
    {
      if (*buf == '#' || *buf == ' ')
	continue;		/* commentaire ligne vide */
      cp = strchr (buf, '#');
      if (cp)
	*cp = '\0';
      cp = strtok (buf, " \t\n\r");
      if (cp == NULL)
	continue;		/* ligne vide */

      if (strcasecmp (cp, "[Version]") == 0)
	{			/* set Version */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s %s: Version absent,No version\n",
		       METEO_VERSION, CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s %s -->%s: version absent, No version\n",
		       METEO_VERSION, ctime (&t), CONF_METEO_CONF_FILE);

	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (Version, cp, 20);
	  comp = strcmp (Version, METEO_VERSION);
	  if (comp != 0)
	    {
	      fprintf (stderr, "%s %s: Mauvaise Version, Bad Version\n",
		       METEO_VERSION, CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s %s -->%s: Mauvaise Version, Bad Version\n",
		       METEO_VERSION, ctime (&t), CONF_METEO_CONF_FILE);

	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	}

      if (strcasecmp (cp, "[Sysop]") == 0)
	{			/* set SysOp  */
	  cp = strtok (NULL, "\t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr,
		       "%s: Indicatif SysOp absent, No SysOp Callsign\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg,
		       "%s -->%s: Indicatif SysOp absent, No SysOp Callsign\n",
		       ctime (&t), CONF_METEO_CONF_FILE);

	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (Conf.SysOp, cp, 5);
	}

      if (strcasecmp (cp, "[Linux]") == 0)
	{			/* set Linux platform  */
	  cp = strtok (NULL, "\t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr,
		       "%s: Platform Linux absent, No Linux system name\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg,
		       "%s -->%s: Platform Linuxp absent, No Linux system name\n",
		       ctime (&t), CONF_METEO_CONF_FILE);

	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (Conf.LINUX, cp, 64);
	}

      if (strcasecmp (cp, "[Locator]") == 0)
	{			/* set Locator */
	  cp = strtok (NULL, "\t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Locator absent, No Locator\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Locator absent, No Locator\n",
		       ctime (&t), CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (Conf.locator, Uppercase (cp), 6);
	}

      if (strcasecmp (cp, "[Latitude]") == 0)
	{
	  cp = strtok (NULL, "\t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Latitude absente, No Latitude\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Latitude absente, No Latitude\n",
		       ctime (&t), CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (Conf.latitude, cp, 9);
	}

      if (strcasecmp (cp, "[Longitude]") == 0)
	{
	  cp = strtok (NULL, "\t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Longitude absente, No Longitude\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Longitude absente, No Longitude\n",
		       ctime (&t), CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (Conf.longitude, cp, 9);
	}


      if (strcasecmp (cp, "[Qth]") == 0)
	{			/* set Qth */
	  cp = strtok (NULL, "\t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Qth absent, No QTH\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Qth absent, No QTH\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (Conf.qth, cp, 31);
	}

      if (strcasecmp (cp, "[Alt]") == 0)
	{			/* set Altitude */
	  cp = strtok (NULL, "\t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Altitude absente, No Altitude\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Altitude absente, No Altitude\n",
		       ctime (&t), CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  Conf.altitude = atoi (cp);
	}

      if (strcasecmp (cp, "[ax25Call]") == 0)
	{			// set Ax25call for beacon 
	  cp = strtok (NULL, "\t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: ax25Call absent, No ax25Callsign\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: ax25Call absent, No ax25Callsign\n",
		       ctime (&t), CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (Conf.ax25Call, cp, 9);
	}

      if (strcasecmp (cp, "[ConvIdent]") == 0)
	{			// set ConvIdent] for convers 
	  cp = strtok (NULL, "\t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: ConvIdent absent, No ConvIdent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: ConvIdent absent, No ConvIdent\n",
		       ctime (&t), CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (Conf.ConvIdent, cp, 9);
	}

      if (strcasecmp (cp, "[Ax25Convers]") == 0)
	{			// set ConvIdent] for convers 
	  cp = strtok (NULL, "\t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Ax25Convers absent, No Ax25Convers \n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Ax25Convers absent, No Ax25Convers\n",
		       ctime (&t), CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (Conf.Ax25Convers, cp, 15);
	}

      if (strcasecmp (cp, "[HTMLLink]") == 0)
	{			/* set HTML Link */
	  cp = strtok (NULL, "\t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: HTMLLink absent, No HTMLLink\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: HTMLLink absent, No HTMLLink\n",
		       ctime (&t), CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (Conf.HTMLLink, cp, 63);
	}



      if (strcasecmp (cp, "[Partner]") == 0)
	{			/* set Partenaire Link */
	  cp = strtok (NULL, "\t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Partenaire absent, No Partnair\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Patnaire absent, No Partnair\n",
		       ctime (&t), CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (Conf.Partner, cp, 63);
	}






      if (strcasecmp (cp, "[Digi]") == 0)
	{			// set Beacon digipeater 
	  cp = strtok (NULL, "\t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Digi absent, No Digi\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Digi absent, No Digi\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (Conf.Digi[0], cp, 40);
	  for (i = 0; i < (strlen (Conf.Digi[0])); i++)
	    {
	      if (Conf.Digi[0][i] == ';')
		{
		  pt = strchr (Conf.Digi[0], ';');
		  *pt = '\0';
		}
	    }
	  strncpy (Conf.Digi[1], cp, 80);
	  for (i = 0; i < (strlen (Conf.Digi[1])); i++)
	    {
	      if (Conf.Digi[1][i] == ';')
		{
		  p = i + 1;
		}
	    }
	  for (i = p; i < (strlen (Conf.Digi[1])); i++)
	    {
	      Conf.Digi[1][i - p] = Conf.Digi[1][i];
	    }
	  Conf.Digi[1][strlen (Conf.Digi[1]) - p] = ';';
	  pt = strchr (Conf.Digi[1], ';');
	  *pt = '\0';

	}

      if (strcasecmp (cp, "[Port]") == 0)
	{			// set Beacon Port 
	  cp = strtok (NULL, "\t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Port absent\n", CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Port absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (Conf.Port[0], cp, 20);
	  for (i = 0; i < (strlen (Conf.Port[0])); i++)
	    {
	      if (Conf.Port[0][i] == ';')
		{
		  pt = strchr (Conf.Port[0], ';');
		  *pt = '\0';
		}
	    }

	  strncpy (Conf.Port[1], cp, 40);
	  for (i = 0; i < (strlen (Conf.Port[1])); i++)
	    {
	      if (Conf.Port[1][i] == ';')
		{
		  p = i + 1;
		}
	    }
	  for (i = p; i < (strlen (Conf.Port[1])); i++)
	    {
	      Conf.Port[1][i - p] = Conf.Port[1][i];
	    }
	  Conf.Port[1][strlen (Conf.Port[1]) - p] = ';';
	  pt = strchr (Conf.Port[1], ';');
	  *pt = '\0';

	}

      if (strcasecmp (cp, "[Adress]") == 0)
	{			/* set Adresse LPT */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Adresse port LPT absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Adresse port LPT absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      exit (1);
	    }
	  Conf.OUT_PORT = atoi (cp);
	  IN_PORT = Conf.OUT_PORT + 1;
	  IN_PORT_2 = Conf.OUT_PORT + 2;
	  OUT_PORT_2 = Conf.OUT_PORT + 2;
	}

      if (strcasecmp (cp, "[htmldir]") == 0)
	{			/* set html dir */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: html directory absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: html directory absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (Conf.METEO_HTML_DIR, cp, 63);
	}

      if (strcasecmp (cp, "[Number]") == 0)
	{			/* set capteur number  */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Nombre de capteurs absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Nombre de capteurs absent\n",
		       ctime (&t), CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  Conf.C = atoi (cp);
	  if (Conf.C > 11)
	    {
	      Conf.C = 11;
	    }
	  if (Conf.C < 4)
	    {
	      Conf.C = 3;
	    }
	}

      if (strcasecmp (cp, "[Tempo]") == 0)
	{			/* set tempo */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Tempo absent\n", CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Tempo absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  Conf.Sleep = atoi (cp);
	}

/*
      if (strcasecmp (cp, "[Upd]") == 0)
	{			// set Minutes explo 
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Upd minutes html absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Update minutes html absent\n",
		       ctime (&t), CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  Conf.Mn = atoi (cp);
	  if (Conf.Mn < 5 || Conf.Mn > 59)
	    {
	      fprintf (stderr,
		       "%s: Erreur %d Minute non compris entre 5 et 59 ! \n",
		       CONF_METEO_CONF_FILE, Conf.Mn);
	      fprintf (msg,
		       "%s -->%s: Erreur %d Minute non compris entre 5 et 59 ! \n",
		       ctime (&t), CONF_METEO_CONF_FILE, Conf.Mn);
	      fclose (msg);
	      fclose (fic);
	      Conf.Mn = 5;
	      exit (1);
	    }
	}
*/

      Conf.Mn = 1;

      if (strcasecmp (cp, "[Uref]") == 0)
	{			/* set ADC Uv reference */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Uref absent\n", CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Uref absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  Uref = atof (cp);
	}

      if (strcasecmp (cp, "[Ch0]") == 0)
	{			/* set Channel 0 */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Mesure Voie 0 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Mesure Voie 0 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[0].Mesure, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Valeur Voie 0 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Valeur Voie 0 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[0].sensor, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Multipl Voie 0 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Multipl Voie 0 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[0].Unites = atof (cp);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Offset Voie 0 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Offset Voie 0 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[0].Offset = atof (cp);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Unite Voie 0 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Unite Voie 0 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[0].Unite, cp, 13);

	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Comp Voie 0 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Comp Voie 0 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[0].Comp, cp, 1);

	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Alarme Voie 0 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Alarme Voie 0 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[0].Seuil = atof (cp);

	}





      if (strcasecmp (cp, "[Ch1]") == 0)
	{			/* set Channel 1 */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Mesure Voie 1 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Mesure Voie 1 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[1].Mesure, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Valeur Voie 1 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Valeur Lumiere absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[1].sensor, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Multipl Voie 1 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Multipl Voie 1 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[1].Unites = atof (cp);
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Offset Voie 1 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Offset Voie 1  absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[1].Offset = atof (cp);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Unite Voie 1 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Unite Voie 1 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[1].Unite, cp, 13);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Comp Voie 1 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Comp Voie 1 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[1].Comp, cp, 1);

	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Alarme Voie 1 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Alarme Voie 1 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[1].Seuil = atof (cp);


	}

      if (strcasecmp (cp, "[Ch2]") == 0)
	{			/* set Channel 2 */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Mesure Voie 2 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Mesure Voie 2 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[2].Mesure, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Valeur mesure Voie 2 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Valeur mesure Voie 2 absent\n",
		       ctime (&t), CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[2].sensor, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Multiple Voie 2 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Multipl Voie 2 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[2].Unites = atof (cp);
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Offset Voie 2 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Offset Voie 2 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[2].Offset = atof (cp);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Unite Voie 2 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Unite Voie 2 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[2].Unite, cp, 13);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Comp Voie 2 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Comp Voie 2 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[2].Comp, cp, 1);

	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Alarme Voie 2 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Alarme Voie 2 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[2].Seuil = atof (cp);


	}

      if (strcasecmp (cp, "[Ch3]") == 0)
	{			/* set Channel 3 */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Mesure Voie 3 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Mesure Voie 3 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[3].Mesure, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Valeur Voie 3 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Valeur Voie 3 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[3].sensor, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Multipl Voie 3 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Multipl Voie 3 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[3].Unites = atof (cp);
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Offset Voie 3 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Offset Voie 3 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[3].Offset = atof (cp);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Unite Voie 3 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Unite Voie 3 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[3].Unite, cp, 13);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Comp Voie 3 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Comp Voie 3 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[3].Comp, cp, 1);

	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Alarme Voie 3 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Alarme Voie 3 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[3].Seuil = atof (cp);

	}

      if (strcasecmp (cp, "[Ch4]") == 0)
	{			/* set Channel 4 */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Mesure Voie 4 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Mesure Voie 4 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[4].Mesure, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Valeur Voie 4 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Valeur Voie 4 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[4].sensor, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Multipl Voie 4 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Multipl Voie 4 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[4].Unites = atof (cp);
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Offset Voie 4 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Offset Voie 4 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[4].Offset = atof (cp);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Unite Voie 4 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Unite Voie 4 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[4].Unite, cp, 13);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Comp Voie 4 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Comp Voie 4 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[4].Comp, cp, 1);

	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Alarme Voie 4 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Alarme Voie 4 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[4].Seuil = atof (cp);


	}

      if (strcasecmp (cp, "[Ch5]") == 0)
	{			/* set Channel 5 */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Mesure Voie 5 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Mesure Voie 5 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[5].Mesure, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Valeur Voie 5 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Valeur Voie 5 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[5].sensor, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Multipl Voie 5 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Multipl Voie 5 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[5].Unites = atof (cp);
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Offset Voie 5 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Offset Voie 5 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[5].Offset = atof (cp);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Unite Voie 5 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Unite Voie 5 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[5].Unite, cp, 13);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Comp Voie 5 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Comp Voie 5 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[5].Comp, cp, 1);

	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Alarme Voie 5 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Alarme Voie 5 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[5].Seuil = atof (cp);


	}

      if (strcasecmp (cp, "[Ch6]") == 0)
	{			/* set Channel 6 */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Mesure Voie 6 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Mesure Voie 6 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[6].Mesure, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Valeur Voie 6 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Valeur Voie 6 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[6].sensor, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Multipl Voie 6 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Multipl Voie 6 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[6].Unites = atof (cp);
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Offset Voie 6 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Offset Voie 6 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[6].Offset = atof (cp);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Unite Voie 6 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Unite Voie 6 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[6].Unite, cp, 13);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Comp Voie 6 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Comp Voie 6 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[6].Comp, cp, 1);

	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Alarme Voie 6 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Alarme Voie 6 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[6].Seuil = atof (cp);

	}

      if (strcasecmp (cp, "[Ch7]") == 0)
	{			/* set Channel 7 */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Mesure Voie 7 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Mesure Voie 7 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[7].Mesure, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Valeur Voie 7 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Valeur Voie 7 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[7].sensor, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Multipl Voie 7 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Multipl Voie 7 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[7].Unites = atof (cp);
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Offset Voie 7 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Offset Voie 7 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[7].Offset = atoi (cp);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Unite Voie 7 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Unite Voie 7 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[7].Unite, cp, 13);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Comp Voie 7 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Comp Voie 7 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[7].Comp, cp, 1);

	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Alarme Voie 7 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Alarme Voie 7 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[7].Seuil = atof (cp);

	}

      if (strcasecmp (cp, "[Ch8]") == 0)
	{			/* set Channel 8 */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Mesure Voie 8 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Mesure Voie 8 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[8].Mesure, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Valeur Voie 8 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Valeur Voie 8 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[8].sensor, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Multipl Voie 8 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Multipl Voie 8 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[8].Unites = atof (cp);
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Offset Voie 8 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Offset Voie 8 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[8].Offset = atoi (cp);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Unite Voie 8 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Unite Voie 8 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[8].Unite, cp, 13);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Comp Voie 8 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Comp Voie 8 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[8].Comp, cp, 1);

	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Alarme Voie 8 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Alarme Voie 8 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[8].Seuil = atof (cp);

	}

      if (strcasecmp (cp, "[Ch9]") == 0)
	{			/* set Channel 9 */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Mesure Voie 9 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Mesure Voie 9 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[9].Mesure, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Valeur Voie 9 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Valeur Voie 9 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[9].sensor, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Multipl Voie 9 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Multipl Voie 9 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[9].Unites = atof (cp);
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Offset Voie 9 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Offset Voie 9 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[9].Offset = atoi (cp);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Unite Voie 9 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Unite Voie 9 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[9].Unite, cp, 13);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Comp Voie 9 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Comp Voie 9 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[9].Comp, cp, 1);

	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Alarme Voie 9 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Alarme Voie 9 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[9].Seuil = atof (cp);

	}

      if (strcasecmp (cp, "[Ch10]") == 0)
	{			/* set Channel 10 */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Mesure Voie 10 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Mesure Voie 10 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[10].Mesure, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Valeur Voie 10 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Valeur Voie 10 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[10].sensor, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Multipl Voie 10 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Multipl Voie 10 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[10].Unites = atof (cp);
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Offset Voie 10 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Offset Voie 10 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[10].Offset = atoi (cp);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Unite Voie 10 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Unite Voie 10 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[10].Unite, cp, 13);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Comp Voie 10 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Comp Voie 10 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[10].Comp, cp, 1);

	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Alarme Voie 10 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Alarme Voie 10 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[10].Seuil = atof (cp);

	}

      if (strcasecmp (cp, "[Ch11]") == 0)
	{			/* set Channel 11 */
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Mesure Voie 11 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Mesure Voie 11 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[11].Mesure, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Valeur Voie 11 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Valeur Voie 11 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[11].sensor, cp, 13);

	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Multipl Voie 11 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Multipl Voie 11 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[11].Unites = atof (cp);
	  cp = strtok (NULL, " \t\n\r");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Offset Voie 11 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Offset Voie 11 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[11].Offset = atoi (cp);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Unite Voie 11 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Unite Voie 11 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  strncpy (capteurs[11].Unite, cp, 13);
	  cp = strtok (NULL, " \n\r\t");
	  if (cp == NULL)
	    {
	      fprintf (stderr, "%s: Alarme Voie 11 absent\n",
		       CONF_METEO_CONF_FILE);
	      fprintf (msg, "%s -->%s: Alarme Voie 11 absent\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      exit (1);
	    }
	  capteurs[11].Seuil = atof (cp);
	}
    }

  i = 0;
  for (p = 0; p < Conf.C; p++)
    {
      if (strcasecmp (capteurs[p].Comp, "!") != 0)
	{
	  Alarms[i].Channel = p;
	  strcpy (Alarms[i].Comp, capteurs[p].Comp);
	  Alarms[i].Seuil = capteurs[p].Seuil;
	  i = i + 1;
	  if (i > 2)
	    {
	      fprintf (msg, "%s -->%s: Seuil Alarm > 2\n", ctime (&t),
		       CONF_METEO_CONF_FILE);
	      fclose (fic);
	      fclose (msg);
	      fprintf
		(stderr,
		 "\n*** Attention il y a plus de 2 seuils d'alarmes selectionnes.\n Voir \"Comp\" dans le fichier %s\n\n",
		 CONF_METEO_CONF_FILE);
	      fprintf (stderr,
		       "*** Warning there are more 2 Alarms level.\n See \"Comp\" in file %s\n\n",
		       CONF_METEO_CONF_FILE);
	      exit (1);
	    }

	}
    }
  fclose (fic);
  fclose (msg);

  {
    t = time (NULL);
    tb = localtime (&t);
  }
//  sprintf (RRD_FILE, "%d.rrd", tb->tm_year + 1900);
//  strcat (RRD_METEO_DATA_BASE, RRD_METEO_DATA_DIR);
//  strcat (RRD_METEO_DATA_BASE, RRD_FILE);
  get_month ();

}
