/*                           mail:f5exo@free.fr                            */
/*                     Web:http://f5exo.free.fr/meteo/                     */
/*                            Erick LINE                                   */

/* Pin 11 LPT (busy) utilise en entree pour recevoir sous forme serie      */
/* Pin 2  LPT (D0) utilisee pour generee l'horloge SCLK                    */
/* Pin 3  LPT (D1) utilisee pour generee CS                                */
/* Pin 4  LPT (D2) utilisee pour envoyer les donnees vers le MAX186.       */
/*                                                                         */
/* Pin 15 LPT (/ERROR)     Bit 3   (comptage impulsions) In                */
/* Pin 13 LPT (/SELECT)    Bit 4   (comptage impulsions) In                */
/* Pin 12 LPT (/PAPER OUT) Bit 5   (comptage impulsions) In                */
/*                                                                         */
/* Pin 17 LPT (Select_IN)  Bit 3   (Alarm 2) Out                           */
/* Pin 16 LPT (INIT)       Bit 2   (Alarm 1) Out                           */
/*                                                                         */
/*                   Calcul Valeur analogique                              */
/*           Val analog = (DATA*(Uref/CAN)-Offset)/Unites                  */
/*           Ou DATA    = valeur digitale lue en sortie CAN                */
/*              Uref    = Tension de reference du CAN  4.096               */
/*              CAD     = CAN 12 bits pour MAX186                          */
/*              Offset  = valeur offset du composant capteur               */
/*              Unites  = facteur mutiplicateur du composant capteur       */

/*------------------------------SCANLPT------------------------------------*/

void
meteograph (void)
{
  int c;
#ifdef RRDTOOL
  int len;
#endif
  char htmlfic[80]  = {""};
  char *rrd_cmd;
//  char rrd_cmd[400	] = {""};
  rrd_cmd = (char *)malloc(1 * sizeof (chaine));
  strcpy (htmlfic, Conf.METEO_HTML_DIR);
  /* Confection des graph pour chaque capteurs */
  for (c = 0; c < (Conf.C - 3); c++)
    {
      strcpy (rrd_cmd, " ");
      strcat (rrd_cmd, htmlfic);
      strcat (rrd_cmd, capteurs[c].Mesure);
      /* Courbes avec des couleurs ou epaisseurs differentes */

      /* temperature */
      if (strcasecmp (capteurs[c].Unite, "Celsius") == 0)
	{
	  strcat (rrd_cmd,
//		  ".png --color BACK#CCCFFF --alt-y-grid --alt-autoscale-max --units-exponent 0 --title=\"");
		  ".png --color BACK#990909 --color CANVAS#EAE2D6 --color SHADEA#990909 --color SHADEB#990909  --color FONT#EAE2D6 --alt-y-grid --alt-autoscale-max --units-exponent 0 --title=\"");
	  strcat (rrd_cmd, capteurs[c].Mesure);
#ifdef French
	  strcat (rrd_cmd, " dernieres 24H a ");
#endif
#ifdef English
	  strcat (rrd_cmd, " last 24H in ");
#endif
#ifdef Deutsch
	  strcat (rrd_cmd, " last 24H in ");
#endif
	  strcat (rrd_cmd, Conf.qth);
	  strcat (rrd_cmd, "\" --vertical-label ");
	  strcat (rrd_cmd, capteurs[c].Unite);
	  strcat (rrd_cmd," --width 460 --height 115");
	  strcat (rrd_cmd, " DEF:");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE");
	  strcat (rrd_cmd, " LINE1:");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#0000FF:");
	  strcat (rrd_cmd, capteurs[c].sensor);
/*
	  strcat (rrd_cmd, " DEF:Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE");
	  strcat (rrd_cmd, " LINE1:Peak_");
//	  strcat (rrd_cmd, " STACK:Peak_");
//	  strcat (rrd_cmd, " AREA:Peak_");	  
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#FF0000:");
	  strcat (rrd_cmd, "peak");


	  strcat (rrd_cmd, " DEF:Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE");
	  strcat (rrd_cmd, " LINE1:Min_");
//	  strcat (rrd_cmd, " STACK:Peak_");
//	  strcat (rrd_cmd, " AREA:Peak_");	  
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#555555:");
	  strcat (rrd_cmd, "min");

*/



	  strcat (rrd_cmd, " HRULE:0#FF0000:0o");
	  strcat (rrd_cmd, capteurs[c].Unite);
	  strcat (rrd_cmd, ":");
	}
      /* Luminosite */
      else if ((strcasecmp (capteurs[c].Unite, "Lux") == 0) ||
              (strcasecmp (capteurs[c].Mesure, "Solar") == 0))
	{
	  strcat (rrd_cmd,
//		  ".png --color BACK#CCCFFF --color CANVAS#000000 --alt-autoscale-max --units-exponent 0 --title=\"");
		  ".png --color BACK#990909 --color CANVAS#EAE2D6 --color SHADEA#990909 --color SHADEB#990909  --color FONT#EAE2D6 --alt-y-grid --alt-autoscale-max --units-exponent 0 --title=\"");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, " ");
#ifdef French
	  strcat (rrd_cmd, " dernieres 24H a ");
#endif
#ifdef English
	  strcat (rrd_cmd, " last 24H in ");
#endif
#ifdef Deutsch
	  strcat (rrd_cmd, " last 24H in ");
#endif
	  strcat (rrd_cmd, Conf.qth);
	  strcat (rrd_cmd, "\" --vertical-label ");	  
	  strcat (rrd_cmd, capteurs[c].Unite);
	  strcat (rrd_cmd," --width 460 --height 115");
	  strcat (rrd_cmd, " DEF:");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE LINE3:");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#0000FF:");
	  strcat (rrd_cmd, capteurs[c].sensor);
	  strcat (rrd_cmd, " AREA:");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#FFF000:Light");
/*
          strcat (rrd_cmd, " DEF:Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE");
	  strcat (rrd_cmd, " LINE1:Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#FF0000:");
	  strcat (rrd_cmd, "peak");

          strcat (rrd_cmd, " DEF:Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE");
	  strcat (rrd_cmd, " LINE1:Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#555555:");
	  strcat (rrd_cmd, "min");
*/

	}
      /* Flux Solaire */
      else if (strcasecmp (capteurs[c].Mesure, "Flux_solaire") == 0)
	{
	  strcat (rrd_cmd,
//		  ".png --color BACK#CCCFFF --alt-y-grid --alt-autoscale-max --units-exponent 0 --title=\"");
		  ".png --color BACK#990909 --color CANVAS#EAE2D6 --color SHADEA#990909 --color SHADEB#990909  --color FONT#EAE2D6 --alt-y-grid --alt-autoscale-max --units-exponent 0 --title=\"");
	  strcat (rrd_cmd, capteurs[c].Mesure);
#ifdef French
	  strcat (rrd_cmd, " dernieres 24H a ");
#endif
#ifdef English
	  strcat (rrd_cmd, " last 24H in ");
#endif
#ifdef Deutsch
	  strcat (rrd_cmd, " last 24H in ");
#endif

	  strcat (rrd_cmd, Conf.qth);
	  strcat (rrd_cmd, "\" --vertical-label ");
	  strcat (rrd_cmd, capteurs[c].Unite);
	  strcat (rrd_cmd," --width 460 --height 115");
	  strcat (rrd_cmd, " DEF:");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE LINE3:");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#FFF000:");
	  strcat (rrd_cmd, capteurs[c].sensor);
	  strcat (rrd_cmd, " AREA:");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#CC33CC:Flux");  
/*
	  strcat (rrd_cmd, " DEF:Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE");
	  strcat (rrd_cmd, " LINE1:Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#FF0000:");
	  strcat (rrd_cmd, "peak");


	  strcat (rrd_cmd, " DEF:Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE");
	  strcat (rrd_cmd, " LINE1:Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#555555:");
	  strcat (rrd_cmd, "min");
*/

	  
	}
      /* Girouette */
      else if (strcasecmp (capteurs[c].Unite, "Degres") == 0)
	{
	  strcat (rrd_cmd,
//		  ".png --color BACK#CCCFFF --alt-y-grid --title=\"");
		  ".png --color BACK#990909 --color CANVAS#EAE2D6 --color SHADEA#990909 --color SHADEB#990909  --color FONT#EAE2D6 --alt-y-grid --alt-autoscale-max --units-exponent 0 --title=\"");
	  strcat (rrd_cmd, capteurs[c].Mesure);
#ifdef French
	  strcat (rrd_cmd, " dernieres 24H a ");
#endif
#ifdef English
	  strcat (rrd_cmd, " last 24H in ");
#endif
#ifdef Deutsch
	  strcat (rrd_cmd, " last 24H in ");
#endif

	  strcat (rrd_cmd, Conf.qth);
	  strcat (rrd_cmd, "\" --vertical-label ");
	  strcat (rrd_cmd, capteurs[c].Unite);
	  strcat (rrd_cmd," --width 460 --height 115");
	  strcat (rrd_cmd, " DEF:");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE LINE1:");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#0000FF:");
	  strcat (rrd_cmd, capteurs[c].sensor);
/*	  
	  strcat (rrd_cmd, " DEF:Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE");
	  strcat (rrd_cmd, " LINE1:Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#FF0000:");
	  strcat (rrd_cmd, "peak");


	  strcat (rrd_cmd, " DEF:Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE");
	  strcat (rrd_cmd, " LINE1:Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#555555:");
	  strcat (rrd_cmd, "min");
*/

	  strcat (rrd_cmd, " HRULE:0#CC33CC:Nord:");
	  strcat (rrd_cmd, " HRULE:90#993300:Est:");
	  strcat (rrd_cmd, " HRULE:180#FF0000:Sud:");
	  strcat (rrd_cmd, " HRULE:270#FF9900:Ouest:");
	  strcat (rrd_cmd, " HRULE:359#CC33CC:Nord:");
	}

      /* Orage */
      else if (strcasecmp (capteurs[c].Mesure, "Orage") == 0)
	{
	  strcat (rrd_cmd,
//		  ".png --color BACK#CCCFFF --alt-y-grid  --title=\"");
		  ".png --color BACK#990909 --color CANVAS#EAE2D6 --color SHADEA#990909 --color SHADEB#990909  --color FONT#EAE2D6 --alt-y-grid --alt-autoscale-max --units-exponent 0 --title=\"");
	  strcat (rrd_cmd, capteurs[c].Mesure);
#ifdef French
	  strcat (rrd_cmd, " dernieres 24H a ");
#endif
#ifdef English
	  strcat (rrd_cmd, " last 24H in ");
#endif
#ifdef Deutsch
	  strcat (rrd_cmd, " last 24H in ");
#endif

	  strcat (rrd_cmd, Conf.qth);
	  strcat (rrd_cmd, "\" --vertical-label ");
	  strcat (rrd_cmd, capteurs[c].Unite);
          strcat (rrd_cmd," --width 460 --height 115");
	  strcat (rrd_cmd, " DEF:");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":");
	  strcat (rrd_cmd, capteurs[c].Mesure);
//	  strcat (rrd_cmd, ":AVERAGE LINE1:");
	  strcat (rrd_cmd, ":AVERAGE AREA:");	  
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#0000FF:");
	  strcat (rrd_cmd, capteurs[c].sensor);
/*
	  strcat (rrd_cmd, " DEF:Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE");
          strcat (rrd_cmd, " LINE1:Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#FF0000:");
	  strcat (rrd_cmd, "peak");


	  strcat (rrd_cmd, " DEF:Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE");
          strcat (rrd_cmd, " LINE1:Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#555555:");
	  strcat (rrd_cmd, "min");
*/



	}

      /* Pression */
      else if (strcasecmp (capteurs[c].Unite, "hPa") == 0)
	{
	  strcat (rrd_cmd,
//		  ".png --color BACK#CCCFFF --alt-y-grid --alt-autoscale-max --units-exponent 0 --title=\"");
		  ".png --color BACK#990909 --color CANVAS#EAE2D6 --color SHADEA#990909 --color SHADEB#990909  --color FONT#EAE2D6 --alt-y-grid --alt-autoscale-max --units-exponent 0 --title=\"");
	  strcat (rrd_cmd, capteurs[c].Mesure);
#ifdef French
	  strcat (rrd_cmd, " dernieres 24H a ");
#endif
#ifdef English
	  strcat (rrd_cmd, " last 24H in ");
#endif
#ifdef Deutsch
	  strcat (rrd_cmd, " last 24H in ");
#endif

	  strcat (rrd_cmd, Conf.qth);
	  strcat (rrd_cmd, "\" --vertical-label ");
	  strcat (rrd_cmd, capteurs[c].Unite);
	  strcat (rrd_cmd," --width 460 --height 115");
	  strcat (rrd_cmd, " DEF:");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE LINE1:");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#0000FF:");
	  strcat (rrd_cmd, capteurs[c].sensor);
/*
	  strcat (rrd_cmd, " DEF:Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE");
	  strcat (rrd_cmd, " LINE1:Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#FF0000:");
	  strcat (rrd_cmd, "peak");


	  strcat (rrd_cmd, " DEF:Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE");
	  strcat (rrd_cmd, " LINE1:Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#555555:");
	  strcat (rrd_cmd, "min");

*/



	  strcat (rrd_cmd, " HRULE:1013#FF0000:1013hPa");
/*	  
	  strcat (rrd_cmd, " GPRINT:");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":LAST:");
	  strcat (rrd_cmd, "Actuel\: ");
	  strcat (rrd_cmd, actuel);
*/
	  
	}
      else
	{
	  strcat (rrd_cmd,
//		  ".png --color BACK#CCCFFF --alt-y-grid --alt-autoscale-max --units-exponent 0 --title=\"");
		  ".png --color BACK#990909 --color CANVAS#EAE2D6 --color SHADEA#990909 --color SHADEB#990909  --color FONT#EAE2D6 --alt-y-grid --alt-autoscale-max --units-exponent 0 --title=\"");
	  strcat (rrd_cmd, capteurs[c].Mesure);
#ifdef French
	  strcat (rrd_cmd, " dernieres 24H a ");
#endif
#ifdef English
	  strcat (rrd_cmd, " last 24H in ");
#endif
#ifdef Deutsch
	  strcat (rrd_cmd, " last 24H in ");
#endif

	  strcat (rrd_cmd, Conf.qth);
	  strcat (rrd_cmd, "\" --vertical-label ");
	  strcat (rrd_cmd, capteurs[c].Unite);
	  strcat (rrd_cmd," --width 460 --height 115");
	  strcat (rrd_cmd, " DEF:");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE LINE1:");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#0000FF:");
	  strcat (rrd_cmd, capteurs[c].sensor);
/*
	  strcat (rrd_cmd, " DEF:Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE");
	  strcat (rrd_cmd, " LINE1:Peak_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#FF0000:");
	  strcat (rrd_cmd, "peak");


	  strcat (rrd_cmd, " DEF:Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "=");
	  strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	  strcat (rrd_cmd, ":Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, ":AVERAGE");
	  strcat (rrd_cmd, " LINE1:Min_");
	  strcat (rrd_cmd, capteurs[c].Mesure);
	  strcat (rrd_cmd, "#555555:");
	  strcat (rrd_cmd, "min");
*/




	}
      strcat (rrd_cmd, " COMMENT:METEO_Linux_Version");
      strcat (rrd_cmd, METEO_VERSION);
#ifdef RRDTOOL
      len = strlen (rrd_cmd);
      printf ("Longuer de rrd_cmd %d: %d\n", c, len);
      printf (rrd_cmd);
      printf ("\n");
#endif
      wrap_rrd_graph (rrd_cmd);
      strcpy (rrd_cmd, "");
    }

  for (c = (Conf.C - 3); c < Conf.C; c++)
    {
      if (capteurs[c].Unites != 0)
	{
	  strcat (rrd_cmd, " ");
	  strcat (rrd_cmd, htmlfic);
	  strcat (rrd_cmd, capteurs[c].Mesure);

	  if ((strcasecmp (capteurs[c].Mesure, "Rain") == 0)
	      || (strcasecmp (capteurs[c].Mesure, "Regen") == 0)
	      || (strcasecmp (capteurs[c].Mesure, "Pluie") == 0))
	    {
	      strcat (rrd_cmd,
//		      ".png --color BACK#CCCFFF --color CANVAS#FFFFFF --alt-autoscale-max --units-exponent 0 --title=\"");
		  ".png --color BACK#990909 --color CANVAS#EAE2D6 --color SHADEA#990909 --color SHADEB#990909  --color FONT#EAE2D6 --alt-y-grid --alt-autoscale-max --units-exponent 0 --title=\"");
	      strcat (rrd_cmd, capteurs[c].Mesure);
	      strcat (rrd_cmd, " ");
#ifdef French
	      strcat (rrd_cmd, " dernieres 24H a ");
#endif
#ifdef English
	      strcat (rrd_cmd, " last 24H in ");
#endif
#ifdef Deutsch
	      strcat (rrd_cmd, " last 24H in ");
#endif
	      strcat (rrd_cmd, Conf.qth);
	      strcat (rrd_cmd, "\" --vertical-label ");
	      strcat (rrd_cmd, capteurs[c].Unite);
	      strcat (rrd_cmd," --width 460 --height 115");
	      strcat (rrd_cmd, " DEF:");
	      strcat (rrd_cmd, capteurs[c].Mesure);
	      strcat (rrd_cmd, "=");
	      strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	      strcat (rrd_cmd, ":");
	      strcat (rrd_cmd, capteurs[c].Mesure);
	      strcat (rrd_cmd, ":AVERAGE LINE1:");
	      strcat (rrd_cmd, capteurs[c].Mesure);
	      strcat (rrd_cmd, "#0000FF:");
	      strcat (rrd_cmd, capteurs[c].sensor);
	      strcat (rrd_cmd, " AREA:");
	      strcat (rrd_cmd, capteurs[c].Mesure);
	      strcat (rrd_cmd, "#0000FF:");
	      strcat (rrd_cmd, capteurs[c].Unite);
	    }
	  else
	    {
	      strcat (rrd_cmd,
//		      ".png --color BACK#CCCFFF --alt-y-grid --alt-autoscale-max --units-exponent 0 --title=\"");
		  ".png --color BACK#990909 --color CANVAS#EAE2D6 --color SHADEA#990909 --color SHADEB#990909  --color FONT#EAE2D6 --alt-y-grid --alt-autoscale-max --units-exponent 0 --title=\"");
	      strcat (rrd_cmd, capteurs[c].Mesure);
	      strcat (rrd_cmd, " ");
#ifdef French
	      strcat (rrd_cmd, " dernieres 24H a ");
#endif
#ifdef English
	      strcat (rrd_cmd, " last 24H in ");
#endif
#ifdef Deutsch
	      strcat (rrd_cmd, " last 24H in ");
#endif
	      strcat (rrd_cmd, Conf.qth);
	      strcat (rrd_cmd, "\" --vertical-label ");
	      strcat (rrd_cmd, capteurs[c].Unite);
              strcat (rrd_cmd," --width 460 --height 115");
	      strcat (rrd_cmd, " DEF:");
	      strcat (rrd_cmd, capteurs[c].Mesure);
	      strcat (rrd_cmd, "=");
	      strcat (rrd_cmd, RRD_METEO_DATA_BASE);
	      strcat (rrd_cmd, ":");
	      strcat (rrd_cmd, capteurs[c].Mesure);
	      strcat (rrd_cmd, ":AVERAGE LINE1:");
	      strcat (rrd_cmd, capteurs[c].Mesure);
	      strcat (rrd_cmd, "#0000FF:");
	      strcat (rrd_cmd, capteurs[c].sensor);
	      
	    }
	  strcat (rrd_cmd, " COMMENT:METEO_Linux_Version");
	  strcat (rrd_cmd, METEO_VERSION);
#ifdef RRDTOOL
	  len = strlen (rrd_cmd);
	  printf (" Direct LPT Longueur de rrd_cmd %d: %d\n", c, len);
	  printf (rrd_cmd);
	  printf ("\n");
#endif
	  wrap_rrd_graph (rrd_cmd);
	  strcpy (rrd_cmd, "");
	}
    }

#ifdef RRDTOOL
#ifdef French
  printf ("[Graphique journalier a jour]\n");
#endif
#ifdef English
  printf ("[Daily Graphic update]\n");
#endif
#ifdef Deutsch
  printf ("[Daily Graphiken erzeugen]\n");
#endif
#endif
  free(rrd_cmd);
  return;
}
