/*                  HamRadioAX25 F5EXO@@F6KSU.FPDL.FRA.EU                  */
/*                           mail:f5exo@free.fr                            */
/*                     Web:http://f5exo.free.fr/meteo/                     */
/*                            Erick LINE                                   */

/* Pin 11 LPT (busy) utilise en entree pour recevoir sous forme serie      */
/* Pin 2  LPT (D0) utilisee pour generee l'horloge SCLK                    */
/* Pin 3  LPT (D1) utilisee pour generee CS                                */
/* Pin 4  LPT (D2) utilisee pour envoyer les donnees vers le MAX186.       */
/*                                                                         */
/* Pin 15 LPT (/ERROR)     Bit 3   (comptage impulsions) In                */
/* Pin 13 LPT (/SELECT)    Bit 4   (comptage impulsions) In                */
/* Pin 12 LPT (/PAPER OUT) Bit 5   (comptage impulsions) In                */
/*                                                                         */
/* Pin 17 LPT (Select_IN)  Bit 3   (Alarm 2) Out                           */
/* Pin 16 LPT (INIT)       Bit 2   (Alarm 1) Out                           */
/*                                                                         */
/*                   Calcul Valeur analogique                              */
/*           Val analog = (DATA*(Uref/CAN)-Offset)/Unites                  */
/*           Ou DATA    = valeur digitale lue en sortie CAN                */
/*              Uref    = Tension de reference du CAN  4.096               */
/*              CAD     = CAN 12 bits pour MAX186                          */
/*              Offset  = valeur offset du composant capteur               */
/*              Unites  = facteur mutiplicateur du composant capteur       */

/*------------------------------SCANLPT------------------------------------*/

/* Init fichier meteo.rrd */
void
rrd_ini (void)
{
  FILE *msg;
  int i;
  char rrdcreate[990] = { " " };
  msg = fopen (MSG_METEO_DATA_FILE, "a");
  
  {

    time_t t;
    t = time (NULL);
    tb = localtime (&t);
    fprintf (msg, "%s %d %s %d %2.2d:%2.2d-->Fichier %s initialise.\n",
	     Jours[tb->tm_wday], tb->tm_mday, Mois[tb->tm_mon],
	     tb->tm_year + 1900, tb->tm_hour, tb->tm_min,
	     RRD_METEO_DATA_BASE);
  }
  fclose (msg);
  
  strcat (rrdcreate, RRD_METEO_DATA_BASE);
  strcat (rrdcreate, " --step ");
  strcat (rrdcreate, "60");
  for (i = 0; i < Conf.C; i++)
    {
      strcat (rrdcreate, " DS:");
      strcat (rrdcreate, capteurs[i].Mesure);
      strcat (rrdcreate, ":GAUGE:");
      strcat (rrdcreate, "180");
      strcat (rrdcreate, ":U:U");
    }
/*
// Base pour les cretes (vent entre autre)  
  for (i = 0; i < Conf.C-3; i++)
    {
      strcat (rrdcreate, " DS:Peak_");
      strcat (rrdcreate, capteurs[i].Mesure);
//      strcat (rrdcreate, ":GAUGE:");
      strcat (rrdcreate, ":GAUGE:");      
  
      strcat (rrdcreate, "180");
      strcat (rrdcreate, ":U:U");
    }

// Base pour les min (vent entre autre)  
  for (i = 0; i < Conf.C-3; i++)
    {
      strcat (rrdcreate, " DS:Min_");
      strcat (rrdcreate, capteurs[i].Mesure);
//      strcat (rrdcreate, ":GAUGE:");
      strcat (rrdcreate, ":GAUGE:");      
      strcat (rrdcreate, "180");
      strcat (rrdcreate, ":U:U");
    }
*/
  strcat (rrdcreate, " RRA:MAX:0.5:1:60");           // 24h 2400
  strcat (rrdcreate, " RRA:AVERAGE:0.5:24:480");       // 1 semaine 7j
  strcat (rrdcreate, " RRA:AVERAGE:0.5:365:8760");     // 24h x 365j 8760

  wrap_rrd_create (rrdcreate);
  printf ("[%s cree ]\n\n", RRD_METEO_DATA_BASE);

#ifdef RRDTOOL
 printf(rrdcreate);
 printf ("\n\n");
#endif
  strcpy (rrdcreate, "");
  return;
}

/* Mise a jour du fichier meteo.rrd */
void
rrd_upd (void)
{
  FILE *rrd;
  char buf[16] = {""};
  char rrdupd[240]= {""};
  int c;
  float z;
  // test presence du fichier rrd
  if ((rrd = fopen (RRD_METEO_DATA_BASE, "r")) == NULL)
  {
  rrd_ini();
  }
  fclose(rrd);
  strcat (rrdupd, RRD_METEO_DATA_BASE);
  strcat (rrdupd, " N");
  if (Conf.C > 3)
    {
      for (c = 0; c < Conf.C - 3; c++)
	{
	  z =
	    ((tab[c][0][1][0] * CAD) -
	     capteurs[c].Offset) / capteurs[c].Unites;
	  sprintf (buf, ":%.1f", z);
	  strcat (rrdupd, buf);
	}
    }
  for (c = Conf.C - 3; c < Conf.C; c++)
    {
      z = (tab[c][0][1][0] * capteurs[c].Unites);
      sprintf (buf, ":%.0f", z);
      strcat (rrdupd, buf);
    }    

/*    
// Valeurs crete
  if (Conf.C > 3)
    {
      for (c = 0; c < Conf.C - 3; c++)
	{
	  z =
	    ((tab[c][0][0][1] * CAD) -
	     capteurs[c].Offset) / capteurs[c].Unites;
	  sprintf (buf, ":%.1f", z);
	  strcat (rrdupd, buf);
	}
    }

// Valeurs crete min
  if (Conf.C > 3)
    {
      for (c = 0; c < Conf.C - 3; c++)
	{
	  z =
	    ((tab[c][0][0][2] * CAD) -
	     capteurs[c].Offset) / capteurs[c].Unites;
	  sprintf (buf, ":%.1f", z);
	  strcat (rrdupd, buf);
	}
    }

*/    
#ifdef RRDTOOL
  printf(rrdupd);    
  printf("\n");
#endif
  wrap_rrd_update (rrdupd);
  strcpy (rrdupd, "");
return;
}
