/*                  HamRadioAX25 F5EXO@@F6KSU.FPDL.FRA.EU                  */
/*                           mail:f5exo@free.fr                            */
/*                     Web:http://f5exo.free.fr/meteo/                     */
/*                            Erick LINE                                   */

/* Pin 11 LPT (busy) utilise en entree pour recevoir sous forme serie      */
/* Pin 2  LPT (D0) utilisee pour generee l'horloge SCLK                    */
/* Pin 3  LPT (D1) utilisee pour generee CS                                */
/* Pin 4  LPT (D2) utilisee pour envoyer les donnees vers le MAX186.       */
/*                                                                         */
/* Pin 15 LPT (/ERROR)     Bit 3   (comptage impulsions) In                */
/* Pin 13 LPT (/SELECT)    Bit 4   (comptage impulsions) In                */
/* Pin 12 LPT (/PAPER OUT) Bit 5   (comptage impulsions) In                */
/*                                                                         */
/* Pin 17 LPT (Select_IN)  Bit 3   (Alarm 2) Out                           */
/* Pin 16 LPT (INIT)       Bit 2   (Alarm 1) Out                           */
/*                                                                         */
/*                   Calcul Valeur analogique                              */
/*           Val analog = (DATA*(Uref/CAN)-Offset)/Unites                  */
/*           Ou DATA    = valeur digitale lue en sortie CAN                */
/*              Uref    = Tension de reference du CAN  4.096               */
/*              CAD     = CAN 12 bits pour MAX186                          */
/*              Offset  = valeur offset du composant capteur               */
/*              Unites  = facteur mutiplicateur du composant capteur       */

/*------------------------------SCANLPT------------------------------------*/


/* Test IO */
void
Test_IO (void)
{
  if (ioperm (Conf.OUT_PORT, 3, 1))
    {
      perror ("Error ioperm: Pas d'acces au port.");
      printf ("\n\r");
      exit (1);
    }
}

/* maj fichier data */
void
maj_file (void)
{
  FILE *fic;
  fic = fopen (METEO_DATA_FILE, "w");
  fwrite (&tab, 4, (Conf.C * 3 * 3 * M), fic);
  fclose (fic);
}

void
init (void)
{
  out = INIT;
  outb (out, Conf.OUT_PORT);	/* demarrage avec CS a 1  */
}

void
Alarm1_up (void)
{
  outb (8 ^ 11, IN_PORT_2);
  tab[0][2][0][8] = 1;
  tab[0][2][0][9] = 0;
#ifdef DEBUG
  usleep (Conf.Sleep);
#endif
}

void
Alarm2_up (void)
{
  outb (4 ^ 11, IN_PORT_2);
  tab[0][2][0][8] = 0;
  tab[0][2][0][9] = 1;
#ifdef DEBUG
  usleep (Conf.Sleep);
#endif
}

void
Alarms_up (void)
{
  outb (12 ^ 11, IN_PORT_2);
  tab[0][2][0][8] = 1;
  tab[0][2][0][9] = 1;
#ifdef DEBUG
  usleep (Conf.Sleep);
#endif
}


void
init_out2 (void)
{
  outb (16 ^ 11, OUT_PORT_2);
  tab[0][2][0][8] = 0;
  tab[0][2][0][9] = 0;
}

void
View_Alarm (void)
{
  int r = 8;
  unsigned bit;
  violet ();
  printf ("*** View ALARMS from port: %#x ***\n", IN_PORT_2);
  resetcouleur ();
  rouge ();
  printf ("Alarm 1");
  resetcouleur ();
  cyan ();
  printf (" Bit 3->");
  resetcouleur ();
  blancvif ();
  bit = !(inb (IN_PORT_2) / r & (0x01));
  printf ("[%d]", bit);
  cyan ();
  printf ("<-/SELECT_IN Pin 17 LPT");
  resetcouleur ();
  jaune ();
  if (bit == 0)
    {
      printf ("  [Low]");
      resetcouleur ();
    }
  else
    {
      rouge ();
      printf ("  [Hight]");
      resetcouleur ();
    }
  printf ("\n");

  r = r / 2;
  rouge ();
  printf ("Alarm 2");
  resetcouleur ();
  cyan ();
  printf (" Bit 2->");
  resetcouleur ();
  blancvif ();
  bit = (inb (IN_PORT_2) / r & (0x01));
  printf ("[%d]", bit);
  cyan ();
  printf ("<-/INIT      Pin 16 LPT");
  resetcouleur ();
  jaune ();
  if (bit == 0)
    {
      printf ("  [Low]");
      resetcouleur ();
    }
  else
    {
      rouge ();
      printf ("  [Hight]");
      resetcouleur ();
    }
  printf ("\n\n");
}



void
Sclk (void)			/* ensemble clock up/down */
{
  out |= SCLK;
  outb (out, Conf.OUT_PORT);
#ifdef DEBUG
  usleep (Conf.Sleep);
#endif
  out &= ~SCLK;
  outb (out, Conf.OUT_PORT);
#ifdef DEBUG
  usleep (Conf.Sleep);
#endif
}

void
Clock_up (void)
{
  out |= SCLK;
  outb (out, Conf.OUT_PORT);
#ifdef DEBUG
  usleep (Conf.Sleep);
#endif
}

void
Clock_down (void)
{
  out &= ~SCLK;
  outb (out, Conf.OUT_PORT);
#ifdef DEBUG
  usleep (Conf.Sleep);
#endif
}

void
CS_down (void)
{
  out &= ~CS;
  outb (out, Conf.OUT_PORT);	/* Postionnement de CS a 0 */
#ifdef DEBUG
  usleep (Conf.Sleep);
#endif
}

void
Control_init (unsigned c)
{
  unsigned i;
  for (i = 0; i < 19; i++)
    {
      out = (intch[c][i]);
      outb (out, Conf.OUT_PORT);

#ifdef DEBUG
      usleep (Conf.Sleep);
#endif

    }
}


/* Recup des data en entree sur ligne busy */
int
val_in (int c)
{
  int j;
  short in = 0;
  unsigned bit;
  CS_down ();
  for (j = ((CAN) - 1); j > -1; j--)  /*------->  12 coups d'horloges */
    {
      Clock_up ();
      bit = !(inb (IN_PORT) / 128 & (0x01));	/* Test du bit 11 /Busy et inversion */
      in |= (bit << j);
      Clock_down ();
    }
  return (in);
}


int
direct_in (int c)
{
  short in = 0;
  unsigned bit;
  bit = (inb (IN_PORT) / c & (0x01));
  in = bit;
  return (in);
}

/* Debug */
/* Affiche les valeurs de bit entrant depuis le CAN via BUSY */
void
Debug_in (void)
{
  int j, in, z, c = 0;
  float v;
  unsigned bit;
  FILE *lock;
  int r = 32;
  struct timeval tv1, tv2;
  struct timezone tz;
  struct timespec delai;
  lock = fopen (METEO_LOCK_FILE, "w");	/* verouillage de la LPT */
  fprintf (lock, "%d", getpid ());
  printf ("\n");
  violet ();
#ifdef French
  printf
    ("*** Affichage des bits recus depuis le port: %#x sur chacune des voies...\n",
     IN_PORT);
#endif
#ifdef English
  printf ("*** View every bit on port: %#x from every channel...\n", IN_PORT);
#endif
#ifdef Deutsch
  printf ("*** aktuel Sensor-Rohdaten ausgeben zu port: %#x...\n", IN_PORT);
#endif

  resetcouleur ();
  printf ("\n");
  gettimeofday (&tv1, &tz);
  violet ();
  printf ("*** MAX186 input port ***\n");
  resetcouleur ();
  if (Conf.C == 4)
    {
      blancvif ();
      printf ("--> No MAX186 input port avalaible <--\n");
      resetcouleur ();
    }

  for (c = 0; c < (Conf.C - 3); c++)
    {
      in = 0;
      Control_init (c);
      Sclk ();
      rouge ();
      printf ("Ch:%d ", c);
      resetcouleur ();
      cyan ();
      printf (" Bit%d->", CAN - 1);
      resetcouleur ();
      blancvif ();
      for (j = ((CAN) - 1); j > -1; j--)
	{
	  Clock_up ();
	  bit = !(inb (IN_PORT) / 128 & (0x01));	/* Test du bit 11 /Busy et inversion */
	  printf ("[%d]", bit);
	  in |= (bit << j);
	  Clock_down ();
	}
      cyan ();
      printf ("<-Bit0 ");
      resetcouleur ();
      printf (" Dec:");
      blancvif ();
      printf ("%4.3d ", in);
      v = (in * CAD);
      resetcouleur ();
      bleu ();
      printf ("Uvolts: ");
      resetcouleur ();
      jaune ();
      printf ("%4.3f", v);
      printf ("\n");
      resetcouleur ();
    }
  init ();
  resetcouleur ();
  c = (Conf.C - 3);
  printf ("\n");
  violet ();
  printf ("*** Direct input port LPT %#x ***\n", IN_PORT);
  resetcouleur ();
  rouge ();
  printf ("Ch:%d ", c);
  resetcouleur ();
  cyan ();
  printf (" Bit 5->");
  resetcouleur ();
  blancvif ();
  bit = (inb (IN_PORT) / r & (0x01));
  printf ("[%d]", bit);
  cyan ();
  printf ("<-/PAPER_OUT   Pin 12 LPT");
  resetcouleur ();
  jaune ();
  if (bit == 0)
    {
      printf ("  [Low]");
      resetcouleur ();
    }
  else
    {
      rouge ();
      printf ("  [Hight]");
      resetcouleur ();
    }
  printf ("\n");
  r = r - 16;
  c = c + 1;

  rouge ();
  printf ("Ch:%d ", c);
  resetcouleur ();
  cyan ();
  printf (" Bit 4->");
  resetcouleur ();
  blancvif ();
  bit = (inb (IN_PORT) / r & (0x01));
  printf ("[%d]", bit);
  cyan ();
  printf ("<-/SELECT      Pin 13 LPT");
  resetcouleur ();
  jaune ();
  if (bit == 0)
    {
      printf ("  [Low]");
      resetcouleur ();
    }
  else
    {
      rouge ();
      printf ("  [Hight]");
      resetcouleur ();
    }
  printf ("\n");
  r = r - 8;
  c = c + 1;

  rouge ();
  printf ("Ch:%d", c);
  resetcouleur ();
  cyan ();
  printf (" Bit 3->");
  resetcouleur ();
  blancvif ();
  bit = (inb (IN_PORT) / r & (0x01));
  printf ("[%d]", bit);
  cyan ();
  printf ("<-/ERROR       Pin 15 LPT");
  resetcouleur ();
  jaune ();
  if (bit == 0)
    {
      printf ("  [Low]");
      resetcouleur ();
    }
  else
    {
      rouge ();
      printf ("  [Hight]");
      resetcouleur ();
    }
  printf ("\n\n");
  /* Alarm */
  View_Alarm ();
  violet ();
  printf ("*** Allumage des LED Alarmes ***\n");
  resetcouleur ();
  delai.tv_sec = 0;
  delai.tv_nsec = 99999999;
  for (i = 0; i < 2; i++)
    {
      Alarms_up ();
      z = nanosleep (&delai, NULL);
      Alarm1_up ();
      z = nanosleep (&delai, NULL);
      Alarm2_up ();
      z = nanosleep (&delai, NULL);
      init_out2 ();
      z = nanosleep (&delai, NULL);
      Alarms_up ();
      z = nanosleep (&delai, NULL);
      init_out2 ();
      z = nanosleep (&delai, NULL);
    }

  /* display acquisition time */
  gettimeofday (&tv2, &tz);
  durees = (tv2.tv_sec - tv1.tv_sec);
  dureeus = (tv2.tv_usec - tv1.tv_usec);
  violetclair ();
  printf ("Acquisition time for %d channels: %ld uS -->", Conf.C,
	  (durees * 1000000L + dureeus));
  resetcouleur ();
  violet ();
  printf (" [%ld uS/Channel]\n", (durees * 1000000L + dureeus) / 8);
  resetcouleur ();
  remove (METEO_LOCK_FILE);	/* deverrouillage du port LPT */
  return;
}

int
explo (void)
{
  struct sched_param sp;
  int z, c = 0, val = 0;
  int fd, retval, irqcount, r = 32;
  unsigned long data;
  float v;
  compteur = tab[0][2][0][0];
  if (Conf.C > 3)
    {
      for (c = 0; c < (Conf.C - 3); c++)
	{
	  Control_init (c);
	  Sclk ();
	  val = val_in (c);	/* Routine de recuperation des bit sur busy */
	  v = (val * CAD);
	  tab[c][0][1][0] = val;	/* Valeur Inst */
	  tab[0][2][1][0] = val;
	  {
	    time_t t;
	    time (&t);
	    tab[c][1][1][0] = t;
	    tab[0][2][2][0] = t;
	  }
	  z = tab[c][0][0][0];
	  if (val >= z)		/* Test Valeur Max */
	    {
	      tab[c][0][0][0] = val;
	      {
		tab[c][1][0][0] = t;
	      }
	    }


	  if (val >= tab[c][0][0][1])		/* Test Valeur Crete */
	    {
	      tab[c][0][0][1] = val;
	      {
              tab[c][1][0][1] = t;	      
	      }
	    }


	  if (val <= tab[c][0][0][2])		/* Test Valeur Min */
	    {
	      tab[c][0][0][2] = val;
	      {
              tab[c][1][0][2] = t;	      
	      }
	    }



	  z = tab[c][0][2][0];
	  if (val <= z)		/* Test valeur Mini */
	    {
	      tab[c][0][2][0] = val;
	      {
		tab[c][1][2][0] = t;
	      }
	    }
	  tab[c][2][1][M - 1] = val;
	  tab[c][2][2][M - 1] = t;

	}
    }
  init ();

  // scan Direct LPT Bit 5, 4, 3 //

  // passage en priorite <<real time >> //
  sp.sched_priority = 60;
  sched_setscheduler (0, SCHED_FIFO, &sp);
  // programation du rtc a 64Hz //
  fd = open ("/dev/rtc", O_RDONLY);
  retval = ioctl (fd, RTC_IRQP_SET, 64);
  retval = ioctl (fd, RTC_PIE_ON, 0);

  for (c = Conf.C - 3; c < Conf.C; c++)
    {
      irqcount = 0;
      val = 0;

      while ((irqcount < 4))
	{
	  // on attend l'interruption suivante //
	  retval = read (fd, &data, sizeof (unsigned long));
	  irqcount++;
	  val = direct_in (r);

	  if (val == 1)
	    {
	      // compteur actuel durant la periode Conf.C (1 mn) 
	      tab[c][0][1][0] = (tab[c][0][1][0] + 1);	//Compteur actuel
	      tab[c][0][2][0] = (tab[c][0][2][0] + 1);	//Compteur 1H
	      tab[c][0][0][0] = (tab[c][0][0][0] + 1);	//compteur 24h
	      // compteur depuis 00h:00 (balise APRS) //
	      tab[0][2][0][c + 10] = (tab[0][2][0][c + 10] + 1);

	    }
	  irqcount = 5;
	}
      {
        // copy valeurs dans le tambour histo
	tab[c][2][1][M - 1] = tab[c][0][1][0];
	tab[c][2][2][M - 1] = t;
//	tab[c][1][1][0] = t;
//	tab[0][2][2][0] = t;
      }
      r = r / 2;
      val = 0;
    }

  retval = ioctl (fd, RTC_PIE_OFF, 0);
  close (fd);
  /* go out real time */
  sp.sched_priority = 0;
  if (sched_setscheduler (0, SCHED_OTHER, &sp) < 0)
    {
      perror ("Warning: sched_setscheduler");
    }

/*------------------------------------------------------------------------*/
  compteur = compteur + 1;	// Incrementation du compteur de mesures 
  tab[0][2][0][0]++;		// Mise a jour compteur    

//  tab[0][2][0][4] = tab[0][2][0][3];
//  tab[0][2][0][3] = tab[0][2][2][0];
  return 0;
}




 /*------------------------------ALARMES----------------------------------*/

void
Set_alarm ()
{

  if ((tab[0][2][0][9] = 0) == 0)
    {
      if ((strcasecmp (Alarms[0].Comp, ">") == 0)
	  && (Alarms[0].Channel < Conf.C - 3)
	  &&
	  ((((tab[Alarms[0].Channel][0][1][0] * CAD) -
	     capteurs[Alarms[0].Channel].Offset) /
	    capteurs[Alarms[0].Channel].Unites) > Alarms[0].Seuil))
	{
	  Alarm1_up ();
	}

      else if ((strcasecmp (Alarms[0].Comp, ">") == 0)
	       && (Alarms[0].Channel >= Conf.C - 3)
	       &&
	       ((tab[Alarms[0].Channel][0][1][0] *
		 capteurs[Alarms[0].Channel].Unites) > Alarms[0].Seuil))
	{
	  Alarm1_up ();
	}

      else if ((strcasecmp (Alarms[0].Comp, "<") == 0)
	       && (Alarms[0].Channel < Conf.C - 3)
	       &&
	       ((((tab[Alarms[0].Channel][0][1][0] * CAD) -
		  capteurs[Alarms[0].Channel].Offset) /
		 capteurs[Alarms[0].Channel].Unites) < Alarms[0].Seuil))

	{
	  Alarm1_up ();
	}

      else if ((strcasecmp (Alarms[0].Comp, "<") == 0)
	       && (Alarms[0].Channel >= Conf.C - 3)
	       &&
	       ((((tab[Alarms[0].Channel][0][1][0] *
		   capteurs[Alarms[0].Channel].Unites) < Alarms[0].Seuil))))
	{
	  Alarm1_up ();
	}

      else if ((strcasecmp (Alarms[0].Comp, "=") == 0)
	       && (Alarms[0].Channel < Conf.C - 3)
	       &&
	       ((((tab[Alarms[0].Channel][0][1][0] * CAD) -
		  capteurs[Alarms[0].Channel].Offset) /
		 capteurs[Alarms[0].Channel].Unites) == Alarms[0].Seuil))

	{
	  Alarm1_up ();
	}

      else if ((strcasecmp (Alarms[0].Comp, "=") == 0)
	       && (Alarms[0].Channel >= Conf.C - 3)
	       &&
	       (((tab[Alarms[0].Channel][0][1][0] *
		  capteurs[Alarms[0].Channel].Unites) == Alarms[0].Seuil)))
	{
	  Alarm1_up ();
	}

      else
	{
	  init_out2 ();
	}
    }

  if ((tab[0][2][0][9] = 0) == 1)
    {
      if ((strcasecmp (Alarms[0].Comp, ">") == 0)
	  && (Alarms[0].Channel < Conf.C - 3)
	  &&
	  ((((tab[Alarms[0].Channel][0][1][0] * CAD) -
	     capteurs[Alarms[0].Channel].Offset) /
	    capteurs[Alarms[0].Channel].Unites) > Alarms[0].Seuil))
	{
	  Alarms_up ();
	}

      else if ((strcasecmp (Alarms[0].Comp, ">") == 0)
	       && (Alarms[0].Channel >= Conf.C - 3)
	       &&
	       (((tab[Alarms[0].Channel][0][1][0] *
		  capteurs[Alarms[0].Channel].Unites) > Alarms[0].Seuil)))
	{
	  Alarms_up ();
	}

      else if ((strcasecmp (Alarms[0].Comp, "<") == 0)
	       && (Alarms[0].Channel < Conf.C - 3)
	       &&
	       ((((tab[Alarms[0].Channel][0][1][0] * CAD) -
		  capteurs[Alarms[0].Channel].Offset) /
		 capteurs[Alarms[0].Channel].Unites) < Alarms[0].Seuil))
	{
	  Alarms_up ();
	}

      else if ((strcasecmp (Alarms[0].Comp, "<") == 0)
	       && (Alarms[0].Channel >= Conf.C - 3)
	       &&
	       (((tab[Alarms[0].Channel][0][1][0] *
		  capteurs[Alarms[0].Channel].Unites) < Alarms[0].Seuil)))
	{
	  Alarms_up ();
	}

      else if ((strcasecmp (Alarms[0].Comp, "=") == 0)
	       &&
	       ((((tab[Alarms[0].Channel][0][1][0] * CAD) -
		  capteurs[Alarms[0].Channel].Offset)
		 / capteurs[Alarms[0].Channel].Unites) == Alarms[0].Seuil))
	{
	  Alarms_up ();
	}

      else if ((strcasecmp (Alarms[0].Comp, "=") == 0)
	       && (Alarms[0].Channel >= Conf.C - 3)
	       &&
	       (((tab[Alarms[0].Channel][0][1][0] *
		  capteurs[Alarms[0].Channel].Unites) == Alarms[0].Seuil)))
	{
	  Alarms_up ();
	}

      else
	{
	  Alarm2_up ();
	}
    }

  if (tab[0][2][0][8] == 0)
    {

      if ((strcasecmp (Alarms[1].Comp, ">") == 0)
	  && (Alarms[1].Channel < Conf.C - 3)
	  &&
	  ((((tab[Alarms[1].Channel][0][1][0] * CAD) -
	     capteurs[Alarms[1].Channel].Offset) /
	    capteurs[Alarms[1].Channel].Unites) > Alarms[1].Seuil))
	{
	  Alarm2_up ();
	}

      else if ((strcasecmp (Alarms[1].Comp, ">") == 0)
	       && (Alarms[1].Channel >= Conf.C - 3)
	       &&
	       (((tab[Alarms[1].Channel][0][1][0] *
		  capteurs[Alarms[1].Channel].Unites) > Alarms[1].Seuil)))
	{
	  Alarm2_up ();
	}

      else if ((strcasecmp (Alarms[1].Comp, "<") == 0)
	       && (Alarms[1].Channel < Conf.C - 3)
	       &&
	       ((((tab[Alarms[1].Channel][0][1][0] * CAD) -
		  capteurs[Alarms[1].Channel].Offset) /
		 capteurs[Alarms[1].Channel].Unites) < Alarms[1].Seuil))
	{
	  Alarm2_up ();
	}

      else if ((strcasecmp (Alarms[1].Comp, "<") == 0)
	       && (Alarms[1].Channel >= Conf.C - 3)
	       &&
	       (((tab[Alarms[1].Channel][0][1][0] *
		  capteurs[Alarms[1].Channel].Unites) < Alarms[1].Seuil)))
	{
	  Alarm2_up ();
	}

      else if ((strcasecmp (Alarms[1].Comp, "=") == 0)
	       && (Alarms[1].Channel < Conf.C - 3)
	       &&
	       ((((tab[Alarms[1].Channel][0][1][0] * CAD) -
		  capteurs[Alarms[1].Channel].Offset) /
		 capteurs[Alarms[1].Channel].Unites) == Alarms[1].Seuil))
	{
	  Alarm2_up ();
	}

      else if ((strcasecmp (Alarms[1].Comp, "=") == 0)
	       && (Alarms[1].Channel >= Conf.C - 3)
	       &&
	       (((tab[Alarms[1].Channel][0][1][0] *
		  capteurs[Alarms[1].Channel].Unites) == Alarms[1].Seuil)))
	{
	  Alarm2_up ();
	}


      else
	{
	  init_out2 ();
	}
    }

  if (tab[0][2][0][8] == 1)
    {
      if ((strcasecmp (Alarms[1].Comp, ">") == 0)
	  && (Alarms[1].Channel < Conf.C - 3)
	  &&
	  ((((tab[Alarms[1].Channel][0][1][0] * CAD) -
	     capteurs[Alarms[1].Channel].Offset) /
	    capteurs[Alarms[1].Channel].Unites) > Alarms[1].Seuil))
	{
	  Alarms_up ();
	}

      else if ((strcasecmp (Alarms[1].Comp, ">") == 0)
	       && (Alarms[1].Channel >= Conf.C - 3)
	       &&
	       (((tab[Alarms[1].Channel][0][1][0] *
		  capteurs[Alarms[1].Channel].Unites) > Alarms[1].Seuil)))
	{
	  Alarms_up ();
	}

      else if ((strcasecmp (Alarms[1].Comp, "<") == 0)
	       && (Alarms[1].Channel < Conf.C - 3)
	       &&
	       ((((tab[Alarms[1].Channel][0][1][0] * CAD) -
		  capteurs[Alarms[1].Channel].Offset) /
		 capteurs[Alarms[1].Channel].Unites) < Alarms[1].Seuil))
	{
	  Alarms_up ();
	}
      else if ((strcasecmp (Alarms[1].Comp, "<") == 0)
	       && (Alarms[1].Channel >= Conf.C - 3)
	       &&
	       (((tab[Alarms[1].Channel][0][1][0] *
		  capteurs[Alarms[1].Channel].Unites) < Alarms[1].Seuil)))
	{
	  Alarms_up ();
	}

      else if ((strcasecmp (Alarms[1].Comp, "=") == 0)
	       && (Alarms[1].Channel < Conf.C - 3)
	       &&
	       ((((tab[Alarms[1].Channel][0][1][0] * CAD) -
		  capteurs[Alarms[1].Channel].Offset) /
		 capteurs[Alarms[1].Channel].Unites) == Alarms[1].Seuil))
	{
	  Alarms_up ();
	}
      else if ((strcasecmp (Alarms[1].Comp, "=") == 0)
	       && (Alarms[1].Channel >= Conf.C - 3)
	       &&
	       (((tab[Alarms[1].Channel][0][1][0] *
		  capteurs[Alarms[1].Channel].Unites) == Alarms[1].Seuil)))
	{
	  Alarms_up ();
	}

      else
	{
	  Alarm1_up ();
	}
    }
  return;
}

// Fin alarms

  /* Mise a jour historique */
void
Maj_Histo (void)
{
  int c, j;
  for (c = 0; c < Conf.C; c++)
    {
      for (j = 1; j < M + 1; j++)
	{
	  tab[c][2][1][j - 1] = tab[c][2][1][j];
	  tab[c][2][2][j - 1] = tab[c][2][2][j];
	}
	tab[c][2][1][M-1] =0;
	tab[c][2][1][M]   =0;
    }
}

void
Arret (int signum)
{
  FILE *msg;
  time_t t;
  time (&t);
  msg = fopen (MSG_METEO_DATA_FILE, "a+");
  printf
    ("Arret exploration capteurs mise  jour fichiers.... End and update files...\n");
/*	maj_file(); rrd_upd() ;maj_html(); Maj_Histo(); meteograph(); Meteohist(); Meteoanhist();*/
  switch (signum)
    {
    case 2:
      fprintf (msg, "%s --> Arret par SIGINT Ctrl C [signal] %d\n",
	       ctime (&t), signum);
      rrd_upd ();
      maj_html ();
      Maj_Histo ();
      maj_file ();
      printf ("--> Arret par SIGINT Ctrl C [signal] %d\n", signum);
      remove (METEO_LOCK_FILE);
      break;
    case 3:
      fprintf (msg, "%s --> Arret par SIGQUIT Quit [signal] %d\n", ctime (&t),
	       signum);
      printf ("--> Arret par SIGQUIT Quit [signal] %d\n", signum);
      remove (METEO_LOCK_FILE);
      break;
    case 4:
      fprintf (msg, "%s --> Arret par SIGILL [signal] %d\n", ctime (&t),
	       signum);
      printf ("--> Arret par SIGILL [signal] %d\n", signum);
      remove (METEO_LOCK_FILE);
      break;
    case 8:
      fprintf (msg,
	       "%s --> Arret par SIGFPE (exeption virgule flottante) [signal] %d\n",
	       ctime (&t), signum);
      printf
	("--> Arret par SIGFPE (exeption virgule flottante) [signal] %d\n",
	 signum);
      remove (METEO_LOCK_FILE);
      break;
    case 9:
      rrd_upd ();
      maj_html ();
      Maj_Histo ();
      maj_file ();

      fprintf (msg, "%s --> Arret par SIGKILL [signal] %d\n", ctime (&t),
	       signum);
      printf ("--> Arret par SIGKILL [signal] %d\n", signum);
      remove (METEO_LOCK_FILE);
      break;
    case 11:
      fprintf (msg, "%s --> Arret par SIGSEGV [signal] %d\n", ctime (&t),
	       signum);
      printf ("--> Arret par SIGSEGV [signal] %d\n", signum);
      remove (METEO_LOCK_FILE);
      break;
    case 13:
      fprintf (msg,
	       "%s --> Arret par SIGPIPE Tube brise [signal] %d\n",
	       ctime (&t), signum);
      printf ("--> Arret par SIGPIPE Tube brise [signal] %d\n", signum);
      remove (METEO_LOCK_FILE);
      break;
/*
	case 14:
	        fprintf(msg, "%s --> Arret par SIGALRM [signal] %d\n",ctime(&t),signum);
	        maj_file(); rrd_upd() ;maj_html(); Maj_Histo(); meteograph(); Meteohist(); Meteoanhist();
		printf("--> Arret par SIGALRM [signal] %d\n",signum);		
		remove(METEO_LOCK_FILE);
		break;
*/
    case 15:
      rrd_upd ();
      maj_html ();
      Maj_Histo ();
      maj_file ();

      fprintf (msg, "%s --> Arret par Kill [signal] %d\n", ctime (&t),
	       signum);
      printf ("--> Arret par Kill [signal] %d\n", signum);
      remove (METEO_LOCK_FILE);
      break;
    default:
      rrd_upd ();
      maj_html ();
      Maj_Histo ();
      maj_file ();

      fprintf (msg, "%s --> Arret anormal [signal] %d\n", ctime (&t), signum);
      printf ("--> Arret anormal [signal] %d\n", signum);
      remove (METEO_LOCK_FILE);
      break;
    }
  remove (METEO_LOCK_FILE);
  fclose (msg);
  Clr_scr ();
  printf ("Session meteo termin ! / meteo ended !\n");
  exit (0);
  return;
}

void
graphtimer (int i)
{
  FILE *msg;
  int c;
  msg = fopen (MSG_METEO_DATA_FILE, "a+");

  {
    time_t t;
    time (&t);
  }

// TOUTES LES MN
  Set_alarm ();
  rrd_upd ();
  Maj_Histo ();
   
  for (c = 0 ; c < Conf.C-3; c++)
    {
      // raz valeur crete
      tab[c][0][0][1] = 0;

      // raz valeur Min
      tab[c][0][0][2] = 4096;


    }

  // attention touts les capteurs ou que direct lpt ?
  for (c = Conf.C-3 ; c < Conf.C; c++)
    {
      // raz valeur crete
      tab[c][0][0][1] = 0;
      // raz cumul 1mnm
      tab[c][0][1][0] = 0;
      // raz valeur cumul 24h
      tab[c][0][0][0] = 0;
      // raz valeur cumul 1h
      tab[c][0][2][0] = 0; 
      // cumul sur 24h
      for (i = M - 1; i > 0; i--)	// m-1 pour ne pas reprendre la valeur inst
	{
	  tab[c][0][0][0] = tab[c][0][0][0] + tab[c][2][1][i];
	}
      // cumul sur 1h
      for (i = M - 1; i > (M-1)-60; i--)	// m-1 pour ne pas reprendre la valeur inst
	{
	  tab[c][0][2][0] = tab[c][0][2][0] + tab[c][2][1][i];
	}

    }
  tab[0][2][0][5] = tab[0][2][0][5] + 1;
  maj_file ();

  for (c = 0; c < Conf.C - 3; c++)
    {
      if (strcasecmp (capteurs[c].Unite, "hPa") == 0)
	{
	  Tendance ();
	}
    }

// Test every 10mn //
  if (tb->tm_min % (Conf.Mn * 10) == 0)
    {
      txt_upd ();
      meteograph ();
      allsensor_html();
      maj_html ();
      // si pas de Digi pas de balise APRS 
      if ((strcasecmp (Conf.Digi[0], "none") != 0)
	  && (strcasecmp (Conf.Digi[1], "none") != 0))
	{
	  Aprs ();
	}
//	 fprintf (msg, "%s --> test 10 mn \n", ctime (&t));
    }

  /* Test minuit 00:00 raz Tab[0][2][0][5] */
  if ((tb->tm_hour == 0) && (tb->tm_min < (Conf.Mn * 2)))
    {
      Conf_html ();
      Index_html ();
      maj_menu ();
      Meteohist ();
      Meteoanhist ();

      for (c = Conf.C - 3; c < Conf.C; c++)
	{
	  tab[0][2][0][c + 10] = 0;
	}
      if ((tb->tm_mday == 1) && (tb->tm_mon + 1 == 1))
	{
	  get_year ();	// on cree un nouveau fichier rrd pour l'annee
	}
//      fprintf (msg, "%s --> test minuit 0h \n", ctime (&t));
    }

  /* Test 2h00 pour graph mois & an */
  if ((tb->tm_hour == 2) && (tb->tm_min < (Conf.Mn * 2)))
    {
      Conf_html ();
      Index_html ();
      logo_html ();
      maj_menu ();
      Meteohist ();
      Meteoanhist ();
//      fprintf (msg, "%s --> maj graph mois & an a 02h \n", ctime (&t));
    }

  fclose (msg);

}

void
Boucle_Explo (void)
{
  struct itimerval timer;
  struct timeval tv1;
  struct timezone tz;
  FILE *lock;
  memset (&timer, (char) 0, sizeof (timer));
  timer.it_interval.tv_sec = (Conf.Mn * 60);
  timer.it_interval.tv_usec = 0;
  timer.it_value.tv_sec = (Conf.Mn * 60);
  timer.it_value.tv_usec = 0;
  lock = fopen (METEO_LOCK_FILE, "w");
  setitimer (ITIMER_REAL, &timer, 0);
  fprintf (lock, "%d", getpid ());
  fclose (lock);
  while (1)
    {
      gettimeofday (&tv1, &tz);
      {
	t = time (NULL);
	tb = localtime (&t);
      }
      explo ();
      Clr_scr ();
      rouge ();
      Entete ();
      resetcouleur ();
#ifdef French
      printf ("Date systme: %s %d %s %d %2.2d:%2.2d ",
	      Jours[tb->tm_wday], tb->tm_mday,
	      Mois[tb->tm_mon], tb->tm_year + 1900, tb->tm_hour, tb->tm_min);
#endif
#ifdef English
      printf ("System date: %s %d %s %d %2.2d:%2.2d ",
	      Jours[tb->tm_wday], tb->tm_mday,
	      Mois[tb->tm_mon], tb->tm_year + 1900, tb->tm_hour, tb->tm_min);
#endif
#ifdef Deutsch
      printf ("System date: %s %d %s %d %2.2d:%2.2d ",
	      Jours[tb->tm_wday], tb->tm_mday,
	      Mois[tb->tm_mon], tb->tm_year + 1900, tb->tm_hour, tb->tm_min);
#endif

      cligncyan ();
      printf ("\n");
      printf (tendance = Tendance ());
      printf ("\n");
      resetcouleur ();

      if ((param[1] == 120) || (param[1] == 88))
	{
	  printf
	    ("Faire Ctrl C pour stopper le process / Ctrl C to stop process.\n");
	}
      jaune ();
      Print_Analog ();
      resetcouleur ();
      bleu ();
      Print_Compteur ();
      resetcouleur ();
      signal (SIGINT, Arret);
      signal (SIGQUIT, Arret);
      signal (SIGILL, Arret);
      signal (SIGFPE, Arret);
      signal (SIGKILL, Arret);
      signal (SIGSEGV, Arret);
      signal (SIGPIPE, Arret);
      signal (SIGTERM, Arret);
      signal (SIGABRT, Arret);
/*	signal (SIGALRM, Arret );	*/
      signal (SIGSTOP, Arret);
    }
}
